	function Activity() {
		/* Object for the Activity Screen */
		this.item = null;
		this.event = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Activity.prototype.initialize = function() {
		browsr.screen = SCREEN_ACTIVITY;
		
		this.scroll = new Scroll();		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		/*
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		*/
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	Activity.prototype.destroy = function() {
		flickr.purge_all();
		
		this.item = null;
		this.event = null;
			
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	Activity.prototype.resize = function() {
		this.scroll.resize();
	}
	
	Activity.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				break;
		}
	}
	
	Activity.prototype.keyEnter = function() {
		if(this.item)
		{
			if(this.item.type == 'photo')
			{
				var params = [];
				var tphoto = [];
				tphoto["id"] = this.item.id;
				tphoto["farm"] = this.item.farm;
				tphoto["secret"] = this.item.secret;
				tphoto["server"] = this.item.server;
				tphoto["owner"] = this.item.owner;
				tphoto["ownername"] = this.item.ownername;
				tphoto["title"] = this.item.title._content;
				
				params["photo"] = tphoto;
				params["user_id"] = this.item.owner;
				
				var ttitle = '';
				if(this.item.title._content)
					ttitle = this.item.title._content;
				else
					ttitle = '(untitled)';
					
				var photo_url = flickr.build_photo_url(this.item.farm, this.item.server, this.item.id, this.item.secret, PHOTO_S);
					
				this.destroy();
				
				browsr.addEvent('Photo: ' + ttitle, photo.show, params, 0, photo_url, 'photoframe');
				photo.show(params);
				params = null;
			}
			else if(this.item.type == 'photoset')
			{
				var params = [];
				var tset = [];
				tset["id"] = this.item.id;
				tset["farm"] = this.item.farm;
				tset["secret"] = this.item.secret;
				tset["server"] = this.item.server;
				tset["primary"] = this.item.primary;
				tset["title"] = this.item.title._content;
				
				params["set"] = tset;
				
				var ttitle = '';
				if(this.item.title._content)
					ttitle = this.item.title._content;
				else
					ttitle = '(untitled)';
					
				var photo_url = flickr.build_photo_url(this.item.farm, this.item.server, this.item.id, this.item.secret, PHOTO_S);
					
				this.destroy();
				
				browsr.addEvent('Set: ' + ttitle, set.show, params, 0, photo_url, 'photoframe');
				set.show(params);
				params = null;
			}
		}
	}
	
	Activity.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
	}
	
	Activity.prototype.show = function(params) {
	
		if(params == null)
		{
			params["item"] = null;
			params["event"] = null;
		}
		
		if((params["item"] == undefined) || (params["item"] == null))
		{
			params["item"] = null;
		}
		
		if((params["event"] == undefined) || (params["event"] == null))
		{
			params["event"] = null;
		}
			
		activity.item = params["item"];
		activity.event = params["event"];
		activity.initialize();
		
		if((activity.item != null) && (activity.event != null))
		{
			if(activity.item.title && activity.item.title._content)
				Helper.setTitle(activity.item.title._content + '\'s recent activity');
			else
				Helper.setTitle('(untitled)' + '\'s recent activity');
			
			activity.displayActivity();
		}
	}
	
	Activity.prototype.displayActivity = function () {
				
		var photo_url = null;
		
		var titem = this.item;
		
		if(titem.type == 'photo')
			photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.id, titem.secret, PHOTO_S);
		else if(titem.type == 'photoset')
			photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.primary, titem.secret, PHOTO_S);
			
		var title = '';
		
		if(titem.title && titem.title._content)
			title = titem.title._content;
		else
			title = '(untitled)';
		
		var div = this.getHeader(0, title, 'Recent Activity', photo_url, 'photoframe');
		var divCnt = Helper.getDescriptionContainer(0);
		var cnt = Helper.getDescriptionContent(divCnt);
		
		var tevent = activity.event;
		var text = null;
		
		var htext = tevent.username;
			
		if(tevent.type == 'comment')
			htext = htext + ' commented: ';
		else if(tevent.type == 'note')
			htext = htext + ' added a note: ';
		else if(tevent.type == 'tag')
			htext = htext + ' added a tag: ';
		else if(tevent.type == 'fave')
			htext = htext + ' added as favorite!';
			
		if(tevent.type != 'fave')
			text = htext + '<br><br>' + tevent._content;
		else
			text = htext;
			
		/* Stripping off a tags */
		var a_re = new RegExp('<\s*\/?\s*a\s*.*?>', 'g');
		text = text.replace(a_re, "");
		
		var nl_re = new RegExp('\\n', 'g');
		text = text.replace(nl_re, '<br>');
		
		cnt.innerHTML = '<p class=\'roundcont small\'>' + text +'</p>';
		
		var p = cnt.getElementsByTagName('p');
		for(i=0; i<p.length; i++){}
		
		/* already stripped it */
		var a = cnt.getElementsByTagName('a');
		
		/* resizing images */
		var img = cnt.getElementsByTagName('img');
		
		for(i=0; i<img.length; i++)
		{
			img[i].onload = this.imageResize(img[i]);
			img[i].className = 'clear roundcont';
		}
		
		div.appendChild(divCnt);
		this.scroll.add(div);
		
		/* Post processing */
		Helper.checkEllipsis($('title_p'), $('title_div').clientWidth, 20);
		Helper.checkEllipsis($('subtitle_p'), $('subtitle_div').clientWidth, 20);
		
		this.resize();
		this.scroll.updateScrollbar();
		this.updateMenus();
	}
	
	Activity.prototype.imageResize = function(img) {
		h = img.height;
		w = img.width;
		
		if((h >= w) && (h > 150))
		{
			img.style.height = '150px';
			img.style.width = ((150/h) * w) + 'px';
		}
		else if(w > 150)
		{
			img.style.width = '150px';
			img.style.height = ((150/w) * h) + 'px';
		}
		
		activity.resize();
		activity.scroll.updateScrollbar();
	}
	
	Activity.prototype.getHeader = function(id, title, subtitle, photo_url, img_type) {
		var divComArea = Helper.getDiv('description_area', 'description_area');
		var divTabCom = Helper.getDiv('tab_af_' + id, 'activity_h');
		var divTComHeader = Helper.getDiv('tab_af_header_' + id, 'description_header');
		var tableTComHeader = Helper.getTable(null, null);
		
		/* First row in Helper */
		var trHUp = Helper.getTr(null, null);
		var tdHUpLEdge = Helper.getTd(null, 'edge');
		var divHUpLEdge = Helper.getDiv(null, 'up left');
		
		var tdHUpIcon = Helper.getTd(null, 'icon');
		tdHUpIcon.setAttribute('rowspan', '2');
		var divHUpIcon = Helper.getDiv(null, null);
		var divIcon = null;
		var imgIcon = null;
		
		if(img_type == 'icon')
		{
			divIcon = Helper.getDiv('description_icon_div', 'icon');
			imgIcon = Helper.getImg('description_icon', null, photo_url);
		}
		else
		{
			divIcon = Helper.getDiv('description_icon_div', 'photoframe');
			imgIcon = Helper.getImg('description_icon', 'photo', photo_url);
		}
		
		var tdHUpText = Helper.getTd(null, 'text');
		var divHUpText = Helper.getDiv('title_div', 'up');
		var pTitle = Helper.getP('title_p', null, title);
		pTitle.origText = '' + title;
		
		var tdHUpREdge = Helper.getTd(null, 'edge');
		var divHUpREdge = Helper.getDiv(null, 'up right');
		
		tdHUpLEdge.appendChild(divHUpLEdge);
		
		divIcon.appendChild(imgIcon);
		divHUpIcon.appendChild(divIcon);
		tdHUpIcon.appendChild(divHUpIcon);
		
		divHUpText.appendChild(pTitle);
		tdHUpText.appendChild(divHUpText);
		
		tdHUpREdge.appendChild(divHUpREdge);
		
		trHUp.appendChild(tdHUpIcon);
		trHUp.appendChild(tdHUpLEdge);
		trHUp.appendChild(tdHUpText);
		trHUp.appendChild(tdHUpREdge);
		
		
		/* Second row in Helper */
		var trHDown = Helper.getTr(null, null);
		var tdHDownLEdge = Helper.getTd(null, 'edge');
		var divHDownLEdge = Helper.getDiv(null, 'down left');
		
		var tdHDownText = Helper.getTd(null, 'text');
		var divHDownText = Helper.getDiv('subtitle_div', 'down');
		var pSubtitle = Helper.getP('subtitle_p', null, subtitle);
		pSubtitle.origText = '' + subtitle;
		
		var tdHDownREdge = Helper.getTd(null, 'edge');
		var divHDownREdge = Helper.getDiv(null, 'down right');
		
		tdHDownLEdge.appendChild(divHDownLEdge);
		
		divHDownText.appendChild(pSubtitle);
		tdHDownText.appendChild(divHDownText);
		
		tdHDownREdge.appendChild(divHDownREdge);
		
		trHDown.appendChild(tdHDownLEdge);
		trHDown.appendChild(tdHDownText);
		trHDown.appendChild(tdHDownREdge);
		
		
		tableTComHeader.appendChild(trHUp);
		tableTComHeader.appendChild(trHDown);
		
		divTComHeader.appendChild(tableTComHeader);
		divTabCom.appendChild(divTComHeader);
		divComArea.appendChild(divTabCom);
		
		divComArea.addEventListener('click', function() {
			browsr.screens[browsr.screen].keyEnter();
		}, false);
		
		return divComArea;
	}
	
	
	
	
	
	
	
	
	
	
	