	/* Defines the class for Bmarks */
	function Bmarks() {
		this.photos = [];
		this.contacts = [];
		this.sets = [];
	}
	
	Bmarks.prototype.loadBmarks = function() {
		/* Get the count from the widget */
		
		if(bmarks && wkey('BP_COUNT'))
		{
			/* photos */
			var pcount = parseInt(wkey('BP_COUNT'));
			
			for(var i=0; i<pcount; i++)
			{
				var tphoto_id = wkey('BP_ID_' + i);
				var tphoto_title = wkey('BP_TITLE_' + i);
				bmarks.photos.push( {id:tphoto_id, title:tphoto_title} );
			}
			
			/* contacts */
			var ccount = parseInt(wkey('BC_COUNT'));
			
			for(var i=0; i<ccount; i++)
			{
				var tcontact_id = wkey('BC_ID_' + i);
				var tcontact_name = wkey('BC_NAME_' + i);
				bmarks.contacts.push( {id:tcontact_id, name:tcontact_name} );
			}
			
			/* sets */
			var scount = parseInt(wkey('BS_COUNT'));
			
			for(var i=0; i<scount; i++)
			{
				var tset_id = wkey('BS_ID_' + i);
				var tset_name = wkey('BS_TITLE_' + i);
				bmarks.sets.push( {id:tset_id, title:tset_name} );
			}
		}
		else
		{
			/* initialise */
			wsetKey('0', 'BP_COUNT');
			wsetKey('0', 'BC_COUNT');
			wsetKey('0', 'BS_COUNT');
		}
	}
	
	Bmarks.prototype.addPhotoToBmarks = function(tphoto) {
		/* Check if the bookmark already exists - if its not there.. add it */
		if(bmarks)
		{
			var pcount = parseInt(wkey('BP_COUNT'));
			
			wsetKey(tphoto.id,    ('BP_ID_' + pcount));
			wsetKey(tphoto.title, ('BP_TITLE_' + pcount));
			wsetKey((pcount + 1), 'BP_COUNT');
			
			this.photos.push(tphoto);
			
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
		}
	}
	
	Bmarks.prototype.removePhotoFromBmarks = function(tid) {
		/* Find the array element having this particular id and remove it */
		if(bmarks)
		{
			for(var i=0; i<bmarks.photos.length; i++)
			{
				if(bmarks.photos[i].id == tid)
					break;
			}
			
			if(i != bmarks.photos.length)
			{
				bmarks.photos.splice(i, 1);			
				
				wsetKey(null, ('BP_ID_' + i));
				wsetKey(null, ('BP_TITLE_' + i));
				
				for(var j=i+1; j<=bmarks.photos.length; j++)
				{
					var bpid = wkey(('BP_ID_' + j));
					wsetKey(bpid, ('BP_ID_' + (j-1)));
					
					var bptitle = wkey(('BP_TITLE_' + j));
					wsetKey(bptitle, ('BP_TITLE_' + (j-1)));
				}
				
				wsetKey(bmarks.photos.length, 'BP_COUNT');
			}
			
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
		}
	}
	
	Bmarks.prototype.findPhotoInBmarks = function(tid) {
		
		if(bmarks)
		{
			for(var i=0; i < bmarks.photos.length; i++)
			{
				if(bmarks.photos[i].id == tid)
					return true;
			}
		}
		
		return false;
	}
	
	Bmarks.prototype.addContactToBmarks = function(tcontact) {
		/* Check if the bookmark already exists - if its not there.. add it */
		if(bmarks)
		{
			var ccount = parseInt(wkey('BC_COUNT'));
			
			wsetKey(tcontact.id,    ('BC_ID_' + ccount));
			wsetKey(tcontact.name, ('BC_NAME_' + ccount));
			wsetKey((ccount + 1), 'BC_COUNT');
			
			this.contacts.push(tcontact);
			
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
		}
	}
	
	Bmarks.prototype.removeContactFromBmarks = function(tid) {
		/* Find the array element having this particular id and remove it */
		
		if(bmarks)
		{
			for(var i=0; i<bmarks.contacts.length; i++)
			{
				if(bmarks.contacts[i].id == tid)
					break;
			}
			
			if(i != bmarks.contacts.length)
			{
				bmarks.contacts.splice(i, 1);			
				
				wsetKey(null, ('BC_ID_' + i));
				wsetKey(null, ('BC_NAME_' + i));
				
				for(var j=i+1; j<=bmarks.contacts.length; j++)
				{
					var bcid = wkey(('BC_ID_' + j));
					wsetKey(bcid, ('BC_ID_' + (j-1)));
					
					var bcname = wkey(('BC_NAME_' + j));
					wsetKey(bcname, ('BC_NAME_' + (j-1)));
				}
				
				wsetKey(bmarks.contacts.length, 'BC_COUNT');
			}
			
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
		}
	}
	
	Bmarks.prototype.findContactInBmarks = function(tid) {
		
		if(bmarks)
		{
			for(var i=0; i < bmarks.contacts.length; i++)
			{
				if(bmarks.contacts[i].id == tid)
					return true;
			}
		}
		
		return false;
	}

	Bmarks.prototype.addSetToBmarks = function(tset) {
		/* Check if the bookmark already exists - if its not there.. add it */
		if(bmarks)
		{
			var scount = parseInt(wkey('BS_COUNT'));
			
			wsetKey(tset.id,    ('BS_ID_' + scount));
			wsetKey(tset.title, ('BS_TITLE_' + scount));
			wsetKey((scount + 1), 'BS_COUNT');
			
			this.sets.push(tset);
			
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
		}
	}
	
	Bmarks.prototype.removeSetFromBmarks = function(tid) {
		/* Find the array element having this particular id and remove it */
		
		if(bmarks)
		{
			for(var i=0; i<bmarks.sets.length; i++)
			{
				if(bmarks.sets[i].id == tid)
					break;
			}
			
			if(i != bmarks.sets.length)
			{
				bmarks.sets.splice(i, 1);			
				
				wsetKey(null, ('BS_ID_' + i));
				wsetKey(null, ('BS_TITLE_' + i));
				
				for(var j=i+1; j<=bmarks.sets.length; j++)
				{
					var bsid = wkey(('BS_ID_' + j));
					wsetKey(bsid, ('BS_ID_' + (j-1)));
					
					var bstitle = wkey(('BS_TITLE_' + j));
					wsetKey(bstitle, ('BS_TITLE_' + (j-1)));
				}
				
				wsetKey(bmarks.sets.length, 'BS_COUNT');
				
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
	}
	
	Bmarks.prototype.findSetInBmarks = function(tid) {
		
		if(bmarks)
		{
			for(var i=0; i < bmarks.sets.length; i++)
			{
				if(bmarks.sets[i].id == tid)
					return true;
			}
		}
		return false;
	}	
	
	
	
	
	
