	function BookmarksMenu() {
		/* Object for the BookmarksMenu Screen */
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	BookmarksMenu.prototype.initialize = function() {
		browsr.screen = SCREEN_BOOKMARKS_MENU;
		
		this.elements = tabs_bookmarksmenu;
		Helper.initialize(this);
		
		this.tabber = new Tabber();
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	BookmarksMenu.prototype.destroy = function() {
		flickr.purge_all();
		
		this.lindex = 0;
		this.elements = null;
		
		Helper.destroy(this);
	}
	
	BookmarksMenu.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	BookmarksMenu.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	BookmarksMenu.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
		
		switch(sindex)
		{
			case BOOKMARKSMENU_IDX_PHOTOS:
				/* photos */
				var params = [];
				
				this.destroy();
				
				browsr.addEvent('Bookmarks - Photos', bookmarks.showByPhotos, params, sindex, bookmarksPhotosImage, 'icon');
				bookmarks.showByPhotos(params);
				params = null;
				break;
				
			case BOOKMARKSMENU_IDX_CONTACTS:
				/* contacts */
				var params = [];
				
				this.destroy();
				
				browsr.addEvent('Bookmarks - Contacts', bookmarks.showByContacts, params, sindex, bookmarksContactsImage, 'icon');
				bookmarks.showByContacts(params);
				params = null;
				break;
				
			case BOOKMARKSMENU_IDX_SETS:
				/* sets */
				var params = [];
				
				this.destroy();
				
				browsr.addEvent('Bookmarks - Sets', bookmarks.showBySets, params, sindex, bookmarksSetsImage, 'icon');
				bookmarks.showBySets(params);
				params = null;
				break;
		}
	}
	
	BookmarksMenu.prototype.showInBrowser = function() {
		/* TODO: Remove this */
	}
	
	BookmarksMenu.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	BookmarksMenu.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	BookmarksMenu.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	BookmarksMenu.prototype.show = function(params) {
		
		bookmarksmenu.initialize();
		
		if(bmarks)
		{
			Helper.setTitle('Bookmarks');
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				bookmarksmenu.lindex = params["sindex"];
			
			if(Helper.isListMode())
				bookmarksmenu.displayList();
			else
				bookmarksmenu.displayTab();
				
			bookmarksmenu.updateMenus();
		}
		else
		{
			bookmarksmenu.selector = null;
			var div = Helper.displayNoType('No bookmarks found!');
			bookmarksmenu.scroll.add(div);
			bookmarksmenu.updateMenus();
		}
	}
	
	BookmarksMenu.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	BookmarksMenu.prototype.displayTab = function() {
		Helper.displayTab(this, 'Bookmarks');
		
		this.auto_disp_tid = setTimeout( function() { bookmarksmenu.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	BookmarksMenu.prototype.autoFetch = function() {
		if(bmarks)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case BOOKMARKSMENU_IDX_PHOTOS:
					/* photos */
					if(bmarks.photos && bmarks.photos.length)
					{
						var thead = bmarks.photos.length + ' photos available!';
						var tlist = [];
						
						for(var i=0; (i < bmarks.photos.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
						{
							if(bmarks.photos[i].title != '(untitled)')
								tlist[tlist.length] = bmarks.photos[i].title;
						}
						Helper.setAFTextListHeader(sindex, thead, tlist);
					}
					else
						Helper.setAFNoResult(sindex, 'No photos available!');
					break;
					
				case BOOKMARKSMENU_IDX_CONTACTS:
					/* contacts */
					if(bmarks.contacts && bmarks.contacts.length)
					{
						var thead = bmarks.contacts.length + ' contacts available!';
						var tlist = [];
						
						for(var i=0; (i < bmarks.contacts.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
						{
							tlist[i] = bmarks.contacts[i].name;
						}
						Helper.setAFTextListHeader(sindex, thead, tlist);
					}
					else
						Helper.setAFNoResult(sindex, 'No contacts available!');
					break;
					
				case BOOKMARKSMENU_IDX_SETS:
					/* sets */
					if(bmarks.sets && bmarks.sets.length)
					{
						var thead = bmarks.sets.length + ' sets available!';
						var tlist = [];
						
						for(var i=0; (i < bmarks.sets.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
						{
							if(bmarks.sets[i].title != '(untitled)')
								tlist[tlist.length] = bmarks.sets[i].title;
						}
						Helper.setAFTextListHeader(sindex, thead, tlist);
					}
					else
						Helper.setAFNoResult(sindex, 'No sets available!');
					break;
			}
		}
	}
	
	
	
	
	
	
	
	
	
	