	function Collection() {
		/* Object for the Collection Screen */
		this.collection = null;
		this.user =  null;
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;

	}
		
	Collection.prototype.initialize = function() {
		browsr.screen = SCREEN_COLLECTION;
		
		this.elements = tabs_collection;
		Helper.initialize(this);

		Helper.initTabber(this);

		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Collection.prototype.destroy = function() {
		flickr.purge_all();
		
		this.collection = null;
		this.user = null;
		this.lindex = 0;
		this.tabs = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
	}
	
	Collection.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Collection.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	Collection.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
		
		switch(sindex)
		{
			case COLLECTION_IDX_ITEMS:
				/* items */
				var params = [];
				params["collection"] = this.collection;
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["collection"].title + '\'s Items', collections.showByCollection, params, sindex, collectionsImage, 'icon');
				collections.showByCollection(params);
				params = null;
				break;
			
			case COLLECTION_IDX_DESCRIPTION:
				/* description */
				var params = [];
				params["collection"] = this.collection;
				
				this.destroy();
				
				browsr.addEvent(params["collection"].title + '\'s Description', description.showByCollection, params, sindex, descriptionImage, 'icon');
				description.showByCollection(params);
				params = null;
				break;
		}
	}
	
	Collection.prototype.showInBrowser = function() {
		if(this.user && this.collection)
		{
			var url = 'http://www.flickr.com/photos/' + this.user.user_nsid + '/collections/' + this.collection.id + '/';
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Collection.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Collection.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Collection.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Collection.prototype.show = function(params) {
	
		if(params == null)
		{
			params["collection"] = null;
			params["user"] = user;
		}
		else if((params["collection"] == undefined) || (params["collection"] == null))
		{
			params["collection"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
		{
			params["user"] = user;
		}
		
		collection.initialize();
		
		collection.collection = params["collection"];
		collection.user = params["user"];
		
		if(collection.collection != null)
		{
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				collection.lindex = params["sindex"];
			
			/* Shoud collection - collection's title here */
			Helper.setTitle('Collection: ' + collection.collection.title);
			
			if(Helper.isListMode())
				collection.displayList();
			else
				collection.displayTab();
			
			collection.updateMenus();
		}
	}
	
	Collection.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Collection.prototype.displayTab = function() {
		
		var ttitle = 'Collection: ' + this.collection.title;
		
		Helper.displayTab(this, ttitle);
			
		this.auto_disp_tid = setTimeout( function() { collection.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Collection.prototype.autoFetch = function() {
		if(this.collection)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case COLLECTION_IDX_ITEMS:
					/* items */
						
					var tchild = null;
					
					if(this.collection.collection)
					{
						/* collection */
						tchild = this.collection.collection;
						
						Helper.destroyDescendants($('autof_elt_' + sindex));
						var photo_url = [];
						for(var i=0; (i < tchild.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
						{
							photo_url[i] = tchild[i].iconsmall;
						}
						
						Helper.setAFPhotoList(sindex, photo_url, 'large');
						this.resize();
						this.scroll.updateScrollbar();
					}
					else
					{
						/* set */
						tchild = this.collection.set;
						
						Helper.destroyDescendants($('autof_elt_' + sindex));
						for(var i=0; (i < tchild.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
						{
							/* Send requests */
							flickr.photosets_getInfo(user.token, tchild[i].id, this.hrSets, PRI_HIGH);
						}
					}
					break;
					
				case COLLECTION_IDX_DESCRIPTION:
					/* description */
					var text = this.collection.description;
						
					if(text.length > MAX_AF_TEXT_LENGTH)
					{
						text = text.substr(0, MAX_AF_TEXT_LENGTH);
						text = text + '...';
					}
					
					if(text != '')
						Helper.setAFText(sindex, text);
					else
						Helper.setAFNoResult(sindex, 'No description available!');
						
					this.resize();
					this.scroll.updateScrollbar();
					break;
			}
		}
	}
	
	Collection.prototype.hrSets = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(collection)
				{
					var sindex = Helper.getSindex(collection);
					
					if(sindex == COLLECTION_IDX_ITEMS)
					{
						if(rsp.photoset)
						{
							var tset = rsp.photoset;
							var photo_url = flickr.build_photo_url(tset.farm, tset.server, tset.primary, tset.secret, PHOTO_S);
							rsp = null;
							
							var img = Helper.getAFLargePhoto(photo_url);
							$('autof_elt_' + sindex).appendChild(img);
							
							Helper.showAutoFetch(sindex);
							collection.resize();
							collection.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	