	function Comment() {
		/* Object for the Comment Screen */
		this.comment = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Comment.prototype.initialize = function() {
		browsr.screen = SCREEN_COMMENT;
		
		this.scroll = new Scroll();		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		/*
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		*/
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	Comment.prototype.destroy = function() {
		flickr.purge_all();
		
		this.comment = null;
			
		/* TODO : Verify */
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	Comment.prototype.resize = function() {
		this.scroll.resize();
	}
	
	Comment.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				break;
		}
	}
	
	Comment.prototype.keyEnter = function() {
		if(this.comment)
		{
			var params = [];
			var tuser = new User();
			tuser.user_nsid = this.comment.author;
			tuser.username = this.comment.authorname;
			
			params["user"] = tuser;
				
			this.destroy();
			
			browsr.addEvent(tuser.username, contact.show, params, 0, contactImage, 'icon');
			contact.show(params);
			params = null;
		}
	}
	
	Comment.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
	}
	
	Comment.prototype.show = function(params) {
	
		if(params == null)
			params["comment"] = null;
		else if((params["comment"] == undefined) || (params["comment"] == null))
			params["comment"] = null;
			
		comment.comment = params["comment"];
		comment.initialize();
		
		if(comment.comment != null)
		{
			Helper.setTitle(comment.comment.authorname + ' says');
			
			if(comment.comment._content != '')
				comment.displayComment(comment.comment._content);
			else
				comment.displayNoComment();
		}
	}
	
	Comment.prototype.displayComment = function (text) {
		var div = this.getHeader(0, this.comment.authorname, 'says', null, 'contactframe');
		var divCnt = Helper.getCommentContainer(0);
		var cnt = Helper.getCommentContent(divCnt);
		
		/* Stripping off a tags */
		var a_re = new RegExp('<\s*\/?\s*a\s*.*?>', 'g');
		text = text.replace(a_re, "");
		
		var nl_re = new RegExp('\\n', 'g');
		text = text.replace(nl_re, '<br>');
		
		cnt.innerHTML = '<p>' + text +'</p>';
		
		var p = cnt.getElementsByTagName('p');
		for(i=0; i<p.length; i++){}
		
		/* already stripped it */
		var a = cnt.getElementsByTagName('a');
		
		/* resizing images */
		var img = cnt.getElementsByTagName('img');
		
		for(i=0; i<img.length; i++)
		{
			img[i].onload = this.imageResize(img[i]);
			img[i].className = 'clear roundcont';
		}
		
		div.appendChild(divCnt);
		this.scroll.add(div);
		
		/* Post processing */
		Helper.checkEllipsis($('title_p'), $('title_div').clientWidth, 20);
		Helper.checkEllipsis($('subtitle_p'), $('subtitle_div').clientWidth, 20);
		
		this.resize();
		this.scroll.updateScrollbar();
		this.updateMenus();
		
		flickr.people_getInfo(user.token, this.comment.author, this.hrCommentIcons, PRI_LOW);
	}
	
	Comment.prototype.displayNoComment = function () {
		var div = Helper.displayNoType('No comment found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Comment.prototype.imageResize = function(img) {
		h = img.height;
		w = img.width;
		
		if((h >= w) && (h > 150))
		{
			img.style.height = '150px';
			img.style.width = ((150/h) * w) + 'px';
		}
		else if(w > 150)
		{
			img.style.width = '150px';
			img.style.height = ((150/w) * h) + 'px';
		}
		
		comment.resize();
		comment.scroll.updateScrollbar();
	}
	
	Comment.prototype.hrCommentIcons = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(comment)
				{
					if(rsp.person)
					{
						var tcontact = rsp.person;
						var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
						rsp = null;
						
						comment.replaceIcon(photo_url);
					}
				}
			}
			else
			{
				/* error */
				alert('failure: ' + rsp.msg);
			}
		}
	}
	
	Comment.prototype.replaceIcon = function(photo_url) {
		if(photo_url)
		{
			if($('contact_icon_div'))
			{
				$('contact_icon_div').className = 'contactframe';
				$('contact_icon').className = 'photo';
				$('contact_icon').src = photo_url;
			}
		}
	}
	
	Comment.prototype.getHeader = function(id, title, subtitle, photo_url, img_type) {
		var divComArea = Helper.getDiv('comment_area', 'comment_area');
		var divTabCom = Helper.getDiv('tab_af_' + id, 'comment_h');
		var divTComHeader = Helper.getDiv('tab_af_header_' + id, 'comment_header');
		var tableTComHeader = Helper.getTable(null, null);
		
		/* First row in Helper */
		var trHUp = Helper.getTr(null, null);
		var tdHUpLEdge = Helper.getTd(null, 'edge');
		var divHUpLEdge = Helper.getDiv(null, 'up left');
		
		var tdHUpIcon = Helper.getTd(null, 'icon');
		tdHUpIcon.setAttribute('rowspan', '2');
		var divHUpIcon = Helper.getDiv(null, null);
		var divIcon = null;
		var imgIcon = null;
		
		if(img_type == 'icon')
		{
			divIcon = Helper.getDiv('contact_icon_div', 'icon');
			imgIcon = Helper.getImg('contact_icon', null, photo_url);
		}
		else
		{
			divIcon = Helper.getDiv('contact_icon_div', 'contactframe');
			imgIcon = Helper.getImg('contact_icon', 'photo', photo_url);
		}
		
		var tdHUpText = Helper.getTd(null, 'text');
		var divHUpText = Helper.getDiv('title_div', 'up');
		var pTitle = Helper.getP('title_p', null, title);
		pTitle.origText = '' + title;
		
		var tdHUpREdge = Helper.getTd(null, 'edge');
		var divHUpREdge = Helper.getDiv(null, 'up right');
		
		tdHUpLEdge.appendChild(divHUpLEdge);
		
		divIcon.appendChild(imgIcon);
		divHUpIcon.appendChild(divIcon);
		tdHUpIcon.appendChild(divHUpIcon);
		
		divHUpText.appendChild(pTitle);
		tdHUpText.appendChild(divHUpText);
		
		tdHUpREdge.appendChild(divHUpREdge);
		
		trHUp.appendChild(tdHUpIcon);
		trHUp.appendChild(tdHUpLEdge);
		trHUp.appendChild(tdHUpText);
		trHUp.appendChild(tdHUpREdge);
		
		
		/* Second row in Helper */
		var trHDown = Helper.getTr(null, null);
		var tdHDownLEdge = Helper.getTd(null, 'edge');
		var divHDownLEdge = Helper.getDiv(null, 'down left');
		
		var tdHDownText = Helper.getTd(null, 'text');
		var divHDownText = Helper.getDiv('subtitle_div', 'down');
		var pSubtitle = Helper.getP('subtitle_p', null, subtitle);
		pSubtitle.origText = '' + subtitle;
		
		var tdHDownREdge = Helper.getTd(null, 'edge');
		var divHDownREdge = Helper.getDiv(null, 'down right');
		
		tdHDownLEdge.appendChild(divHDownLEdge);
		
		divHDownText.appendChild(pSubtitle);
		tdHDownText.appendChild(divHDownText);
		
		tdHDownREdge.appendChild(divHDownREdge);
		
		trHDown.appendChild(tdHDownLEdge);
		trHDown.appendChild(tdHDownText);
		trHDown.appendChild(tdHDownREdge);
		
		
		tableTComHeader.appendChild(trHUp);
		tableTComHeader.appendChild(trHDown);
		
		divTComHeader.appendChild(tableTComHeader);
		divTabCom.appendChild(divTComHeader);
		divComArea.appendChild(divTabCom);
		
		divComArea.addEventListener('click', function() {
			browsr.screens[browsr.screen].keyEnter();
		}, false);
		
		return divComArea;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	