	function Comments() {
		/* Object for the Comments Screen */
		this.page = [];
		this.photo = null;
		this.set = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Comments.prototype.initialize = function() {
		browsr.screen = SCREEN_COMMENTS;

		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();
	}
	
	Comments.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.photo = null;
		this.set = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	Comments.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	Comments.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpListNav(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownListNav(this);
				else
					Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	Comments.prototype.keyEnter = function() {
		if(this.total)
		{	
			var tcomment = this.getSelectedComment();
			var lindex = this.lindex;
			
			this.destroy();
			
			var params = [];
			
			params["comment"] = tcomment;
			
			browsr.addEvent('Comment by: ' + tcomment.authorname, comment.show, params, lindex, commentImage, 'icon');
			comment.show(params);
			params = null;
		}
	}
	
	Comments.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	Comments.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	Comments.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	Comments.prototype.keyRightTab = function() {
		Helper.keyRightTabPage(this);
	}
	
	Comments.prototype.refresh = function() {
		this.displayComments();
	}
	
	Comments.prototype.showInBrowser = function() {
		if(this.photo)
		{
			var url = 'http://www.flickr.com/photos/' + this.photo.owner + '/' + this.photo.id + '/';
			openURL(url);
		}
		else if(this.set)
		{
			/* need owner info */
			//var url = 'http://www.flickr.com/photos/' + this.user_id + '/tags/';
			//widget.openURL(encodeURI(url));
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Comments.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
			
			if(this.photo)
				wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			else
				wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			
			if(this.photo)
				toolbar.show(MENU_SHOW_IN_BROWSER.id);
			else
				toolbar.hide(MENU_SHOW_IN_BROWSER.id);
				
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Comments.prototype.switchToTabs = function() {
		Helper.switchToTabsPage(this);		
		this.displayComments();
	}
	
	Comments.prototype.switchToList = function() {
		Helper.switchToListPage(this);
		this.displayComments();
	}
	
	Comments.prototype.showByPhoto = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["user_id"] = null; /* unused */
		}
		else if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
		
		comments.photo = params["photo"];
		comments.initialize();
		
		if(comments.photo != null)
		{
			if(comments.photo.title != '')
				Helper.setTitle(comments.photo.title + '\'s comments');
			else
				Helper.setTitle('(untitled)' + '\'s comments');
				
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				comments.lindex = params["sindex"];
				comments.cur_page = parseInt(comments.lindex / MAX_LIST_SIZE) + 1;
			}
				
			flickr.photos_comments_getList(user.token, comments.photo.id, null, null, comments.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Comments.prototype.showBySet = function(params) {
	
		if(params == null)
		{
			params["set"] = null;
			params["user_id"] = null; /* unused */
		}
		else if((params["set"] == undefined) || (params["set"] == null))
		{
			params["set"] = null;
		}
		
		comments.set = params["set"];
		comments.initialize();
		
		if(comments.set != null)
		{
			if(comments.set.title._content)
				Helper.setTitle(comments.set.title._content + '\'s comments');
			else
				Helper.setTitle(comments.set.title + '\'s comments');
				
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				comments.lindex = params["sindex"];
				comments.cur_page = parseInt(comments.lindex / MAX_LIST_SIZE) + 1;
			}
				
			flickr.photosets_comments_getList(user.token, comments.set.id, comments.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Comments.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				comments.total = 0;
				var cur_page = comments.cur_page;
				comments.cur_page = 1;
				
				if(rsp.comments && rsp.comments.comment && rsp.comments.comment.length)
				{
					var tcomments = rsp.comments;
					comments.total = rsp.comments.comment.length;
					rsp = null;
					
					while(tcomments.comment.length)
					{
						if(tcomments.comment.length > MAX_LIST_SIZE)
						{
							comments.page[comments.cur_page] = tcomments.comment.slice(0, MAX_LIST_SIZE);
							tcomments.comment.splice(0, MAX_LIST_SIZE);
							comments.cur_page++;
						}
						else
						{
							comments.page[comments.cur_page] = tcomments.comment.slice(0, tcomments.comment.length);
							tcomments.comment.splice(0, tcomments.comment.length);
							comments.cur_page++;
						}
					}
					
					tcomments = null;
				}
				
				if(comments.total)
				{
					comments.pages = comments.cur_page-1;
					comments.cur_page = cur_page;
				}
				
				if(comments.total)
				{
					comments.displayComments();
				}
				else
				{
					comments.displayNoComment();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Comments.prototype.displayComments = function () {
		if(Helper.isListMode())
			this.displayCommentsList();
		else
			this.displayCommentsTabs();
	}
	
	Comments.prototype.displayCommentsList = function () {
		if(this.selector)
			this.selector.removeAll();
		
		var tcomments = this.page[this.cur_page];
		
		/* add to selector */
		for(var i=0; i < tcomments.length; i++)
		{
			var text = tcomments[i].authorname;
			
			this.selector.addElement(text, commentImage, 'icon');
			
			/* send a flickr request */
			flickr.people_getInfo(user.token, tcomments[i].author, this.hrCommentsIcons, PRI_LOW);
		}
		
		Helper.postDisplayList(this);
	}
	
	Comments.prototype.displayCommentsTabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var tcomment = this.page[this.cur_page][sindex];
		var photo_url = null;
		
		var ttitle = '';
		
		if(this.photo)
		{
			if(this.photo.title)
				ttitle = this.photo.title + '\'s Comments';
			else
				ttitle = '(untitled)' + '\'s Comments';
		}
		else if(this.set)
		{
			if(this.set.title._content)
				ttitle = this.set.title._content;
			else
				ttitle = this.set.title;
		}
		
		Helper.displayTabPage(this, this.lindex, tcomment.authorname, ttitle, commentImage, 'icon');
		this.auto_disp_tid = setTimeout( function() { comments.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
			
		Helper.postDisplayTabs(this);
	}
	
	Comments.prototype.displayNoComment = function () {
		this.selector = null;
		this.tab_container = null;
		var div = Helper.displayNoType('No comments found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Comments.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	Comments.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	Comments.prototype.hrCommentsIcons = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(comments && comments.selector)
				{
					if(rsp.person)
					{
						var tcontact = rsp.person;
						var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
						rsp = null;
						
						var set_index = -1;
						var current_page = comments.page[comments.cur_page];
						
						for(var i=0; i < current_page.length; i++)
						{
							if(current_page[i].author == tcontact.nsid)
							{
								set_index = i;
								comments.selector.replaceElement(set_index, current_page[i].authorname, photo_url);
							}
						}
					}
				}
			}
			else
			{
				/* error */
				alert('failure: ' + rsp.msg);
			}
		}
	}
	
	Comments.prototype.autoFetch = function() {
		if(this.cur_page && this.page[this.cur_page])
		{	
			var tcomment = this.getSelectedComment();
			
			if(!(Helper.isListMode()))
				this.tabs.autoFetch();
			
			var sindex = Helper.getSindex(this);
			
			var text = tcomment._content;
			
			if(text.length > MAX_AF_TEXT_LENGTH)
			{
				text = text.substr(0, MAX_AF_TEXT_LENGTH);
				text = text + '...';
			}
				
			if(text != '' )
				Helper.setAFText(sindex, tcomment._content);
			else
				Helper.setAFNoResult(sindex, 'No comment available!');
			
			this.resize();
			this.scroll.updateScrollbar();
		}
	}
	

	Comments.prototype.getSelectedComment = function() {
		if(Helper.isListMode())
		{
			sindex = this.selector.selected_index;
			this.lindex = this.selectedListItem();
		}
		else
		{
			this.cur_page = parseInt(this.lindex / MAX_LIST_SIZE) + 1;
			sindex = this.lindex % MAX_LIST_SIZE;
		}
	
		if(this.total)
			return this.page[this.cur_page][sindex];
		else
			return null;
	}
	
	