	function Contact() {
		/* Object for the Contact Screen */
		this.user = null;
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	Contact.prototype.initialize = function() {
		browsr.screen = SCREEN_CONTACT;
		
		this.elements = tabs_contact;
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Contact.prototype.destroy = function() {
		flickr.purge_all();
		
		this.user = null;
		this.lindex = 0;
		this.elements = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
	}
	
	Contact.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Contact.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	Contact.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
			
		switch(sindex)
		{
			case CONTACT_IDX_PHOTOSTREAM:
				/* photostream */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Photostream', photostream.showByUser, params, sindex, photostreamImage, 'icon');
				photostream.showByUser(params);
				params = null;
				break;
				
			case CONTACT_IDX_CONTACTS:
				/* contacts */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Contacts', contacts.showByContact, params, sindex, contactsImage, 'icon');
				contacts.showByContact(params);
				params = null;
				break;
			
			case CONTACT_IDX_SETS:
				/* sets */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Sets', sets.showByUser, params, sindex, setsImage, 'icon');
				sets.showByUser(params);
				params = null;
				break;
				
			case CONTACT_IDX_COLLECTIONS:
				/* collections */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Collections', collections.showByUser, params, sindex, collectionsImage, 'icon');
				collections.showByUser(params);
				params = null;
				break;
				
			case CONTACT_IDX_TAGS:
				/* tags */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Tags', tags.showByUser, params, sindex, tagsImage, 'icon');
				tags.showByUser(params);
				params = null;
				break;
				
			case CONTACT_IDX_FAVORITES:
				/* tags */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Favorites', photostream.showByFavorites, params, sindex, favoritesImage, 'icon');
				photostream.showByFavorites(params);
				params = null;
				break;
				
			case CONTACT_IDX_PROFILE:
				/* profile */
				
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent(params["user"].username + '\'s Profile', description.showByProfile, params, sindex, profileImage, 'icon');
				description.showByProfile(params);
				params = null;
		}
	}
	
	Contact.prototype.refresh = function() {
		this.destroy();
		
		var params = [];
		params["user"] = this.user;
		
		this.show(params);
	}
	
	Contact.prototype.showInBrowser = function() {
		if(this.user)
		{	
			var url = 'http://www.flickr.com/photos/' + this.user.user_nsid + '/';
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Contact.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
			
			if(this.user)
			{
				if(bmarks.findContactInBmarks(this.user.user_nsid))
				{
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
				}
				else
				{	
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
				}
			}
			else
			{
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Contact.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Contact.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Contact.prototype.show = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
		}
		else if((params["user"] == undefined) || (params["user"] == null))
		{
			params["user"] = user;
		}
		
		if(params["user"].user_nsid == user.user_nsid)
		{
			params["user_nsid"] = user.user_nsid;
			params["sindex"] = 0;
			
			/* update history */
			browsr.lastEvent();
			browsr.addEvent('Home', home.show, params, 0, browsrImage, 'icon');
			home.show(params);
			return;
		}
		
		contact.initialize();
		
		contact.user = params["user"];
		
		if(contact.user != null)
		{
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				contact.lindex = params["sindex"];
			
			Helper.setTitle('' + contact.user.username + '\'s home');
			
			if(Helper.isListMode())
				contact.displayList();
			else
				contact.displayTab();
			
			contact.updateMenus();
		}
	}
	
	Contact.prototype.showByBookmark = function(params) {
		if(params == null)
		{
			params["user_id"] = null;
			params["username"] = null;
		}
		
		if((params["user_id"] == undefined) || (params["user_id"] == null))
			params["user_id"] = null;
		
		if((params["username"] == undefined) || (params["username"] == null))
			params["username"] = null;
			
		if(params["user_id"])
		{
			var tparams = [];
			tparams["user"] = { user_nsid : params["user_id"],
								username : params["username"] };
			contact.show(tparams);
		}
	}
	
	Contact.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Contact.prototype.displayTab = function() {
		Helper.displayTab(this, this.user.username);
		
		this.auto_disp_tid = setTimeout( function() { contact.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Contact.prototype.autoFetch = function() {
		if(this.user)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case CONTACT_IDX_PHOTOSTREAM:
					/* photostream */
					var params = [];
					
					params["method"] = "flickr.photos.search";
					params["user_id"] = this.user.user_nsid;
					params["auth_token"] = user.token;
					params["per_page"] = Constants.AUTO_FETCH_PHOTOCOUNT;
					
					flickr.photos_search(params, this.hrPhotostream, PRI_HIGH);
					break;
					
				case CONTACT_IDX_CONTACTS:
					/* contacts */
					flickr.contacts_getPublicList(user.token, this.user.user_nsid, null, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrContacts, PRI_HIGH);
					break;
					
				case CONTACT_IDX_SETS:
					/* sets */
					flickr.photosets_getList(user.token, this.user.user_nsid, this.hrSets, PRI_HIGH);
					break;
				
				case CONTACT_IDX_COLLECTIONS:
					/* collections */
					flickr.collections_getTree(user.token, null, this.user.user_nsid, this.hrCollections, PRI_HIGH);						
					break;
					
				case CONTACT_IDX_TAGS:
					/* tags */
					flickr.tags_getListUserPopular(user.token, this.user.user_nsid, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrTags, PRI_HIGH);
					break;
					
				case CONTACT_IDX_FAVORITES:
					/* favorites */
					flickr.favorites_getList(user.token, this.user.user_nsid, null, null, null, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrFavorites, PRI_HIGH);
					break;
					
				case CONTACT_IDX_PROFILE:
					/* profile */
					flickr.people_getInfo(user.token, this.user.user_nsid, this.hrProfile, PRI_HIGH);
					break;
			}
		}
	}
	
	Contact.prototype.hrPhotostream = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == CONTACT_IDX_PHOTOSTREAM)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrContacts = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{	
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
					
					if(rsp.contacts.total)
					{
						var tcontacts = rsp.contacts.contact;
						rsp = null;
						
						if(sindex == CONTACT_IDX_CONTACTS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tcontacts.length; i++)
							{
								var tcontact = tcontacts[i];
								photo_url[i] = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'small');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No contacts available!');					
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrSets = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
					
					if(rsp.photosets.photoset.length)
					{
						var tsets = rsp.photosets.photoset;
						rsp = null;
						
						if(sindex == HOME_IDX_SETS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; (i < tsets.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								var tset = tsets[i];
								photo_url[i] = flickr.build_photo_url(tset.farm, tset.server, tset.primary, tset.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No sets available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrCollections = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
					
					if(rsp.collections && rsp.collections.collection && rsp.collections.collection.length)
					{
						var tcollections = rsp.collections.collection;
						rsp = null;
						
						if(sindex == CONTACT_IDX_COLLECTIONS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; (i < tcollections.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								var tcollection = tcollections[i];
								photo_url[i] = tcollection.iconsmall;
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No collections available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrTags = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
						
					var ttags = rsp.who.tags.tag;
					rsp = null;
					
					if(ttags.length)
					{						
						if(sindex == CONTACT_IDX_TAGS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var ttag = [];
							for(var i=0; (i < ttags.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								ttag[i] = ttags[i]._content + ' (' + ttags[i].count + ')';
							}
							
							Helper.setAFTextList(sindex, ttag);
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No tags available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrFavorites = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
						
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == CONTACT_IDX_FAVORITES)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No favorite photos available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contact.prototype.hrProfile = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(contact)
				{
					var sindex = Helper.getSindex(contact);
						
					if(rsp.person)
					{
						var tperson = rsp.person;
						rsp = null;
						
						if(sindex == CONTACT_IDX_PROFILE)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var photo_url = flickr.build_buddy_icon_url(tperson.iconserver, tperson.iconfarm, tperson.nsid);
							
							var text = [];
							if(tperson.realname && tperson.realname._content)
								text[text.length] = tperson.realname._content;
								
							if(tperson.location && tperson.location._content)
								text[text.length] = tperson.location._content;
							
							if(tperson.photos && tperson.photos.count && tperson.photos.count._content)
								text[text.length] = tperson.photos.count._content + ' photos';
							
							Helper.setAFPhotoTextList(sindex, photo_url, text, 'small', 'right');
							contact.resize();
							contact.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No profile information available!');
						contact.resize();
						contact.scroll.updateScrollbar();
					}
					
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Contact.prototype.addToBookmarks = function() {
		if(bmarks && this && this.user)
		{
			bmarks.addContactToBmarks( {id:this.user.user_nsid, name:this.user.username} );
		}
	}
	
	Contact.prototype.removeFromBookmarks = function() {
		if(bmarks && this && this.user)
		{
			bmarks.removeContactFromBmarks(this.user.user_nsid);
		}
	}
	
	