	function Contacts() {
		/* Object for the Contacts Screen */
		this.page = [];
		this.user = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.by_user = false;
		this.by_contact = false;
		this.by_recent = false;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Contacts.prototype.initialize = function() {
		browsr.screen = SCREEN_CONTACTS;

		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();
	}
	
	Contacts.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.user = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.by_user = false;
		this.by_contact = false;
		this.by_recent = false;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	Contacts.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	Contacts.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
				{
					Helper.keyUpListNav(this);
					this.updateBookmarkMenus();
				}
				else
				{
					Helper.keyUpScroll(this);
				}
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
				{
					Helper.keyDownListNav(this);
					this.updateBookmarkMenus();
				}
				else
				{
					Helper.keyDownScroll(this);
				}
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	Contacts.prototype.keyEnter = function() {
		if(this.total)
		{	
			var tcontact = this.getSelectedContact();
			var lindex = this.lindex;
			var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
			
			this.destroy();
			
			var params = [];
			
			params["user"] = new User();
			params["user"].user_nsid = tcontact.nsid;
			params["user"].username = tcontact.username;
			params["user"].fullname = tcontact.realname;
			
			browsr.addEvent('User: ' + tcontact.username, contact.show, params, lindex, photo_url, 'photoframe');
			contact.show(params);
			params = null;
		}
	}
	
	Contacts.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	Contacts.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	Contacts.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	Contacts.prototype.keyRightTab = function() {
		Helper.keyRightTabPage(this);
	}
	
	Contacts.prototype.refresh = function() {
		if(this.page[this.cur_page])
		{
			flickr.purge_all();
			this.displayContacts();
		}
		else
		{
			flickr.purge_all();
			var params = [];
			params["user"] = this.user;
			params["page"] = this.cur_page;
			
			if(this.by_user == true)
			{
				this.showByUser(params);
			}
			else if(this.by_contact == true)
			{
				this.showByContact(params);
			}
			else if(this.by_recent == true)
			{
				this.showByRecent(params);
			}
		}
	}
	
	Contacts.prototype.showInBrowser = function() {
		if(this.selector)
		{
			var tcontact = this.getSelectedContact();
			
			var url = 'http://www.flickr.com/photos/' + tcontact.nsid + '/';
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Contacts.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
			
			this.updateBookmarkMenus();
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Contacts.prototype.updateBookmarkMenus = function() {
		var tcontact = this.getSelectedContact();
		
		if(tcontact && bmarks)
		{
			if(bmarks.findContactInBmarks(tcontact.nsid))
			{
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
			}
			else
			{	
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
	}
		
	Contacts.prototype.switchToTabs = function() {
		Helper.switchToTabsPage(this);
		this.refresh();
	}
	
	Contacts.prototype.switchToList = function() {
		Helper.switchToListPage(this);
		this.refresh();
	}

	Contacts.prototype.showByUser = function(params) {
		
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		contacts.user = params["user"];
		contacts.by_user = true;
		
		if((params["page"] == undefined) || (params["page"] == null))
			contacts.initialize();
		
		if(contacts.user != null)
		{
			Helper.setTitle(contacts.user.username + '\'s contacts');
			
			var page = params["page"];
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				contacts.lindex = params["sindex"];
				contacts.cur_page = parseInt(contacts.lindex / MAX_LIST_SIZE) + 1;
				page =  contacts.cur_page;
			}
			flickr.contacts_getList(user.token, null, page, MAX_LIST_SIZE, contacts.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Contacts.prototype.showByContact = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		contacts.user = params["user"];
		contacts.by_contact = true;
		
		if((params["page"] == undefined) || (params["page"] == null))
			contacts.initialize();
		
		if(contacts.user != null)
		{
			Helper.setTitle(contacts.user.username + '\'s contacts');
			
			var page = params["page"];
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				contacts.lindex = params["sindex"];
				contacts.cur_page = parseInt(contacts.lindex / MAX_LIST_SIZE) + 1;
				page =  contacts.cur_page;
			}
			
			flickr.contacts_getPublicList(user.token, contacts.user.user_nsid, page, MAX_LIST_SIZE, contacts.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Contacts.prototype.showByRecent = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		contacts.user = params["user"];
		contacts.by_recent = true;
		
		if((params["page"] == undefined) || (params["page"] == null))
			contacts.initialize();
		
		if(contacts.user != null)
		{
			/* TODO: Change this after title scrolling!! */
			Helper.setTitle(contacts.user.username + '\'s contacts');
			
			var page = params["page"];
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				contacts.lindex = params["sindex"];
				contacts.cur_page = parseInt(contacts.lindex / MAX_LIST_SIZE) + 1;
				page =  contacts.cur_page;
			}
			
			flickr.contacts_getListRecentlyUploaded(user.token, null, null, contacts.handleRecentFlickrResponse, PRI_HIGH);
		}
	}
	
	Contacts.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				var cur_page = rsp.contacts.page;
				contacts.page[cur_page] = rsp.contacts;
				contacts.total = rsp.contacts.total;
				contacts.pages = rsp.contacts.pages;
				rsp = null;
				if((contacts.cur_page == cur_page) && contacts.total)
				{
					contacts.displayContacts();
				}
				else if(contacts.total == 0)
				{
					contacts.displayNoContact();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Contacts.prototype.handleRecentFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				contacts.total = 0;
				var cur_page = contacts.cur_page;
				
				if(rsp.contacts)
				{
					var tcontacts = rsp.contacts;
					contacts.total = tcontacts.total;
					rsp = null;
					contacts.cur_page = 1;
					
					while(tcontacts.contact.length)
					{
						if(tcontacts.contact.length > MAX_LIST_SIZE)
						{
							contacts.page[contacts.cur_page] = tcontacts.contact.slice(0, MAX_LIST_SIZE);
							tcontacts.contact.splice(0, MAX_LIST_SIZE);
							contacts.cur_page++;
						}
						else
						{
							contacts.page[contacts.cur_page] = tcontacts.contact.slice(0, tcontacts.contact.length);
							tcontacts.contact.splice(0, tcontacts.contact.length);
							sets.cur_page++;
						}
					}
					
					tsets = null;
				}
				
				if(contacts.total)
				{
					contacts.pages = contacts.cur_page-1;
					contacts.cur_page = cur_page;
				}
				
				if(contacts.total)
				{
					contacts.displayContacts();
				}
				else
				{
					contacts.displayNoContact();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Contacts.prototype.displayContacts = function () {
		if(Helper.isListMode())
			this.displayContactsList();
		else
			this.displayContactsTabs();
	}
	
	Contacts.prototype.displayContactsList = function () {
		if(this.selector)
			this.selector.removeAll();
			
		var tcontacts = null;
		
		if(this.by_user || this.by_contact)
			tcontacts = this.page[this.cur_page].contact;
		else
			tcontacts = this.page[this.cur_page];
		
		/* add to selector */
		for(var i=0; i < tcontacts.length; i++)
		{
			var tcontact = tcontacts[i];
			var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
			
			/* Can set this using a setting */
			this.selector.addElement(tcontact.username, photo_url, 'photoframe');
		}
		
		Helper.postDisplayList(this);
	}

	Contacts.prototype.displayContactsTabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var tcontact = null;	
		if(this.by_user || this.by_contact)
			tcontact = this.page[this.cur_page].contact[sindex];
		else
			tcontact = this.page[this.cur_page][sindex];
			
		var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
		
		Helper.displayTabPage(this, this.lindex, tcontact.username, (this.user.username + '\'s Contacts'), photo_url, 'contactframe');
		this.auto_disp_tid = setTimeout( function() { contacts.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
			
		Helper.postDisplayTabs(this);
	}
	
	Contacts.prototype.displayNoContact = function () {
		this.selector = null;
		this.tab_container = null;
		var div = Helper.displayNoType('No contacts found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Contacts.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	Contacts.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	Contacts.prototype.autoFetch = function() {
		if(this.cur_page && this.page[this.cur_page])
		{
			var tcontact = this.getSelectedContact();
			
			if(!(Helper.isListMode()))
				this.tabs.autoFetch();
			
			/* photostream */
			var params = [];
			
			params["method"] = "flickr.photos.search";
			params["user_id"] = tcontact.nsid;
			params["auth_token"] = user.token;
			params["per_page"] = Constants.AUTO_FETCH_PHOTOCOUNT;

			flickr.photos_search(params, this.hrPhotostream, PRI_HIGH);
		}
	}
	
	Contacts.prototype.hrPhotostream = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				var tphotostream = rsp.photos.photo;
				rsp = null;
				
				if(contacts && contacts.page && contacts.cur_page && contacts.page[contacts.cur_page])
				{
					
					/* check if the owner of the rsp and the owner of the selected item match */
					var rsp_owner = "";
					if(tphotostream.length > 0)
					{
						rsp_owner = tphotostream[0]["owner"];
					}
					
					var tcontact = contacts.getSelectedContact();
					
					var sindex = Helper.getSindex(contacts);
					
					var sel_owner = tcontact["nsid"];
					
					if(rsp_owner == sel_owner)
					{
						Helper.destroyDescendants($('autof_elt_' + sindex));
						var photo_url = [];
						for(var i=0; i < tphotostream.length; i++)
						{
							var tphoto = tphotostream[i];
							photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
						}
						
						Helper.setAFPhotoList(sindex, photo_url, 'large');
						contacts.resize();
						contacts.scroll.updateScrollbar();
					}
					else
					{
						/* Display real name */
						var text = [];
						
						if(tcontact.realname)
							text[text.length] = tcontact.realname;
							
						if(tcontact.location)
							text[text.length] = ''  + tcontact.location;
						
						Helper.setAFTextList(sindex, text);
						contacts.resize();
						contacts.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Contacts.prototype.addToBookmarks = function() {
		if(this.cur_page && this.page[this.cur_page])
		{
			var tcontact = this.getSelectedContact();
			
			if(bmarks && tcontact)
			{
				bmarks.addContactToBmarks( {id:tcontact.nsid, name:tcontact.username} );
			}
		}
	}
	
	Contacts.prototype.removeFromBookmarks = function() {
		if(this.cur_page && this.page[this.cur_page])
		{
			var tcontact = this.getSelectedContact();
			
			if(bmarks && tcontact)
			{
				bmarks.removeContactFromBmarks(tcontact.nsid);
			}
		}
	}
	
	Contacts.prototype.getSelectedContact = function() {
		if(Helper.isListMode())
		{
			sindex = this.selector.selected_index;
			this.lindex = this.selectedListItem();
		}
		else
		{
			this.cur_page = parseInt(this.lindex / MAX_LIST_SIZE) + 1;
			sindex = this.lindex % MAX_LIST_SIZE;
		}
		
		if(this.total)
		{
			if(this.by_user || this.by_contact)
				return this.page[this.cur_page].contact[sindex];
			else
				return this.page[this.cur_page][sindex];
		}
		else
			return null;
	}
	
	