	function Description() {
		/* Object for the Description Screen */
		this.photo = null;
		this.set = null;
		this.collection = null;
		this.user = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Description.prototype.initialize = function() {
		browsr.screen = SCREEN_DESCRIPTION;
		
		this.scroll = new Scroll();		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		/*
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		*/
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	Description.prototype.destroy = function() {
		flickr.purge_all();
		
		this.photo = null;
		this.set = null;
		this.collection = null;
		this.user = null;
			
		/* TODO : Verify */
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	Description.prototype.resize = function() {
		this.scroll.resize();
	}
	
	Description.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				break;
				
			case KEY_LEFT:
				/* LEFT */
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				break;
		}
	}
	
	Description.prototype.showInBrowser = function() {
		if(this.photo)
		{
			var url = 'http://www.flickr.com/photos/' + this.photo.owner + '/' + this.photo.id + '/';		
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Description.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			
			if(this.photo)
				wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			else
				wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			
			if(this.photo)
				toolbar.show(MENU_SHOW_IN_BROWSER.id);
			else
				toolbar.hide(MENU_SHOW_IN_BROWSER.id);
				
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
	}
	
	Description.prototype.showByPhoto = function(params) {
	
		if(params == null)
			params["photo"] = null;
		else if((params["photo"] == undefined) || (params["photo"] == null))
			params["photo"] = null;
			
		description.photo = params["photo"];
		description.initialize();
		
		if(description.photo != null)
		{
			if(description.photo.title != '')
				Helper.setTitle(description.photo.title + '\'s description');
			else
				Helper.setTitle('(untitled)' + '\'s description');
				
			/* send request to flickr */
			flickr.photos_getInfo(user.token, description.photo.id, description.photo.secret, description.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Description.prototype.showBySet = function(params) {
	
		if(params == null)
			params["set"] = null;
		else if((params["set"] == undefined) || (params["set"] == null))
			params["set"] = null;
			
		description.set = params["set"];
		description.initialize();
		
		if(description.set != null)
		{
			if(description.set.title._content)
				Helper.setTitle('' + description.set.title._content + '\'s description');
			else
				Helper.setTitle('' + description.set.title + '\'s description');
				
			/* send request to flickr */
			flickr.photosets_getInfo(user.token, description.set.id, description.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Description.prototype.showByCollection = function(params) {
	
		if(params == null)
			params["collection"] = null;
		else if((params["collection"] == undefined) || (params["collection"] == null))
			params["collection"] = null;
			
		description.collection = params["collection"];
		description.initialize();
		
		if(description.collection != null)
		{
			Helper.setTitle('' + description.collection.title + '\'s description');
				
			var text = description.collection.description;
				
			if(text != '')
				description.displayDescription(text);
			else
				description.displayNoDescription();
		}
	}
	
	Description.prototype.showByProfile = function(params) {
	
		if(params == null)
			params["user"] = null;
		else if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = null;
			
		description.user = params["user"];
		description.initialize();
		
		if(description.user != null)
		{
			Helper.setTitle('' + description.user.username + '\'s profile');
			
			flickr.people_getInfo(user.token, description.user.user_nsid, description.hrProfile, PRI_HIGH);
		}
	}
	
	Description.prototype.showByExif = function(params) {
	
		if(params == null)
			params["photo"] = null;
		else if((params["photo"] == undefined) || (params["photo"] == null))
			params["photo"] = null;
			
		description.photo = params["photo"];
		description.initialize();
		
		if(description.photo != null)
		{
			if(description.photo.title != '')
				Helper.setTitle(description.photo.title + '\'s Exif data');
			else
				Helper.setTitle('(untitled)' + '\'s Exif data');
				
			/* send request to flickr */
			flickr.photos_getExif(user.token, description.photo.id, description.photo.secret, description.hrExif, PRI_HIGH);
		}
	}
	
	Description.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(description)
				{
					if(description.photo)
					{
						tinfo = rsp.photo;
						rsp = null;
					}
					else if(description.set)
					{
						tinfo = rsp.photoset;
						rsp = null;
					}
					
					var text = '';
						
					if(tinfo.description)
						text = tinfo.description._content;
						
					if(text != '')
						description.displayDescription(text);
					else
						description.displayNoDescription();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Description.prototype.hrProfile = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(description)
				{
					tperson = rsp.person;
					rsp = null;
						
					if(tperson)
					{
						var photo_url = flickr.build_buddy_icon_url(tperson.iconserver, tperson.iconfarm, tperson.nsid);
						var text = '';
						var title = '';
						var subtitle = '';
						
						if(tperson.username && tperson.username._content)
						{
							var username = tperson.username._content;
							if(username)
								title = '' + username;
						}
							
						if(tperson.realname && tperson.realname._content)
						{
							var realname = tperson.realname._content;
							if(realname)
								subtitle = '' + realname;
							else
								subtitle = '(no realname given)';
						}
						
						if(tperson.ispro)
							text += 'Pro user' + '<br>';
							
						if(tperson.isadmin)
							text += 'Admin' + '<br>';
							
						if(tperson.location && tperson.location._content)
						{
							var location = tperson.location._content;
							if(location)
								text += 'Location : ' + location + '<br>';
						}
						
						if(0)
						{
							/* Enable this later */
							if(tperson.photosurl && tperson.photosurl._content)
							{
								var photosurl = tperson.photosurl._content;
								if(photosurl)
									text += 'Photos URL: ' + photosurl + '<br>';
							}
								
							if(tperson.profileurl && tperson.profileurl._content)
							{
								var profileurl = tperson.profileurl._content;
								if(profileurl)
									text += 'Profile URL: ' + profileurl + '<br>';
							}
								
							if(tperson.mobileurl && tperson.mobileurl._content)
							{
								var mobileurl = tperson.mobileurl._content;
								if(mobileurl)
									text += 'Mobile URL: ' + mobileurl + '<br>';
							}
						}
						
						if(tperson.photos)
						{
							var tphotos = tperson.photos;
							if(tphotos.firstdate && tphotos.firstdate._content)
							{
								var firstdate = tphotos.firstdate._content;
								if(firstdate)
								{
									var fd_obj = new Date();
									fd_obj.setTime(firstdate * 1000);
									text += 'Uploading photos since : ' + fd_obj.toLocaleDateString() + '<br>';
								}
							}
								
							if(tphotos.count && tphotos.count._content)
							{
								var count = tphotos.count._content;
								if(count)
									text += '# Photos : ' + count + '<br>';
								}
								
							if(tphotos.views && tphotos.views._content)
							{
								var views = tphotos.views._content;
								if(views)
									text += '# Views : ' + views + '<br>';
							}	
						}
						
						var div = description.getHeader(0, title, subtitle, photo_url, 'photoframe');
						var divCnt = Helper.getDescriptionContainer(0);
						var cnt = Helper.getDescriptionContent(divCnt);
						
						cnt.innerHTML = '<p>' + text +'</p>';
						
						var p = cnt.getElementsByTagName('p');
						for(i=0; i<p.length; i++){}
						
						div.appendChild(divCnt);
						description.scroll.add(div);
						
						/* Post processing */
						Helper.checkEllipsis($('title_p'), $('title_div').clientWidth, 20);
						Helper.checkEllipsis($('subtitle_p'), $('subtitle_div').clientWidth, 20);
						
						description.resize();
						description.scroll.updateScrollbar();
						description.updateMenus();
					}	
					else
					{
						var div = Helper.displayNoType('No profile info found!');
						description.scroll.add(div);
						description.updateMenus();
					}
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Description.prototype.hrExif = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(description)
				{
					texif = rsp.photo.exif;
					rsp = null;
					
					if(texif && texif.length)
					{	
						var photo_url = null;
						var tphoto = description.photo;
						photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
						
						var text = '';
						var title = '';
						
						if(description.photo.title != '')
							title = '' + description.photo.title;
						else
							title = '(untitled)';
							
						for(var i=0; (i < texif.length); i++)
						{
							if(texif[i].tagspace == 'IFD0')
							{
								if(texif[i].tag == 'Make')
									text += 'Make : ' + texif[i].raw._content + '<br>';
									
								else if(texif[i].tag == 'Model')
									text += 'Model : ' + texif[i].raw._content + '<br>';
									
								else if(texif[i].tag == 'Software')
									text += 'Software : ' + texif[i].raw._content + '<br>';
							}
							else if(texif[i].tagspace == 'ExifIFD')
							{
								if(texif[i].tag == 'ExposureTime')
									text += 'Exposure Time : ' + texif[i].raw._content + ' sec' + '<br>';
									
								else if(texif[i].tag == 'FNumber')
								{
									if(texif[i].clean)
										text +='Aperture : ' + texif[i].clean._content + '<br>';
										
									else
										text += 'Aperture : ' + texif[i].raw._content + '<br>';
								}
								
								else if(texif[i].tag == 'ISO')
									text += 'ISO : ' + texif[i].raw._content + '<br>';
									
								else if(texif[i].tag == 'FocalLength')
									text += 'Focal Length : ' + texif[i].raw._content + '<br>';
							}
						}
						
						var div = description.getHeader(0, title, 'Exif Data', photo_url, 'photoframe');
						var divCnt = Helper.getDescriptionContainer(0);
						var cnt = Helper.getDescriptionContent(divCnt);
						
						cnt.innerHTML = '<p>' + text +'</p>';
						
						var p = cnt.getElementsByTagName('p');
						for(i=0; i<p.length; i++){}
						
						div.appendChild(divCnt);
						description.scroll.add(div);
						
						/* Post processing */
						Helper.checkEllipsis($('title_p'), $('title_div').clientWidth, 20);
						Helper.checkEllipsis($('subtitle_p'), $('subtitle_div').clientWidth, 20);
						
						description.resize();
						description.scroll.updateScrollbar();
						description.updateMenus();
					}	
					else
					{
						var div = Helper.displayNoType('No exif info found!');
						description.scroll.add(div);
						description.updateMenus();
					}
				}
			}
			else
			{
				/* error */
				var div = Helper.displayNoType('No exif info found!');
				description.scroll.add(div);
				description.updateMenus();
			}
		}
	}
	
	Description.prototype.displayDescription = function (text) {
	
		var title = '';
		var photo_url = '';
		
		if(this.photo)
		{
			if(this.photo.title != '')
				title = this.photo.title;
			else
				title = '(untitled)';
				
			photo_url = flickr.build_photo_url(this.photo.farm, this.photo.server, this.photo.id, this.photo.secret, PHOTO_S);
		}
		else if(this.set)
		{
			if(this.set.title._content)
				title = this.set.title._content;
			else
				title = this.set.title;
				
			photo_url = flickr.build_photo_url(this.set.farm, this.set.server, this.set.primary, this.set.secret, PHOTO_S);
		}
		else if(this.collection)
		{
			title = this.collection.title;
			
			if(this.collection.iconsmall)
				photo_url = this.collection.iconsmall;
			else
				photo_url = itemsImage;
		}
		
		var div = this.getHeader(0, title, 'Description', photo_url, 'photoframe');
		var divCnt = Helper.getDescriptionContainer(0);
		var cnt = Helper.getDescriptionContent(divCnt);
		
		/* Stripping off a tags */
		var a_re = new RegExp('<\s*\/?\s*a\s*.*?>', 'g');
		text = text.replace(a_re, "");
		
		var nl_re = new RegExp('\\n', 'g');
		text = text.replace(nl_re, '<br>');
		
		cnt.innerHTML = '<p>' + text +'</p>';
		
		var p = cnt.getElementsByTagName('p');
		for(i=0; i<p.length; i++){}
		
		var a = cnt.getElementsByTagName('a');
		
		var img = cnt.getElementsByTagName('img');
		
		for(i=0; i<img.length; i++)
		{
			img[i].onload = this.imageResize(img[i]);
			img[i].className = 'clear roundcont';
		}
		
		div.appendChild(divCnt);
		this.scroll.add(div);
		
		/* Post processing */
		Helper.checkEllipsis($('title_p'), $('title_div').clientWidth, 20);
		Helper.checkEllipsis($('subtitle_p'), $('subtitle_div').clientWidth, 20);
		
		this.resize();
		this.scroll.updateScrollbar();
		this.updateMenus();
	}
	
	Description.prototype.displayNoDescription = function () {
		var div = Helper.displayNoType('No description found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Description.prototype.imageResize = function(img) {
		h = img.height;
		w = img.width;
		
		if((h >= w) && (h > 150))
		{
			img.style.height = '150px';
			img.style.width = ((150/h) * w) + 'px';
		}
		else if(w > 150)
		{
			img.style.width = '150px';
			img.style.height = ((150/w) * h) + 'px';
		}
		
		description.resize();
		description.scroll.updateScrollbar();
	}
	
	Description.prototype.getHeader = function(id, title, subtitle, photo_url, img_type) {
		var divComArea = Helper.getDiv('description_area', 'description_area');
		var divTabCom = Helper.getDiv('tab_af_' + id, 'activity_h');
		var divTComHeader = Helper.getDiv('tab_af_header_' + id, 'description_header');
		var tableTComHeader = Helper.getTable(null, null);
		
		/* First row in Helper */
		var trHUp = Helper.getTr(null, null);
		var tdHUpLEdge = Helper.getTd(null, 'edge');
		var divHUpLEdge = Helper.getDiv(null, 'up left');
		
		var tdHUpIcon = Helper.getTd(null, 'icon');
		tdHUpIcon.setAttribute('rowspan', '2');
		var divHUpIcon = Helper.getDiv(null, null);
		var divIcon = null;
		var imgIcon = null;
		
		if(img_type == 'icon')
		{
			divIcon = Helper.getDiv('description_icon_div', 'icon');
			imgIcon = Helper.getImg('description_icon', null, photo_url);
		}
		else
		{
			divIcon = Helper.getDiv('description_icon_div', 'photoframe');
			imgIcon = Helper.getImg('description_icon', 'photo', photo_url);
		}
		
		var tdHUpText = Helper.getTd(null, 'text');
		var divHUpText = Helper.getDiv('title_div', 'up');
		var pTitle = Helper.getP('title_p', null, title);
		pTitle.origText = '' + title;
		
		var tdHUpREdge = Helper.getTd(null, 'edge');
		var divHUpREdge = Helper.getDiv(null, 'up right');
		
		tdHUpLEdge.appendChild(divHUpLEdge);
		
		divIcon.appendChild(imgIcon);
		divHUpIcon.appendChild(divIcon);
		tdHUpIcon.appendChild(divHUpIcon);
		
		divHUpText.appendChild(pTitle);
		tdHUpText.appendChild(divHUpText);
		
		tdHUpREdge.appendChild(divHUpREdge);
		
		trHUp.appendChild(tdHUpIcon);
		trHUp.appendChild(tdHUpLEdge);
		trHUp.appendChild(tdHUpText);
		trHUp.appendChild(tdHUpREdge);
		
		
		/* Second row in Helper */
		var trHDown = Helper.getTr(null, null);
		var tdHDownLEdge = Helper.getTd(null, 'edge');
		var divHDownLEdge = Helper.getDiv(null, 'down left');
		
		var tdHDownText = Helper.getTd(null, 'text');
		var divHDownText = Helper.getDiv('subtitle_div', 'down');
		var pSubtitle = Helper.getP('subtitle_p', null, subtitle);
		pSubtitle.origText = '' + subtitle;
		
		var tdHDownREdge = Helper.getTd(null, 'edge');
		var divHDownREdge = Helper.getDiv(null, 'down right');
		
		tdHDownLEdge.appendChild(divHDownLEdge);
		
		divHDownText.appendChild(pSubtitle);
		tdHDownText.appendChild(divHDownText);
		
		tdHDownREdge.appendChild(divHDownREdge);
		
		trHDown.appendChild(tdHDownLEdge);
		trHDown.appendChild(tdHDownText);
		trHDown.appendChild(tdHDownREdge);
		
		
		tableTComHeader.appendChild(trHUp);
		tableTComHeader.appendChild(trHDown);
		
		divTComHeader.appendChild(tableTComHeader);
		divTabCom.appendChild(divTComHeader);
		divComArea.appendChild(divTabCom);
		
		divComArea.addEventListener('click', function() {
			browsr.screens[browsr.screen].keyEnter();
		}, false);
		
		return divComArea;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	