	function Explore() {
		/* Object for the Explore Screen */
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	Explore.prototype.initialize = function() {
		browsr.screen = SCREEN_EXPLORE;
		
		this.elements = tabs_explore;
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Explore.prototype.destroy = function() {
		flickr.purge_all();
		
		this.lindex = 0;
		this.tabs = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
	}
	
	Explore.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Explore.prototype.handleKeypress = function(key) {
		if(!browsr.onion)
		{
			/* Normal Screen*/
			switch(key)
			{
				case KEY_UP:
					/* UP */
					if(Helper.isListMode())
						Helper.keyUpList(this);
					else
						Helper.keyUpScroll(this);
					break;
					
				case KEY_DOWN:
					/* DOWN */
					if(Helper.isListMode())
						Helper.keyDownList(this);
					else
						Helper.keyDownScroll(this);
					break;
				
				case KEY_ENTER:
					/* ENTER */
					this.keyEnter();
					break;
					
				case KEY_LEFT:
					/* LEFT */
					if(!(Helper.isListMode()))
						Helper.keyLeftTab(this);
					break;
					
				case KEY_RIGHT:
					/* RIGHT */
					if(!(Helper.isListMode()))
						Helper.keyRightTab(this);
					break;
			}
		}
		else
		{
			/* Onion Input screen */
			switch(key)
			{
				case KEY_CANCEL:
					this.byDateCancelHandler();
					break;
			}
		}
	}
	
	Explore.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
		
		switch(sindex)
		{
			case EXPLORE_IDX_TODAY:
				/* today */
				var params = [];
				
				this.destroy();
				
				browsr.addEvent('Explore Today', photostream.showByExploreToday, params, sindex, exploreTodayImage, 'icon');
				photostream.showByExploreToday(params);
				params = null;
				break;
			
			case EXPLORE_IDX_BY_DATE:
				/* today */
				this.showByDateInput();
				break;
		}
	}
	
	Explore.prototype.showInBrowser = function() {
		var url = 'http://www.flickr.com/explore/';
		openURL(url);
	}
	
	Explore.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Explore.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Explore.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Explore.prototype.show = function(params) {
		
		explore.initialize();
	
		Helper.setTitle('Explore');
		
		if((params["sindex"] != undefined) || (params["sindex"] != null))
			explore.lindex = params["sindex"];
		
		if(Helper.isListMode())
			explore.displayList();
		else
			explore.displayTab();

			explore.updateMenus();
	}
	
	Explore.prototype.autoFetch = function() {
		
		var sindex = 0;
		
		if(Helper.isListMode())
		{
			if(this.selector)
				sindex = this.selector.selected_index;
			else
				return;
		}
		else
		{
			sindex = this.lindex;
			this.tabs.autoFetch();
		}
		
		switch(sindex)
		{
			case EXPLORE_IDX_TODAY:
				/* today */
				flickr.interestingness_getList(user.token, null, null, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrToday, PRI_HIGH);
				break;
				
			case EXPLORE_IDX_BY_DATE:
				/* by date */
				var yday = new Date();
				yday.setDate(yday.getDate() - 1);
				
				var yyear = yday.getFullYear();
				var ymonth = yday.getMonth()+1;
				var yday = yday.getDay();
				
				if(ymonth < 10)
					ymonth = '0' + ymonth;
					
				if(yday < 10)
					yday = '0' + yday;
					
				var yday_string = yyear + '-' + ymonth + '-' + yday;
				flickr.interestingness_getList(user.token, yday_string, null, 1, (Constants.AUTO_FETCH_PHOTOCOUNT-2), this.hrByDate, PRI_HIGH);
				break;
		}
	}
	
	Explore.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Explore.prototype.displayTab = function() {
		Helper.displayTab(this, 'Explore');
			
		this.auto_disp_tid = setTimeout( function() { explore.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Explore.prototype.hrToday = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(explore)
				{
					var sindex = Helper.getSindex(explore);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == EXPLORE_IDX_TODAY)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							explore.resize();
							explore.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == EXPLORE_IDX_TODAY)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							explore.resize();
							explore.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Explore.prototype.hrByDate = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(explore)
				{
					var sindex = Helper.getSindex(explore);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == EXPLORE_IDX_BY_DATE)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var text = 'Yesterday\'s';
							
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFTextPhotoList(sindex, photo_url, text, 'large', 'right');
							explore.resize();
							explore.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == EXPLORE_IDX_TODAY)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							explore.resize();
							explore.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Explore.prototype.showByDateInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; explore.byDateCancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer(0);
			var cnt = Helper.getOnionContent(dcont);
			
			var date_picker = Helper.getDatePickerBox('Interesting photos of:', 'year', 'month', 'day', 'ok');
			cnt.appendChild(date_picker);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			var that = this;
			
			$('ok').addEventListener('click', function() { that.byDateOkHandler(); }, true);;
			$('year').addEventListener ('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('year').addEventListener ('blur',  function() { browsr.onion_cancel_ok = true;  }, false);
			$('month').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('month').addEventListener('blur',  function() { browsr.onion_cancel_ok = true;  }, false);
			$('day').addEventListener  ('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('day').addEventListener  ('blur',  function() { browsr.onion_cancel_ok = true;  }, false);
			$('year').focus();
		}
	}
	
	Explore.prototype.hideByDateInput = function() {
		if($('onion_skin'))
		{
			$('year').blur();
			$('month').blur();
			$('day').blur();
			$('ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Explore.prototype.byDateOkHandler = function() {
		if($('ok'))
		{
			/* TODO: Validation of date */
			var year = '' + $('year').value;
			var month = '' + $('month').value;
			var day = '' + $('day').value;
			
			if((month < 10) && (month.indexOf('0') == -1))
				month = '0' + month;
				
			if((day < 10) && (day.indexOf('0') == -1))
				day = '0' + day;
				
			var date_string = year + '-' + month + '-' + day;
			
			explore.hideByDateInput();
			
			var sindex = Helper.getSindex(explore);
			var params = [];
			params["date"] = date_string;
			
			explore.destroy();
			
			browsr.addEvent('Explore By Date', photostream.showByExploreDate, params, sindex, exploreByDateImage, 'icon');
			photostream.showByExploreDate(params);
			params = null;
		}
	}
	
	Explore.prototype.byDateCancelHandler = function() {
		if($('ok') && browsr.onion_cancel_ok)
		{
			explore.hideByDateInput();
		}
	}