	function Favorites() {
		/* Object for the Favorites Screen */
		this.page = [];
		this.photo = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Favorites.prototype.initialize = function() {
		browsr.screen = SCREEN_FAVORITES;

		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();
	}
	
	Favorites.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.photo = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	Favorites.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	Favorites.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpListNav(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownListNav(this);
				else
					Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	Favorites.prototype.keyEnter = function() {
		if(this.total)
		{
			var tfavorite = this.getSelectedFavorite();
			var lindex = this.lindex;
			
			var params = [];
			var tuser = new User();
			tuser.user_nsid = tfavorite.nsid;
			tuser.username = tfavorite.username;
			
			params["user"] = tuser;
				
			this.destroy();
			
			browsr.addEvent(tuser.username, contact.show, params, lindex, null, 'photoframe');
			contact.show(params);
			params = null;
		}
	}
	
	Favorites.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	Favorites.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	Favorites.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	Favorites.prototype.keyRightTab = function() {
		keyRightTabPage(this);
	}
	
	Favorites.prototype.refresh = function() {	
		if(this.page[this.cur_page])
		{
			flickr.purge_all();
			this.displayFavorites();
		}
		else
		{
			flickr.purge_all();
			var params = [];
			params["photo"] = this.photo;
			params["page"] = this.cur_page;
			
			this.showByPhoto(params);
		}
	}
	
	Favorites.prototype.showInBrowser = function() {
		if(this.photo)
		{
			var url = 'http://www.flickr.com/photos/' + this.photo.owner + '/' + this.photo.id + '/';
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Favorites.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
		
	Favorites.prototype.switchToTabs = function() {
		Helper.switchToTabsPage(this);
		this.refresh();
	}
	
	Favorites.prototype.switchToList = function() {
		Helper.switchToListPage(this);
		this.refresh();
	}
	
	Favorites.prototype.showByPhoto = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["page"] = null;
		}
		
		if((params["photo"] == undefined) || (params["photo"] == null))
			params["photo"] = null;
			
		favorites.photo = params["photo"];
		
		if((params["page"] == undefined) || (params["page"] == null))
			favorites.initialize();
		
		if(favorites.photo != null)
		{
			if(favorites.photo.title != '')
				Helper.setTitle(favorites.photo.title + '\'s favorites');
			else
				Helper.setTitle('(untitled)' + '\'s favorites');
				
			var page = params["page"];
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				favorites.lindex = params["sindex"];
				favorites.cur_page = parseInt(favorites.lindex / MAX_LIST_SIZE) + 1;
				page = favorites.cur_page;
			}
				
			/* send request to flickr */
			flickr.photos_getFavorites(user.token, favorites.photo.id, page, MAX_LIST_SIZE, favorites.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Favorites.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				var cur_page = parseInt(rsp.photo.page);
				favorites.page[cur_page] = rsp.photo;
				favorites.total = parseInt(rsp.photo.total);
				favorites.pages = parseInt(rsp.photo.pages);
				rsp = null;
				
				if((favorites.cur_page == cur_page) && favorites.total)
				{
					favorites.displayFavorites();
				}
				else if(favorites.total == 0)
				{
					favorites.displayNoFavorite();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Favorites.prototype.displayFavorites = function () {
		if(Helper.isListMode())
			this.displayFavoritesList();
		else
			this.displayFavoritesTabs();
	}
	
	Favorites.prototype.displayFavoritesList = function () {
		if(this.selector)
			this.selector.removeAll();
			
		var tfavorites = this.page[this.cur_page].person;
		
		/* add to selector */
		for(var i=0; i < tfavorites.length; i++)
		{
			var text = tfavorites[i].username;
			
			this.selector.addElement(text, contactImage, 'icon');
			
			/* send a flickr request */
			flickr.people_getInfo(user.token, tfavorites[i].nsid, this.hrFavoritesIcons, PRI_LOW);
		}
		
		Helper.postDisplayList(this);
	}
	
	Favorites.prototype.displayFavoritesTabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var tfavorite = this.page[this.cur_page].person[sindex];
		
		var ttitle = '';
		if(this.photo.title != '')
			ttitle = this.photo.title;
		else
			ttitle = '(untitled)';
		
		Helper.displayTabPage(this, this.lindex, tfavorite.username, (ttitle + '\'s Favorites`'), contactImage, 'icon');
		this.auto_disp_tid = setTimeout( function() { favorites.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
			
		Helper.postDisplayTabs(this);
	}
	
	Favorites.prototype.displayNoFavorite = function () {
		this.selector = null;
		var div = Helper.displayNoType('No favorites found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Favorites.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	Favorites.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	Favorites.prototype.hrFavoritesIcons = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(favorites && favorites.selector)
				{
					if(rsp.person)
					{
						var tcontact = rsp.person;
						var photo_url = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
						rsp = null;
						
						var set_index = -1;
						var current_page = favorites.page[favorites.cur_page].person;
						
						for(var i=0; i < current_page.length; i++)
						{
							if(current_page[i].nsid == tcontact.nsid)
							{
								set_index = i;
								favorites.selector.replaceElement(set_index, current_page[i].username, photo_url);
							}
						}
					}
				}
			}
			else
			{
				/* error */
				alert('failure: ' + rsp.msg);
			}
		}
	}

	Favorites.prototype.autoFetch = function() {
		if(this.cur_page && this.page[this.cur_page])
		{
			var tfavorite = this.getSelectedFavorite();
			
			if(!(Helper.isListMode()))
				this.tabs.autoFetch();
				
			var sindex = Helper.getSindex(this);
			
			var dateupload = new Date();
			dateupload.setTime(tfavorite.favedate * 1000);
			
			var text = 'Favorited on ' + dateupload.toLocaleDateString() + '.';
			
			Helper.setAFText(sindex, text);
			
			this.resize();
			this.scroll.updateScrollbar();
		}
	}
	
	Favorites.prototype.getSelectedFavorite = function () {
		if(Helper.isListMode())
		{
			sindex = this.selector.selected_index;
			this.lindex = this.selectedListItem();
		}
		else
		{
			this.cur_page = parseInt(this.lindex / MAX_LIST_SIZE) + 1;
			sindex = this.lindex % MAX_LIST_SIZE;
		}
		
		if(this.total)
			return this.page[this.cur_page].person[sindex];
		else
			return null;
	}
	
	