	function MiniView() {
		/* Object for the MiniView Screen */
		this.page = [];
		this.user = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		this.iindex = 0;
		this.eindex = 0;
		this.ss_tmt = 0;
		this.ss_state = true;
		this.change_tmt = 0;
		
		this.by_photos = false;
		this.by_comments = false;
		this.by_contacts = false;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	MiniView.prototype.initialize = function() {
		browsr.screen = SCREEN_MINI_VIEW;

		this.div = $('content_area');
		this.div.style.display = 'block';
		
		var that = this;
		var mini = Helper.getMiniContainer();
		mini.addEventListener('click', function() { that.showInBrowser(); }, false);
		this.div.appendChild(mini);
		
		Helper.hideNavbar();
		Helper.hideTabbar();
		Helper.hideToolbar();
		Helper.hideTitlebar();
		
		$('header_icon_bg').style.display = 'none';
		$('content_area').style.top = '-20px';
		$('viewport_area').className = 'viewport_area mini';
		$('change_mini_icon').style.display = 'block';
		clearTimeout(this.change_tmt);
		this.change_tmt = setTimeout(function() { miniview.changeType(); }, 300000);
	}
	
	MiniView.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.user = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		this.iindex = 0;
		this.eindex = 0;
		clearTimeout(this.ss_tmt);
		this.ss_tmt = 0;
		this.ss_state = true;
		clearTimeout(this.change_tmt);
		this.change_tmt = 0;
		
		this.by_photos = false;
		this.by_comments = false;
		this.by_contacts = false;
		
		Helper.destroy(this);
		Helper.showToolbar();
		Helper.showTitlebar();
		
		$('header_icon_bg').style.display = 'block';
		$('content_area').style.top = '0px';
		$('viewport_area').className = 'viewport_area';
		$('change_mini_icon').style.display = 'none';
		
		switch(browsr.bg)
		{
			case BG_NONE:
				$('viewport_area').className += ' transparent';
				break;
				
			case BG_WHITE:
				$('viewport_area').className += ' white';
				break;
				
			case BG_BLACK:
				$('viewport_area').className += ' black';
				break;
				
			case BG_CUSTOM:
				$('viewport_area').className += ' theme1';
				break;
		}
	}
	
	MiniView.prototype.resize = function() {
	}
	
	MiniView.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				break;
				
			case KEY_DOWN:
				/* DOWN */
				break;
				
			case KEY_ENTER:
				/* ENTER */
				//this.keyEnter();
				this.slideshow();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				this.keyLeft();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				this.keyRight();
				break;
		}
	}
	
	MiniView.prototype.keyLeft = function() {
		if(this.by_photos || this.by_comments)
		{
			if(this.total)
			{
				var titem = this.page[this.cur_page][this.iindex];
				
				if(titem.activity && titem.activity.event && titem.activity.event.length)
				{
					var tevent = titem.activity.event;
					
					if((this.eindex - 1) >= 0)
					{
						this.eindex = this.eindex - 1;
						this.refresh();
						return;
					}
				}
				
				/* All events for that particular item shown - move to next item */
				if((this.iindex - 1) >= 0)
				{
					this.iindex = this.iindex - 1;
					this.eindex = this.page[this.cur_page][this.iindex].activity.event.length - 1;
					this.refresh();
					return;
				}
				
				/* Page over - previous page */
				if((this.cur_page - 1) > 0)
				{
					this.cur_page -= 1;
					this.iindex = this.page[this.cur_page].length - 1;
					this.eindex = this.page[this.cur_page][this.iindex].activity.event.length - 1;
					this.refresh();
					return;
				}
			}
			
			/* Move to next kind of data */
			this.changeType();
		}
		else if(this.by_contacts)
		{
			if(this.total)
			{
				if((this.lindex % 3) != 0)
				{
					this.lindex -= (this.lindex % 3);
					this.refresh();
					return;
				}
				else if(this.lindex > 0)
				{
					this.lindex -= 3;
					this.refresh();
					return;
				}
			}
			
			/* Move to next kind of data */
			this.changeType();
		}
	}
	
	MiniView.prototype.keyRight = function() {
		if(this.by_photos || this.by_comments)
		{
			if(this.total)
			{
				var titem = this.page[this.cur_page][this.iindex];
				
				if(titem.activity && titem.activity.event && titem.activity.event.length)
				{
					var tevent = titem.activity.event;
					
					if((this.eindex + 1) < tevent.length)
					{
						this.eindex = this.eindex + 1;
						this.refresh();
						return;
					}
				}
				
				/* All events for that particular item shown - move to next item */
				if((this.iindex + 1) < this.page[this.cur_page].length)
				{
					this.iindex = this.iindex + 1;
					this.eindex = 0;
					this.refresh();
					return;
				}
				
				/* Page over - Next page */
				if((this.cur_page + 1) <= this.pages)
				{
					this.iindex = 0;
					this.eindex = 0;
					this.cur_page = this.cur_page + 1;
					this.refresh();
					return;
				}
			}
				
			/* Move to next kind of data */
			this.changeType();
		}
		else if(this.by_contacts)
		{
			if(this.total)
			{
				if((this.lindex + 3) < this.total)
				{
					this.lindex += 3;
					this.refresh();
					return;
				}
			}
			
			/* Move to next kind of data */
			this.changeType();
		}
	}
	
	MiniView.prototype.changeType = function() {
		clearTimeout(this.ss_tmt);
		flickr.purge_all();
		var params = [];
		params["user"] = this.user;
		params["page"] = 1;
		
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		this.iindex = 0;
		this.eindex = 0;
			
		/* Move to next kind of data */
		if(this.by_photos)
		{
			this.by_photos = false;
			this.showByComments(params);
		}
		else if(this.by_comments)
		{
			this.by_comments = false;
			this.showByContacts(params);
		}
		else if(this.by_contacts)
		{
			this.by_contacts = false;
			this.showByPhotos(params);
		}
		
		clearTimeout(this.change_tmt);
		this.change_tmt = setTimeout(function() { miniview.changeType(); }, 300000);
	}
	
	MiniView.prototype.refresh = function() {
		if(this.page[this.cur_page])
		{
			flickr.purge_all();
			this.displayMiniView();
		}
		else
		{
			clearTimeout(this.ss_tmt);
			flickr.purge_all();
			var params = [];
			params["user"] = this.user;
			params["page"] = this.cur_page;
			
			if(this.by_photos)
				this.showByPhotos(params);
			else if(this.by_comments)
				this.showByComments(params);
			else if(this.by_contacts)
				this.showByContacts(params);
		}
	}
	
	MiniView.prototype.showInBrowser = function() {
		if(this.by_photos || this.by_comments)
		{
			var titem = this.page[this.cur_page][this.iindex];
			
			if(titem.type == 'photo')
			{
				var url = 'http://www.flickr.com/photos/' + titem.owner + '/' + titem.id;
				openURL(url);
			}
			
			/* TODO: Cannot show sets */
		}
	}
	
	MiniView.prototype.updateMenus = function() {
	}
		
	MiniView.prototype.switchToTabs = function() {
	}
	
	MiniView.prototype.switchToList = function() {
	}
	
	MiniView.prototype.showByPhotos = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		miniview.user = params["user"];
		
		if((params["page"] == undefined) || (params["page"] == null))
			miniview.initialize();
		
		if(miniview.user != null)
		{
			miniview.by_photos = true;
				
			var page = params["page"];
			
			/* send request to flickr */
			flickr.activity_userPhotos(user.token, null, page, MAX_LIST_SIZE, miniview.handleFlickrResponseActivity, PRI_HIGH);
		}
	}
	
	MiniView.prototype.showByComments = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		miniview.user = params["user"];
		
		if((params["page"] == undefined) || (params["page"] == null))
			miniview.initialize();
		
		if(miniview.user != null)
		{
			miniview.by_comments = true;
				
			var page = params["page"];			
			
			/* send request to flickr */
			flickr.activity_userComments(user.token, page, MAX_LIST_SIZE, miniview.handleFlickrResponseActivity, PRI_HIGH);
		}
	}
	
	MiniView.prototype.showByContacts = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
			params["page"] = null;
		}
		
		if((params["user"] == undefined) || (params["user"] == null))
			params["user"] = user;
			
		miniview.user = params["user"];
		
		if((params["page"] == undefined) || (params["page"] == null))
			miniview.initialize();
		
		if(miniview.user != null)
		{
			miniview.by_contacts = true;
			
			var page = params["page"];
			
			/* 50 is the max value */
			flickr.photos_getContactsPhotos(user.token, 50, null, null, null, 'views, owner_name, date_upload', miniview.handleFlickrResponsePhotos, PRI_HIGH);
		}
	}
	
	MiniView.prototype.handleFlickrResponseActivity = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(rsp.items)
				{
					var cur_page = parseInt(rsp.items.page);
					miniview.page[cur_page] = rsp.items.item;
					miniview.total = parseInt(rsp.items.total);
					miniview.pages = parseInt(rsp.items.pages);
					rsp = null;
					
					if((miniview.cur_page == cur_page) && miniview.total)
					{
						miniview.displayMiniView();
					}
					else if(miniview.total == 0)
					{
						miniview.displayNoMiniView();
					}
				}
				else
				{
					miniview.displayNoMiniView();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	MiniView.prototype.handleFlickrResponsePhotos = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(rsp.photos)
				{
					miniview.page[miniview.cur_page] = rsp.photos.photo;
					miniview.total = parseInt(rsp.photos.total);
					miniview.pages = 1;
					rsp = null;
					
					if(miniview.total)
					{
						miniview.displayMiniView();
					}
					else
					{
						miniview.displayNoMiniView();
					}
				}
				else
				{
					miniview.displayNoMiniView();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	MiniView.prototype.displayMiniView = function () {
		if(this.by_photos || this.by_comments)
		{
			this.displayMiniViewByActivity();
			if(this.ss_state)
			{
				clearTimeout(this.ss_tmt);
				this.ss_tmt = setTimeout(function() { miniview.handleKeypress(KEY_RIGHT); }, 5000);
			}
		}
		else if(this.by_contacts)
		{
			this.displayMiniViewByPhotos();
			if(this.ss_state)
			{
				clearTimeout(this.ss_tmt);
				this.ss_tmt = setTimeout(function() { miniview.handleKeypress(KEY_RIGHT); }, 5000);
			}
		}
	}
	
	MiniView.prototype.displayMiniViewByActivity = function () {
	
		var titem = this.page[this.cur_page][this.iindex];
		
		var photo_url = '';
			
		if(titem.type == 'photo')
			photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.id, titem.secret, PHOTO_S);
		else if(titem.type == 'photoset')
			photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.primary, titem.secret, PHOTO_S);
			
		var tevent = titem.activity.event[this.eindex];
		
		var thead = tevent.username;
		
		var text = '';
		if(tevent.type == 'comment')
			text = tevent._content;
		else if(tevent.type == 'tag')
			text = 'added a tag!';
		else if(tevent.type == 'fave')
			text = 'added as a fave!';
		else if(tevent.type == 'note')
			text = 'added a note!';
			
		try {
			Helper.destroyDescendants($('mini_area'));
			
			if(photo_url)
			{
				var dimg = Helper.getDiv(null, 'gframe large');
				var img = Helper.getImg(null, 'photo large', photo_url);
				dimg.appendChild(img);
				
				$('mini_area').appendChild(dimg);
			}
			
			var thead = Helper.getP(null, 'header', thead + ' :');
			$('mini_area').appendChild(thead);
			
			/* Stripping off a tags */
			var a_re = new RegExp('<\s*\/?\s*a\s*.*?>', 'g');
			text = text.replace(a_re, "");
			
			var img_re = new RegExp('<\s*\/?\s*img\s*.*?>', 'g');
			text = text.replace(img_re, "");
			
			var nl_re = new RegExp('\\n', 'g');
			text = text.replace(nl_re, '');
			
			var ttext = Helper.getP(null, null, text);
			ttext.origText = '' + text;
			$('mini_area').appendChild(ttext);
			
			Helper.checkEllipsis(ttext, ttext.clientWidth, 50);
			
		} catch(e) { }
	}
	
	MiniView.prototype.displayMiniViewByPhotos = function () {
	
		var tphotos = this.page[this.cur_page];
			
		var photo_url = [];
		
		for(var i = this.lindex; (i < this.total) && (i < (this.lindex + 3));  i++)
		{
			var tphoto = tphotos[i];
			
			photo_url.push(flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S));
		}
			
		try {
			Helper.destroyDescendants($('mini_area'));
			if(photo_url)
			{
				for(var i=0; i<photo_url.length; i++)
				{
					var dimg = Helper.getDiv(null, 'gframe large');
					var img = Helper.getImg(null, 'photo large', photo_url[i]);
					img.index = this.lindex + i;
					
					img.addEventListener('click', cbMiniImage, false);
					
					dimg.appendChild(img);
					
					$('mini_area').appendChild(dimg);
				}
			}
		} catch(e) { }
	}
	
	cbMiniImage = function(e) {		
		var tphoto = miniview.page[miniview.cur_page][e.currentTarget.index];
		var url = 'http://www.flickr.com/photos/' + tphoto.owner + '/' + tphoto.id;
		openURL(url);
		e.stopPropagation();
	}
	
	MiniView.prototype.displayNoMiniView = function () {
		Helper.destroyDescendants($('mini_area'));
		var p = Helper.getP(null, 'header', 'No Recent Activity found!');
		$('mini_area').appendChild(p);
	}
	
	MiniView.prototype.slideshow = function () {
		if(this.ss_state)
		{
			this.ss_state = false;
			clearTimeout(this.ss_tmt);
		}
		else
		{
			this.ss_state = true;
			clearTimeout(this.ss_tmt);
			this.ss_tmt = setTimeout(function() { miniview.handleKeypress(KEY_RIGHT); }, 5000);
		}
	}
	
	
	
	
	