
	function cbMoveToolRight() {
		var that = cbMoveToolRight.that;
		that.moveRight();
	}
	
	function cbMoveToolLeft() {
		var that = cbMoveToolLeft.that;
		that.moveLeft();
	}
	
	function Option() {
		/* Define the properties */
		this.selected_index = 0;
		this.sub_selected_index = 0;
		this.scroll = null;
		this.div_array = [];
		
		/* this is jus for optimization */
		this.count = 0;
		this.visibleCount = 0;
		this.max_icons = 0;
		this.arrows = false;
		this.subarrows = false;
		
		this.div = $('tool_pane');		
		this.parent = $('tool_bar');
		
		this.subdiv = $('subtool_pane');
		this.subparent = $('subtool_bar');
		
		cbMoveToolLeft.that = this;
		cbMoveToolRight.that = this;
		
		$('tool_left').addEventListener('click', cbMoveToolRight, false);

		$('tool_right').addEventListener('click', cbMoveToolLeft, false);
	}
	
	Option.prototype.addTo = function(div) {
		if($(div))
		{
			$(div).appendChild(this.div);
		}
	}
	
	Option.prototype.add = function(div) {
		if(div)
		{
			this.div_array.push(div);
			div.sindex = this.count;
			this.count++;
			this.visibleCount++;
		}
	}
	
	Option.prototype.removeAll = function() {
		Helper.destroyDescendants(this.div);
		this.div_array = [];
		this.count = 0;
		
		$('tool_left').removeEventListener('click', cbMoveToolRight, false);
		$('tool_right').removeEventListener('click', cbMoveToolLeft, false);
	}

	/* TODO: Useless Function : REMOVE THIS */
/*	
	Option.prototype.getOptionById = function(id) {
		var i=0;
		for(i=0; i < this.count; i++)
		{
			if(this.div_array[i].item.id == id)
				return this.div_array[i].item;
		}
		return null;
	}
	
	Option.prototype.getSubOptionById = function(id, parent) {
		var i=0;
		
		for(i=0; i < parent.subitems.length; i++)
		{
			if(parent.subitems[i].id == id)
				return parent.subitems[i];
		}
		return null;
	}
*/

	Option.prototype.getSubOptionByIndex = function(index) {
		var parent = this.div_array[this.selected_index].item;
		
		if(parent && parent.subitems && (index < parent.subitems.length))
			return parent.subitems[index];
		else
			return null;
	}

	Option.prototype.select = function(index) {
		if(index < this.count)
		{
			if(this.selected_index >= 0)
				this.deselect(this.selected_index);
				
			this.selected_index = index;
			$('option_slider_' + index).style.display = 'block';
			
			if(this.div_array[index].item.callback)
			{
				this.div_array[index].item.callback();
			}
			
			//this.updateOption();
		}
	}

	Option.prototype.subSelect = function(index) {
		if(index < this.count)
		{
			this.subDeselect(this.sub_selected_index);
			this.sub_selected_index = index;
			$('suboption_slider_' + index).style.display = 'block';
			
			var si = this.getSubOptionByIndex(index);
			if(si)
				si.select_bydefaut = true;
			
			var div = $('suboption_' + index);
			
			if(div.item.callback)
			{
				div.item.callback();
			}
			
			//this.updateOption();
		}
	}
	
	Option.prototype.selectById = function(id) {
		var index = 0;
		for(index=0; index < this.count; index++)
		{
			var div = $('option_' + index);
			if(div.item && (div.item.id == id))
			{
				this.select(index);
			}
		}
	}
	
	Option.prototype.deselect = function(index) {
		if((index < this.count)) // && (index >= 0))
		{
			this.selected_index = -1;
			var that = this;
			
			/* To provide some animation */
			//setTimeout(function() { 
				$('option_slider_' + index).style.display = 'none';
				Helper.destroyDescendants(that.subdiv);
				that.subparent.style.display = 'none';
			//}, 50);
		}
	}
	
	Option.prototype.subDeselect = function(index) {
		if(index < this.count)
		{
			$('suboption_slider_' + index).style.display = 'none';
			/* find the menu item and change the selection */
			
			var si = this.getSubOptionByIndex(index);
			if(si)
				si.select_bydefaut = false;
		}
	}
	
	Option.prototype.deselectById = function(id) {
		var index = 0;
		for(index=0; index < this.count; index++)
		{
			var div = $('option_' + index);
			if(div.item && (div.item.id == id))
			{
				this.deselect(index);
			}
		}
	}
	
	Option.prototype.show = function(id) {
		var index = 0;
		for(index=0; index < this.count; index++)
		{
			var div = $('option_' + index);
			if(div.item && (div.item.id == id))
			{
				if(!Helper.isVisible('option_' + index))
				{	
					$('option_' + index).style.display = 'block';
					this.visibleCount += 1;
					this.div.style.width = (this.visibleCount * TAB_ICON_WIDTH) + 'px';
					
					this.updateOption();
				}
				break;
			}
		}
	}
	
	Option.prototype.hide = function(id) {
		var index = 0;
		for(index=0; index < this.count; index++)
		{
			var div = $('option_' + index);
			if(div.item && (div.item.id == id))
			{
				if(Helper.isVisible('option_' + index))
				{
					if(index == this.selected_index)
						this.deselect(index);
					
					$('option_' + index).style.display = 'none';
					this.visibleCount -= 1;
					this.div.style.width = (this.visibleCount * TAB_ICON_WIDTH) + 'px';
					
					this.updateOption();
				}
				break;
			}
		}
	}
	
	Option.prototype.resize = function() {
	}
	
	Option.prototype.updateOption = function() {
		
		/* Bring the icon to visible area */
		if(this.visibleCount >= this.max_icons)
		{
			this.arrows = true;
			
			this.div.style.left =  ARROW_WIDTH + 'px';
			
			/* Check the arrows */
			if((0 - this.div.offsetLeft) > 0)
				$('tool_left').style.display = 'block';
			else
				$('tool_left').style.display = 'none';
			
			if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
				$('tool_right').style.display = 'block';
			else
				$('tool_right').style.display = 'none';
		}
		else
		{
			this.arrows = false;
			this.div.style.left = ((this.parent.clientWidth - (this.visibleCount * TAB_ICON_WIDTH)) / 2) + 'px';
			$('tool_left').style.display = 'none';
			$('tool_right').style.display = 'none';
		}
	}
	
	Option.prototype.moveRight = function() {
		this.div.style.left = this.div.offsetLeft + TAB_ICON_WIDTH;
		
		if((0 - this.div.offsetLeft) > 0)
			$('tool_left').style.display = 'block';
		else
			$('tool_left').style.display = 'none';
		
		if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
			$('tool_right').style.display = 'block';
		else
			$('tool_right').style.display = 'none';
	}
	
	Option.prototype.moveLeft = function() {
		this.div.style.left = this.div.offsetLeft - TAB_ICON_WIDTH;
		
		if((0 - this.div.offsetLeft) > 0)
			$('tool_left').style.display = 'block';
		else
			$('tool_left').style.display = 'none';
		
		if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
			$('tool_right').style.display = 'block';
		else
			$('tool_right').style.display = 'none';
	}
	
	Option.prototype.addArray = function(tab_array) {
		if(tab_array)
		{
			var tableTab = Helper.getTable(null, null);
			var trTab = Helper.getTr(null, null);
			
			for(var i=0; i < tab_array.length; i++)
			{	
				var tdTab = Helper.getTd(null, null);
				var divTab = this.addElement(tab_array[i]);
				
				tdTab.appendChild(divTab);
				trTab.appendChild(tdTab);
			}
			
			tableTab.appendChild(trTab);
			this.div.appendChild(tableTab);
		
			var index = this.selected_index;
			this.max_icons = this.parent.clientWidth / TAB_ICON_WIDTH;
			
			
			this.div.style.left           = '0px';
			$('tool_left').style.display  = 'none';
			$('tool_right').style.display = 'none';
			
			this.subdiv.style.left           = '0px';
			$('subtool_left').style.display  = 'none';
			$('subtool_right').style.display = 'none';
			
			this.subparent.style.display = 'none';
			
			this.div.style.width = (this.count * TAB_ICON_WIDTH) + 'px';
			
			if(this.count >= this.max_icons)
			{
				/* Accounting for the arrows */
				this.arrows = true;
				this.div.style.left = ARROW_WIDTH + 'px';
			}
			else
			{
				this.arrows = false;
				this.div.style.left = ((this.parent.clientWidth - (this.count * TAB_ICON_WIDTH)) / 2) + 'px';
			}
			
			this.updateOption();
		}
	}
	
	Option.prototype.addElement = function(elt) {
		var id = this.count;
		
		var divEl = Helper.getDiv('option_' + id, 'menu_bar_bottom_icon');
		var imgEl = Helper.getImg('option_img_' + id, null, elt.unselected);
		
		var divSlider = Helper.getDiv('option_slider_' + id, 'menu_bar_bottom_slider');
		var imgSlider = Helper.getImg('option_slider_img_' + id, null, elt.selected);
		
		divSlider.appendChild(imgSlider);
		divSlider.style.display = 'none';
		
		divEl.appendChild(imgEl);
		divEl.appendChild(divSlider);
		
		divEl.item = elt;
		
		var that = this;
		
		if(elt.subitems)
		{
			divEl.addEventListener('click', function(e) {
															if(that.selected_index == id)
																that.deselect(id);
															else
																that.select(id);	
															e.stopPropagation();
														}, false);
		}
		else
		{
			divEl.addEventListener('click', function(e) {
															that.select(id);	
															e.stopPropagation();
														}, false);
		}
		
		this.add(divEl);
		
		return divEl;
	}
	
	Option.prototype.showSubItems = function() {
		/* assumption: this.selected_index holds the currently selected item */
		
		var div = this.div_array[this.selected_index];
		
		if(div && div.item.subitems && div.item.subitems.length)
		{
			this.subparent.style.display = 'block';
			this.addSubArray(div.item.subitems);
		}
	}
	
	Option.prototype.addSubArray = function(tab_array) {
		if(tab_array)
		{
			var tableTab = Helper.getTable(null, null);
			var trTab = Helper.getTr(null, null);
			var visCount = 0;
			
			for(var i=0; i < tab_array.length; i++)
			{
				if(tab_array[i].visible)
				{
					var tdTab = Helper.getTd(null, null);
					var divTab = this.addSubElement(tab_array[i], i);
					
					tdTab.appendChild(divTab);
					trTab.appendChild(tdTab);
					visCount++;
				}
			}
			
			tableTab.appendChild(trTab);
			this.subdiv.appendChild(tableTab);
			
			this.subdiv.style.left           = '0px';
			$('subtool_left').style.display  = 'none';
			$('subtool_right').style.display = 'none';
			
			this.subdiv.style.width = (visCount * TAB_ICON_WIDTH) + 'px';
			
			if(visCount > this.max_icons)
			{
				/* Accounting for the arrows */
				this.subarrows = true;
				this.subdiv.style.left = ARROW_WIDTH + 'px';
			}
			else
			{
				this.subarrows = false;
				this.subdiv.style.left = ((this.subparent.clientWidth - (visCount * TAB_ICON_WIDTH)) / 2) + 'px';
			}
		}
	}
	
	Option.prototype.addSubElement = function(elt, id) {
		
		var divEl = Helper.getDiv('suboption_' + id, 'menu_bar_bottom_icon');
		var imgEl = Helper.getImg('suboption_img_' + id, null, elt.unselected);
		
		var divSlider = Helper.getDiv('suboption_slider_' + id, 'menu_bar_bottom_option_slider');
		var imgSlider = Helper.getImg('suboption_slider_img_' + id, null, elt.selected);
		
		divSlider.appendChild(imgSlider);
		
		if(!elt.select_bydefaut)
			divSlider.style.display = 'none';
		else
			this.sub_selected_index = id;
		
		divEl.appendChild(imgEl);
		divEl.appendChild(divSlider);
		
		divEl.item = elt;
		
		var that = this;
		
		divEl.addEventListener('click', function(e) {
														that.subSelect(id);	
	
														/* find the parent and deslect it */
														that.deselect(that.selected_index);
													}, false);
		
		return divEl;
	}
	
	
	
	
	
	
	
	
	
	
	
	