	function Photo() {
		/* Object for the Photo Screen */
		this.photo = null;
		this.user_id = '';
		this.info = null;
		this.set = null;
		this.favs = null;
		this.comments = null;
		this.sizes = null;
		this.exif = null;
		this.owner = null;
		this.lindex = 0;
		this.elements = null;
		this.tabber = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	Photo.prototype.initialize = function() {
		browsr.screen = SCREEN_PHOTO;
		
		this.elements = tabs_photo;
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Photo.prototype.destroy = function() {
		flickr.purge_all();
		
		this.photo = null;
		this.user_id = '';
		this.info = null;
		this.set = null;
		this.favs = null;
		this.comments = null;
		this.sizes = null;
		this.exif = null;
		this.lindex = 0;
		this.owner = null;
		this.tabs = null;
		
		this.tabber.removeAll();
			
		Helper.destroy(this);
	}
	
	Photo.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Photo.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	Photo.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);

		var ttitle = '';
		if(this.photo.title != '')
			ttitle = this.photo.title;
		else
			ttitle = '(untitled)';
				
		switch(sindex)
		{
			case PHOTO_IDX_PHOTO:
				/* photo */
				var params = [];
				params["photo"] = this.photo;
				var tphoto = this.photo;
				var photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
				
				this.destroy();
				
				browsr.addEvent('Photo!', sphoto.show, params, sindex, photo_url, 'photoframe');
				sphoto.show(params);
				params = null;
				break;
				
			case PHOTO_IDX_DESCRIPTION:
				/* description */
				var params = [];
				params["photo"] = this.photo;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Description', description.showByPhoto, params, sindex, descriptionImage, 'icon');
				description.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_COMMENTS:
				/* comments */
				var params = [];
				params["photo"] = this.photo;
				params["user_id"] = this.user_id;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Comments', comments.showByPhoto, params, sindex, commentsImage, 'icon');
				comments.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_FAVORITES:
				/* favorites */
				var params = [];
				params["photo"] = this.photo;
				params["user_id"] = this.user_id;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Favorites', favorites.showByPhoto, params, sindex, favoritesImage, 'icon');
				favorites.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_TAGS:
				/* tags */
				var params = [];
				params["photo"] = this.photo;
				params["user_id"] = this.user_id;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Tags', tags.showByPhoto, params, sindex, tagsImage, 'icon');
				tags.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_SETS:
				/* sets */
				var params = [];
				params["photo"] = this.photo;
				params["user_id"] = this.user_id;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Sets', sets.showByPhoto, params, sindex, setsImage, 'icon');
				sets.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_NOTES:
				/* notes */
				var params = [];
				params["photo"] = this.photo;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Notes', notes.showByPhoto, params, sindex, notesImage, 'icon');
				notes.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_EXIF:
				/* exif */
				var params = [];
				params["photo"] = this.photo;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Exif', Description.showByExif, params, sindex, exifImage, 'icon');
				description.showByExif(params);
				params = null;
				break;
				
			case PHOTO_IDX_SIZES:
				/* sizes */
				var params = [];
				params["photo"] = this.photo;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Sizes', sizes.showByPhoto, params, sindex, sizesImage, 'icon');
				sizes.showByPhoto(params);
				params = null;
				break;
				
			case PHOTO_IDX_OWNER:
				/* owner */
				var params = [];
				var tuser = new User();
				tuser.user_nsid = this.user_id;
				tuser.username = this.photo.ownername;
				params["user"] = tuser;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Owner', contact.show, params, sindex, ownerImage, 'icon');
				contact.show(params);
				params = null;
				break;
		}
	}
	
	Photo.prototype.refresh = function() {
		this.destroy();
		
		var params = [];
		params["photo"] = this.photo;
		params["user_id"] = this.user_id;
		
		this.show(params);
	}
	
	Photo.prototype.showInBrowser = function() {
		if(this.photo)
		{
			var url = 'http://www.flickr.com/photos/' + this.photo.owner + '/' + this.photo.id;
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Photo.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
			
			if(this.photo)
			{
				if(bmarks.findPhotoInBmarks(this.photo.id))
				{
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
				}
				else
				{	
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
				}
			}
			else
			{
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Photo.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Photo.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Photo.prototype.show = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["user_id"] = null;
		}
		else if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
		
		if((params["user_id"] == undefined) || (params["user_id"] == null))
		{
			params["user_id"] = user.user_nsid;
		}
		
		photo.initialize();
		
		photo.photo = params["photo"];
		photo.user_id = params["user_id"];
		
		if(photo.photo != null)
		{	
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				photo.lindex = params["sindex"];
				
			/* Shoud photo - photo's title here */
			if(photo.photo.title != '')
			{
				Helper.setTitle('Photo: ' + photo.photo.title);
			}
			else
			{
				Helper.setTitle('Photo: (untitled)');
			}
			
			if(Helper.isListMode())
				photo.displayList();
			else
				photo.displayTab();
			
			photo.updateMenus();
		}
	}
	
	Photo.prototype.showByBookmark = function(params) {
		if(params == null)
		{
			params["photo_id"] = null;
			params["photo_title"] = null;
		}
		
		if((params["photo_id"] == undefined) || (params["photo_id"] == null))
			params["photo_id"] = null;
		
		if((params["photo_title"] == undefined) || (params["photo_title"] == null))
			params["photo_title"] = null;
			
		if(params["photo_title"])
		{
			Helper.setTitle('Photo: ' + params["photo_title"]);
		}
			
		if(params["photo_id"])
		{
			flickr.photos_getInfo(user.token, params["photo_id"], null, photo.hrShowByBookmark, PRI_HIGH);
		}
	}
	
	Photo.prototype.hrShowByBookmark = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo && rsp.photo)
				{
					var tphoto = rsp.photo;
					var params = [];
					
					params["photo"] = { id: tphoto.id, 
										owner: tphoto.owner.nsid, 
										secret: tphoto.secret, 
										server: tphoto.server,
										farm: tphoto.farm, 
										title: tphoto.title._content, 
										ispublic: tphoto.visibility.ispublic,
										isfriend: tphoto.visibility.isfriend,
										isfamily: tphoto.visibility.isfamily,
										views: tphoto.views,
										ownername: tphoto.owner.username,
										dateupload: tphoto.dateuploaded };
					params["user_id"] = rsp.photo.owner.nsid;
					rsp = null;
					
					photo.show(params);
					params = null;
				}
			}
			else
			{
				/* error */
				alert(rsp.message);
			}
		}
	}
	
	Photo.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Photo.prototype.displayTab = function() {
		var subtitle = '';
		
		if(this.photo.title)
			subtitle = this.photo.title;
		else
			subtitle = '(untitled)';
		
		Helper.displayTab(this, subtitle);
		this.auto_disp_tid = setTimeout( function() { photo.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Photo.prototype.autoFetch = function() {
		if(this.photo)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case PHOTO_IDX_PHOTO:
					/* photo */
					this.displayPhoto(sindex);
					break;
					
				case PHOTO_IDX_DESCRIPTION:
					/* description */
					if(this.info)
					{
						this.displayDescription(sindex);
					}
					else
					{
						flickr.photos_getInfo(user.token, this.photo.id, this.photo.secret, this.hrDescription, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_COMMENTS:
					/* comments */
					if(this.comments)
					{
						this.displayComments(sindex);
					}
					else
					{
						flickr.photos_comments_getList(user.token, this.photo.id, null, null, this.hrComments, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_FAVORITES:
					/* favorites */
					if(this.favs)
					{
						this.displayFavorites(sindex);
					}
					else
					{
						flickr.photos_getFavorites(user.token, this.photo.id, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrFavorites, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_TAGS:
					/* tags */
					if(this.info)
					{
						this.displayTags(sindex);
					}
					else
					{
						flickr.photos_getInfo(user.token, this.photo.id, this.photo.secret, this.hrTags, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_SETS:
					/* sets */
					if(this.set)
					{
						this.displaySets(sindex);
					}
					else
					{
						flickr.photos_getAllContexts(user.token, this.photo.id, this.hrSets, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_NOTES:
					/* notes */
					if(this.info)
					{
						this.displayNotes(sindex);
					}
					else
					{
						flickr.photos_getInfo(user.token, this.photo.id, this.photo.secret, this.hrNotes, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_EXIF:
					/* exif */
					if(this.exif)
					{
						this.displayExif(sindex);
					}
					else
					{
						flickr.photos_getExif(user.token, this.photo.id, this.photo.secret, this.hrExif, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_SIZES:
					/* sizes */
					if(this.sizes)
					{
						this.displaySizes(sindex);
					}
					else
					{
						flickr.photos_getSizes(user.token, this.photo.id, this.hrSizes, PRI_HIGH);
					}
					break;
					
				case PHOTO_IDX_OWNER:
					/* owner */
					if(this.owner)
					{
						this.displayOwner(sindex);
					}
					else
					{
						flickr.people_getInfo(user.token, this.user_id, this.hrOwner, PRI_HIGH);
					}
					break;
			}
		}
	}
	
	Photo.prototype.displayPhoto = function(rsp) {
		if(photo && photo.photo)
		{
			var sindex = Helper.getSindex(photo);
			var tphoto = photo.photo;
			
			if(sindex == PHOTO_IDX_PHOTO)
			{
				/* TODO: size shud be increased */
				var photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
				
				Helper.setAFPhoto(sindex, photo_url, 'large');
			
				photo.resize();
				photo.scroll.updateScrollbar();
			}
		}
	}
	
	Photo.prototype.hrInfo = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					photo.info = rsp.photo;
					rsp = null;
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.hrDescription = function(rsp) {
		photo.hrInfo(rsp);
		
		if(photo && photo.info)
		{
			var sindex = Helper.getSindex(photo);
			
			if(sindex == PHOTO_IDX_DESCRIPTION)
			{
				photo.displayDescription(sindex);
			}
		}
	}
	
	Photo.prototype.displayDescription = function(sindex) {
		var text = '';
		
		if(photo.info.description)
			text = photo.info.description._content;
			
		if(text.length > MAX_AF_TEXT_LENGTH)
		{
			text = text.substr(0, MAX_AF_TEXT_LENGTH);
			text = text + '...';
		}
			
		if(text != '')
			Helper.setAFText(sindex, text);
		else
			Helper.setAFNoResult(sindex, 'No description available!');
		
		photo.resize();
		photo.scroll.updateScrollbar();	
	}
	
	Photo.prototype.hrNotes = function(rsp) {
		photo.hrInfo(rsp);
		
		if(photo && photo.info)
		{
			var sindex = Helper.getSindex(photo);
			
			if(sindex == PHOTO_IDX_NOTES)
			{
				photo.displayNotes(sindex);
			}
		}
	}
	
	Photo.prototype.displayNotes = function(sindex) {
		var text = '';
		var tnotes = photo.info.notes;
		
		if(tnotes && tnotes.note && tnotes.note.length)
			text = tnotes.note.length + ' notes.';
			
		/* can add authornames too.. tnotes.note[i].authorname */
			
		if(text != '')
			Helper.setAFText(sindex, text);
		else
			Helper.setAFNoResult(sindex, 'No notes available!');
		
		photo.resize();
		photo.scroll.updateScrollbar();
	}
	
	Photo.prototype.hrTags = function(rsp) {
		photo.hrInfo(rsp);
		
		if(photo && photo.info)
		{
			var sindex = Helper.getSindex(photo);
			
			if(sindex == PHOTO_IDX_TAGS)
			{
				photo.displayTags(sindex);
			}
		}
	}
	
	Photo.prototype.displayTags = function(sindex) {
		var text = [];
		var ttags = photo.info.tags;
		
		if(ttags && ttags.tag && ttags.tag.length)
		{
			for(var i = 0; (i < ttags.tag.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
				text[i] = ttags.tag[i].raw;
		}
			
		if(text.length)
			Helper.setAFTextList(sindex, text);
		else
			Helper.setAFNoResult(sindex, 'No tags available!');
		
		photo.resize();
		photo.scroll.updateScrollbar();
	}
	
	Photo.prototype.hrSets = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.set)
					{
						photo.set = rsp.set;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_SETS)
						{
							photo.displaySets(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_SETS)
						{
							photo.displaySets(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.displaySets = function(sindex) {
		var text = [];
		var tsets = photo.set;
		
		if(tsets && tsets.length)
		{
			for(var i=0; (i < tsets.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
				text[i] = tsets[i].title;
		}
		
		if(text.length)
			Helper.setAFTextList(sindex, text);
		else
			Helper.setAFNoResult(sindex, 'Doesn\'t belong to any set!');
		
		this.resize();
		this.scroll.updateScrollbar();
	}
		
	Photo.prototype.hrFavorites = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.photo && rsp.photo.person && rsp.photo.person.length)
					{
						photo.favs = rsp.photo.person;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_FAVORITES)
						{
							photo.displayFavorites(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_FAVORITES)
						{
							photo.displayFavorites(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.displayFavorites = function(sindex) {
	
		var thead = 'Favorites by';
		var tfavs = photo.favs;
		var tlist = [];
		
		if(tfavs && tfavs.length)
		{	
			for(var i=0; (i < tfavs.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
				tlist[i] = tfavs[i].username;
		}
		
		if(tlist.length)
			Helper.setAFTextListHeader(sindex, thead, tlist);
		else
			Helper.setAFNoResult(sindex, 'Hasn\'t been favorited so far!');
		
		this.resize();
		this.scroll.updateScrollbar();		
	}
	
	Photo.prototype.hrComments = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.comments && rsp.comments.comment && rsp.comments.comment.length)
					{
						photo.comments = rsp.comments.comment;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_COMMENTS)
						{
							photo.displayComments(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_COMMENTS)
						{
							photo.displayComments(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.displayComments = function(sindex) {
	
		var thead = 'Comments by';
		var tcomments = photo.comments;
		var tlist = [];
		
		if(tcomments && tcomments.length)
		{	
			for(var i=0; (i < tcomments.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
				tlist[i] = tcomments[i].authorname;	
		}
			
		if(tlist.length)
			Helper.setAFTextListHeader(sindex, thead, tlist);
		else
			Helper.setAFNoResult(sindex, 'Hasn\'t been commented so far!');
		
		this.resize();
		this.scroll.updateScrollbar();		
	}

	Photo.prototype.hrSizes = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.sizes && rsp.sizes.size && rsp.sizes.size.length)
					{
						photo.sizes = rsp.sizes.size;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_SIZES)
						{
							photo.displaySizes(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_SIZES)
						{
							photo.displaySizes(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.displaySizes = function(sindex) {
	
		var thead = 'Available sizes';
		var tsizes = photo.sizes;
		var tlist = [];
		
		if(tsizes && tsizes.length)
		{	
			for(var i=0; (i < tsizes.length); i++)
				tlist[i] = tsizes[i].width + ' X ' + tsizes[i].height;
		}
		
		if(tlist.length)
			Helper.setAFTextListHeader(sindex, thead, tlist);
		else
			Helper.setAFNoResult(sindex, 'No size available!');
		
		this.resize();
		this.scroll.updateScrollbar();		
	}

	Photo.prototype.hrExif = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.photo && rsp.photo.exif && rsp.photo.exif.length)
					{
						photo.exif = rsp.photo.exif;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_EXIF)
						{
							photo.displayExif(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_EXIF)
						{
							photo.displayExif(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
				photo.exif = null;

				var sindex = Helper.getSindex(photo);
				
				if(sindex == PHOTO_IDX_EXIF)
				{
					photo.displayExif(sindex);
				}
			}
		}
	}
	
	Photo.prototype.displayExif = function(sindex) {
	
		var text = [];
		var texif = photo.exif;
		
		if(texif && texif.length)
		{
			/* Make, Model, Software, ExposureTime, FNumber, ExposureProgram, ISO, FocalLength */
			
			for(var i=0; (i < texif.length); i++)
			{
				if(texif[i].tagspace == 'IFD0')
				{
					if(texif[i].tag == 'Make')
						text[text.length] = texif[i].raw._content;
					else if(texif[i].tag == 'Model')
						text[text.length] = texif[i].raw._content;
					else if(texif[i].tag == 'Software')
						text[text.length] = texif[i].raw._content;
				}
				else if(texif[i].tagspace == 'ExifIFD')
				{
					if(texif[i].tag == 'ExposureTime')
						text[text.length] = texif[i].raw._content + ' sec';
					else if(texif[i].tag == 'FNumber')
					{
						if(texif[i].clean)
							text[text.length] = texif[i].clean._content;
						else
							text[text.length] = texif[i].raw._content;
					}
					else if(texif[i].tag == 'ISO')
						text[text.length] = ' ISO ' + texif[i].raw._content;
					else if(texif[i].tag == 'FocalLength')
						text[text.length] = texif[i].raw._content;
				}
			}
			
			Helper.setAFTextList(sindex, text);
		}
		else
		{
			Helper.setAFNoResult(sindex, 'No Exif data available!');
		}
		
		this.resize();
		this.scroll.updateScrollbar();		
	}
	
	Photo.prototype.hrOwner = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(photo)
				{
					if(rsp.person)
					{
						photo.owner = rsp.person;
						rsp = null;
						
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_OWNER)
						{
							photo.displayOwner(sindex);
						}
					}
					else
					{
						var sindex = Helper.getSindex(photo);
							
						if(sindex == PHOTO_IDX_OWNER)
						{
							photo.displayOwner(sindex);
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Photo.prototype.displayOwner = function(sindex) {
	
		var text = '';
		var towner = photo.owner;
		
		if(towner)
		{
			var text = [];
			var photo_url = flickr.build_buddy_icon_url(towner.iconserver, towner.iconfarm, towner.nsid);
			text[text.length] = 'Uploaded by ' + photo.photo.ownername;
			
			var dateupload = null;
			if(photo.photo.dateupload)
			{				
				dateupload = new Date();
				dateupload.setTime(photo.photo.dateupload * 1000);
				text[text.length] = 'on ' + dateupload.toLocaleDateString() + '.';
			}
			
			Helper.setAFPhotoTextList(sindex, photo_url, text, 'small', 'right');
		}
		else
		{
			Helper.setAFNoResult(sindex, 'No owner information available!');
		}
		
		this.resize();
		this.scroll.updateScrollbar();		
	}
	
	Photo.prototype.addToBookmarks = function() {
		if(bmarks && this && this.photo)
		{
			var ttitle = '';
			
			if(this.photo.title != '')
				ttitle = this.photo.title;
			else
				ttitle = '(untitled)';
			
			bmarks.addPhotoToBmarks( {id:this.photo.id, title:ttitle} );
		}
	}
	
	Photo.prototype.removeFromBookmarks = function() {
		if(bmarks && this && this.photo)
		{
			bmarks.removePhotoFromBmarks(this.photo.id);
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
