	function PredefinedScreen() {
		/* Object for the PredefinedScreen Screen */
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	PredefinedScreen.prototype.initialize = function() {
		Helper.initialize(this);
		
		/* This part should go into initialize */
		this.tabber = new Tabber();
		
		var tabber_array = [];
		
		for(var i=0; i < this.elements.length; i++)
		{
			tabber_array[i] = new TabberItem(this.elements[i].name, this.elements[i].img, this.elements[i].img);
		}
		
		this.tabber.addArray(tabber_array);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	PredefinedScreen.prototype.destroy = function() {
		flickr.purge_all();
		
		this.user_nsid = 0;
		this.lindex = 0;
		this.tabs = null;
		
		Helper.destroy(this);
	}
	
	PredefinedScreen.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	PredefinedScreen.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	PredefinedScreen.prototype.keyEnter = function() {	
		var sindex = Helper.getSindex(this);
		
		if(this.user_nsid != 0)
		{
			switch(sindex)
			{
				case HOME_IDX_PHOTOSTREAM:
					/* photostream */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('Your Photostream', photostream.showByUser, params, sindex, photostreamImage, 'icon');
					photostream.showByUser(params);
					params = null;
					break;
					
				case HOME_IDX_CONTACTS:
					/* contacts */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('Your Contacts', contacts.showByUser, params, sindex, contactsImage, 'icon');
					contacts.showByUser(params);
					params = null;
					break;
					
				case HOME_IDX_SETS:
					/* sets */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('My Sets', sets.showByUser, params, sindex, setsImage, 'icon');
					sets.showByUser(params);
					params = null;
					break;
					
				case HOME_IDX_COLLECTIONS:
					/* collections */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('My Collections', collections.showByUser, params, sindex, collectionsImage, 'icon');
					collections.showByUser(params);
					params = null;
					break;
					
				case HOME_IDX_TAGS:
					/* tags */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('My Tags', tags.showByUser, params, sindex, tagsImage, 'icon');
					tags.showByUser(params);
					params = null;
					break;
					
				case HOME_IDX_FAVORITES:
					/* favorites */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('My Favorites', photostream.showByFavorites, params, sindex, favoritesImage, 'icon');
					photostream.showByFavorites(params);
					params = null;
					break;
					
				case HOME_IDX_PROFILE:
					/* profile */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('My Profile', description.showByProfile, params, sindex, profileImage, 'icon');
					description.showByProfile(params);
					params = null;
					break;
					
				case HOME_IDX_RECENT_ACTIVITY:
					/* recent activity */
					this.destroy();
					
					var params = [];
					params["user"] = user;
					
					browsr.addEvent('Recent Activity', recent.show, params, sindex, recentActivityImage, 'icon');
					recent.show(params);
					params = null;
					break;
					
				case HOME_IDX_BOOKMARKS:
					/* bookmarks */
					this.destroy();
					
					var params = [];
					
					browsr.addEvent('Bookmarks', bookmarksmenu.show, params, sindex, bookmarksImage, 'icon');
					bookmarksmenu.show(params);
					params = null;
					break;
				
				case HOME_IDX_SEARCH:
					/* search */
					this.destroy();
					
					var params = [];
					
					browsr.addEvent('Search', search.show, params, sindex, searchImage, 'icon');
					search.show(params);
					params = null;
					break;
					
				case HOME_IDX_EXPLORE:
					/* explore */
					this.destroy();
					
					var params = [];
					
					browsr.addEvent('Explore', explore.show, params, sindex, exploreImage, 'icon');
					explore.show(params);
					params = null;
					break;
			}
		}
		else
		{
			switch(sindex + 7)
			{
				case HOME_IDX_SEARCH:
					/* search */
					break;
					
				case HOME_IDX_EXPLORE:
					/* explore */
					break;
			}
		}
	}
	
	PredefinedScreen.prototype.refresh = function() {
		this.destroy();
		
		var params = [];
		params["user_nsid"] = user.user_nsid;
		
		this.show(params);
	}
	
	PredefinedScreen.prototype.showInBrowser = function() {
		widget.openURL(encodeURI('http://www.flickr.com/'));
	}
	
	PredefinedScreen.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
	}
	
	PredefinedScreen.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	PredefinedScreen.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	PredefinedScreen.prototype.show = function(params) {
		if(params)
			home.user_nsid = params["user_nsid"];
		else
			home.user_nsid = 0;
		
		home.initialize();
		
		if(home.user_nsid == user.user_nsid)
		{
			Helper.setTitle('Welcome ' + user.username + '!');
		}
		else
		{
			Helper.setTitle('Welcome');
		}
		
		if((params["sindex"] != undefined) || (params["sindex"] != null))
			home.lindex = params["sindex"];
			
		if(Helper.isListMode())
			home.displayList();
		else
			home.displayTab();
	}
	
	PredefinedScreen.prototype.displayList = function() {
		if(this.user_nsid != 0)
		{
			Helper.displayList(this);
		}
		else
		{
			this.selector.addElement("Search", searchImage, 'icon');
			this.selector.addElement("Explore", exploreImage, 'icon');
			this.selector.select(0);
		}
	}
	
	PredefinedScreen.prototype.displayTab = function() {
		if(!Helper.isListMode())
		{
			Helper.displayTab(this, '');
			this.auto_disp_tid = setTimeout( function() { home.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
		}
	}
	
	PredefinedScreen.prototype.autoFetch = function() {
		var sindex = 0;
		
		if(Helper.isListMode())
		{
			if(this.selector)
				sindex = this.selector.selected_index;
			else
				return;
		}
		else
		{
			sindex = this.lindex;
			this.tabs.autoFetch();
		}
			
		if(this.user_nsid != 0)
		{
			switch(sindex)
			{
				case HOME_IDX_PHOTOSTREAM:
					/* photostream */
					var params = [];
					
					params["method"] = "flickr.photos.search";
					params["user_id"] = user.user_nsid;
					params["auth_token"] = user.token;
					params["per_page"] = Constants.AUTO_FETCH_PHOTOCOUNT;
					
					flickr.photos_search(params, this.hrPhotostream, PRI_HIGH);
					break;
					
				case HOME_IDX_CONTACTS:
					/* contacts */
					flickr.contacts_getList(user.token, null, null, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrContacts, PRI_HIGH);
					break;
					
				case HOME_IDX_SETS:
					/* sets */
					flickr.photosets_getList(user.token, null, this.hrSets, PRI_HIGH);
					break;
					
					
				case HOME_IDX_COLLECTIONS:
					/* collections */
					flickr.collections_getTree(user.token, null, null, this.hrCollections, PRI_HIGH);	
					break;
					
				case HOME_IDX_TAGS:
					/* tags */
					flickr.tags_getListUserPopular(user.token, null, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrTags, PRI_HIGH);
					break;
					
				case HOME_IDX_FAVORITES:
					/* favorites */
					flickr.favorites_getList(user.token, user.user_nsid, null, null, null, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrFavorites, PRI_HIGH);
					break;
					
				case HOME_IDX_PROFILE:
					/* profile */
					flickr.people_getInfo(user.token, user.user_nsid, this.hrProfile, PRI_HIGH);
					break;
					
				case HOME_IDX_RECENT_ACTIVITY:
					/* recent activity */
					flickr.photos_getContactsPhotos(user.token, Constants.AUTO_FETCH_PHOTOCOUNT, null, null, null, null, this.hrRecentActivity, PRI_HIGH);
					break;
					
				case HOME_IDX_BOOKMARKS:
					/* bookmarks */
					this.hrBookmarks();
					break;
					
				case HOME_IDX_SEARCH:
					/* search */
					var params = [];
					
					params["method"] = "flickr.photos.search";
					params["text"] = "sriram ramani";
					params["auth_token"] = user.token;
					params["per_page"] = (Constants.AUTO_FETCH_PHOTOCOUNT-2);
					
					flickr.photos_search(params, this.hrSearch, PRI_HIGH);
					break;
					
				case HOME_IDX_EXPLORE:
					/* explore */
					flickr.interestingness_getList(user.token, null, null, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrExplore, PRI_HIGH);
					break;
			}
			
		}
		else
		{
			switch(sindex + 6)
			{
				case HOME_IDX_SEARCH:
					/* search */
					break;
					
				case HOME_IDX_EXPLORE:
					/* explore */
					break;
			}
		}
	}
	
	PredefinedScreen.prototype.hrPhotostream = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == HOME_IDX_PHOTOSTREAM)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrContacts = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(rsp.contacts.total)
					{
						var tcontacts = rsp.contacts.contact;
						rsp = null;
						
						if(sindex == HOME_IDX_CONTACTS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tcontacts.length; i++)
							{
								var tcontact = tcontacts[i];
								photo_url[i] = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'small');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No contacts available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrSets = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(rsp.photosets.photoset.length)
					{
						var tsets = rsp.photosets.photoset;
						rsp = null;
						
						if(sindex == HOME_IDX_SETS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; (i < tsets.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								var tset = tsets[i];
								photo_url[i] = flickr.build_photo_url(tset.farm, tset.server, tset.primary, tset.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No sets available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrCollections = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(rsp.collections && rsp.collections.collection && rsp.collections.collection.length)
					{
						var tcollections = rsp.collections.collection;
						rsp = null;
						
						if(sindex == HOME_IDX_COLLECTIONS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; (i < tcollections.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								var tcollection = tcollections[i];
								photo_url[i] = tcollection.iconsmall;
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No collections available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrTags = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					var ttags = rsp.who.tags.tag;
					rsp = null;
					
					if(ttags.length)
					{						
						if(sindex == HOME_IDX_TAGS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var ttag = [];
							
							for(var i=0; (i < ttags.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								ttag[i] = ttags[i]._content + ' (' + ttags[i].count + ')';
							}
							
							Helper.setAFTextList(sindex, ttag);
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No tags available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrFavorites = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == HOME_IDX_FAVORITES)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No favorite photos available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrProfile = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(rsp.person)
					{
						var tperson = rsp.person;
						rsp = null;
						
						if(sindex == HOME_IDX_PROFILE)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var photo_url = flickr.build_buddy_icon_url(tperson.iconserver, tperson.iconfarm, tperson.nsid);
							
							var text = [];
							
							if(tperson.realname && tperson.realname._content)
								text[text.length] = tperson.realname._content;
							
							if(tperson.location && tperson.location._content)
								text[text.length] = tperson.location._content;
								
							if(tperson.photos && tperson.photos.count && tperson.photos.count._content)
								text[text.length] = tperson.photos.count._content + ' photos';
							
							Helper.setAFPhotoTextList(sindex, photo_url, text, 'small', 'right');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No profile information available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
					
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}

	PredefinedScreen.prototype.hrRecentActivity = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(rsp.photos && rsp.photos.photo && rsp.photos.photo.length)
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == HOME_IDX_RECENT_ACTIVITY)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrBookmarks = function() {
		if(bmarks)
		{
			if(home)
			{
				var sindex = Helper.getSindex(home);
				
				if(sindex == HOME_IDX_BOOKMARKS)
				{
					var thead = 'Your Bookmarks';
					var tlist = [];
					
					tlist[tlist.length] = bmarks.photos.length + ' photos';
					tlist[tlist.length] = bmarks.contacts.length + ' contacts';
					tlist[tlist.length] = bmarks.sets.length + ' sets';
					
					Helper.setAFTextListHeader(sindex, thead, tlist);
					home.resize();
					home.scroll.updateScrollbar();
				}
			}
		}
		else
		{
			if(home)
			{
				var sindex = Helper.getSindex(home);
				
				Helper.setAFNoResult(sindex, 'No bookmarks available!');
				home.resize();
				home.scroll.updateScrollbar();
			}
		}
	}
	
	PredefinedScreen.prototype.hrSearch = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == HOME_IDX_SEARCH)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var text = 'Search for \'Sriram Ramani\'';
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFTextPhotoList(sindex, photo_url, text, 'large', 'right');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	PredefinedScreen.prototype.hrExplore = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(home)
				{
					var sindex = Helper.getSindex(home);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == HOME_IDX_EXPLORE)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							home.resize();
							home.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						home.resize();
						home.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	