	function Recent() {
		/* Object for the Recent Screen */
		this.user = null;
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	Recent.prototype.initialize = function() {
		browsr.screen = SCREEN_RECENT;
		
		this.elements = tabs_recent;		
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Recent.prototype.destroy = function() {
		flickr.purge_all();
		
		this.user = null;
		this.lindex = 0;
		this.tabs = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
	}
	
	Recent.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Recent.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	Recent.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);

		switch(sindex)
		{
			case RECENT_IDX_UR_PHOTOS:
				/* on your photos */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent('Activity on Your Photos', recent_activity.showByPhotos, params, sindex, recentPhotosImage, 'icon');
				recent_activity.showByPhotos(params);
				params = null;
				break;
				
			case RECENT_IDX_COMMENTS:
				/* on photos you commented */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent('Activity on Your Comments', recent_activity.showByComments, params, sindex, recentCommentsImage, 'icon');
				recent_activity.showByComments(params);
				params = null;
				break;
				
			case RECENT_IDX_CONTACT_PHOTOS:
				/* recent contact photos */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent('Your Contacts\' Recent Photos', photostream.showByContactRecent, params, sindex, recentContactsPhotosImage, 'icon');
				photostream.showByContactRecent(params);
				params = null;
				break;
				
			case RECENT_IDX_CONTACTS:
				/* contacts who recently uploaded */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent('Your Contacts Who Uploaded Recently', contacts.showByRecent, params, sindex, recentContactsImage, 'icon');
				contacts.showByRecent(params);
				params = null;
				break;
				
			case RECENT_IDX_PUBLIC_PHOTOS:
				/* public photos */
				var params = [];
				params["user"] = this.user;
				
				this.destroy();
				
				browsr.addEvent('Recent Public Photos', photostream.showByPublicRecent, params, sindex, recentPublicPhotosImage, 'icon');
				photostream.showByPublicRecent(params);
				params = null;
				break;
		}
	}
	
	Recent.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Recent.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Recent.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Recent.prototype.show = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
		}
		else if((params["user"] == undefined) || (params["user"] == null))
		{
			params["user"] = user;
		}
		
		recent.initialize();
		
		recent.user = params["user"];
		
		if(recent.user != null)
		{	
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				recent.lindex = params["sindex"];
			
			Helper.setTitle('' + recent.user.username + '\'s recent events');
			
			if(Helper.isListMode())
				recent.displayList();
			else
				recent.displayTab();
				
			recent.updateMenus();
		}
	}
	
	Recent.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Recent.prototype.displayTab = function() {
		Helper.displayTab(this, 'Recent Activities');
			
		this.auto_disp_tid = setTimeout( function() { recent.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Recent.prototype.autoFetch = function() {
		if(this.user)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case RECENT_IDX_UR_PHOTOS:
					/* on your photos */
					flickr.activity_userPhotos(user.token, null, 1, 1, this.hrPhotos, PRI_HIGH);
					break;
					
				case RECENT_IDX_COMMENTS:
					/* on photos you commented */
					flickr.activity_userComments(user.token, 1, 1, this.hrComments, PRI_HIGH);
					break;
					
				case RECENT_IDX_CONTACT_PHOTOS:
					/* recent contacts photos */
					flickr.photos_getContactsPhotos(user.token, Constants.AUTO_FETCH_PHOTOCOUNT, null, null, null, null, this.hrContactsPhotos, PRI_HIGH);
					break;
					
				case RECENT_IDX_CONTACTS:
					/* contacts who uploaded recently */
					flickr.contacts_getListRecentlyUploaded(user.token, null, null, this.hrContacts, PRI_HIGH);
					break;
					
				case RECENT_IDX_PUBLIC_PHOTOS:
					/* public photos */
					flickr.photos_getRecent(user.token, null, 1, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrPublicPhotos, PRI_HIGH);
					break;
			}
		}
	}
	
	Recent.prototype.hrPhotos = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(recent)
				{
					var sindex = Helper.getSindex(recent);
					
					if(rsp.items && rsp.items.item && rsp.items.item.length)
					{
						var titem = rsp.items.item[0];
						rsp = null;
						
						if(sindex == RECENT_IDX_UR_PHOTOS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var text = '';
							var photo_url = '';
							
							if(titem.type == 'photo')
							{
								text = 'Recent activity on photo \'' + titem.title._content + '\'';
								photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.id, titem.secret, PHOTO_S);
							}
							else if(titem.type == 'photoset')
							{
								text = 'Recent activity on set\'' + titem.title._content + '\'';
								photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.primary, titem.secret, PHOTO_S);
							}	
							
							Helper.setAFPhotoText(sindex, photo_url, text, 'large', 'right');
							recent.resize();
							recent.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No recent activity found!');
						recent.resize();
						recent.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Recent.prototype.hrComments = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(recent)
				{
					var sindex = Helper.getSindex(recent);
					
					if(rsp.items && rsp.items.item && rsp.items.item.length)
					{
						var titem = rsp.items.item[0];
						rsp = null;
						
						if(sindex == RECENT_IDX_COMMENTS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var text = '';
							var photo_url = '';
							
							if(titem.type == 'photo')
							{
								text = 'Recent activity on photo \'' + titem.title._content + '\'';
								photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.id, titem.secret, PHOTO_S);
							}
							else if(titem.type == 'photoset')
							{
								text = 'Recent activity on set\'' + titem.title._content + '\'';
								photo_url = flickr.build_photo_url(titem.farm, titem.server, titem.primary, titem.secret, PHOTO_S);
							}	
							
							Helper.setAFPhotoText(sindex, photo_url, text, 'large', 'right');
							recent.resize();
							recent.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No recent activity found!');
						recent.resize();
						recent.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Recent.prototype.hrContacts = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(recent)
				{
					var sindex = Helper.getSindex(recent);
					
					if(rsp.contacts && rsp.contacts.total)
					{
						var tcontacts = rsp.contacts.contact;
						rsp = null;
						
						if(sindex == RECENT_IDX_CONTACTS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tcontacts.length; i++)
							{
								var tcontact = tcontacts[i];
								photo_url[i] = flickr.build_buddy_icon_url(tcontact.iconserver, tcontact.iconfarm, tcontact.nsid);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'small');
							recent.resize();
							recent.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No contact uploaded photos/videos in last 1 hour!');
						recent.resize();
						recent.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
		
	Recent.prototype.hrContactsPhotos = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(recent)
				{
					var sindex = Helper.getSindex(recent);
					
					if(rsp.photos && rsp.photos.photo && rsp.photos.photo.length)
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == RECENT_IDX_CONTACT_PHOTOS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							recent.resize();
							recent.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						recent.resize();
						recent.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Recent.prototype.hrPublicPhotos = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(recent)
				{
					var sindex = Helper.getSindex(recent);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == RECENT_IDX_PUBLIC_PHOTOS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							recent.resize();
							recent.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No photos available!');
						recent.resize();
						recent.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}