
	function Scroll(hpanel) {
		this.scroll = Helper.getDiv('scroll', 'scroller');
		this.scroll.scroller = this;
		this.scrollarea = Helper.getDiv('scrollarea', 'scrollarea');
		this.scrollpanel = Helper.getDiv('scrollpanel', 'scrollpanel');
		//this.scrollpanel.onclick = this.handleScrollpanelClick;
		this.scrollbar = Helper.getDiv('scrollbar', 'scrollbar');
		this.scrollpanel.appendChild(this.scrollbar);
		this.parent = null;
		
		if(hpanel)
		{
			this.hpanel = true;
			this.hscrollpanel = Helper.getDiv('hscrollpanel', 'hscrollpanel');
		
			this.hscrollbar = Helper.getDiv('hscrollbar', 'hscrollbar');
			this.hscrollpanel.appendChild(this.hscrollbar);
		}
		else
		{
			this.hpanel = false;
			this.hscrollpanel = null;
			this.hscrollbar = null;
		}
		
		this.scroll.appendChild(this.scrollpanel);
		if(hpanel)
			this.scroll.appendChild(this.hscrollpanel);
		this.scroll.appendChild(this.scrollarea);
	}
	
	Scroll.prototype.addTo = function(div) {
		if(div)
		{
			$(div).appendChild(this.scroll);
			this.parent = $(div);
		}
	}
	
	Scroll.prototype.add = function(div) {
		if(div)	
		{
			this.scrollarea.appendChild(div);
		}
	}
	
	Scroll.prototype.resize = function() {
		this.scroll.style.height = this.parent.clientHeight + 'px';
		
		if(this.scrollarea.clientHeight > this.scroll.clientHeight)
		{
			this.scrollpanel.style.display = 'block';	
			
			if(!this.hpanel)
				this.scrollarea.style.width = (this.parent.clientWidth - this.scrollpanel.clientWidth) + 'px';
		}
		else
		{
			this.scrollpanel.style.display = 'none';
			this.scrollarea.style.width = this.parent.clientWidth + 'px';
		}
			
		this.scrollpanel.style.height = this.parent.clientHeight + 'px';
		
		if(this.hpanel)
		{
			this.scroll.style.width = this.parent.clientWidth + 'px';
			if(this.scrollarea.clientWidth > this.scroll.clientWidth)
			{
				this.hscrollpanel.style.display = 'block';
				this.scrollpanel.style.height = (this.parent.clientHeight - this.hscrollpanel.clientHeight) + 'px';
				this.hscrollpanel.style.width = (this.parent.clientWidth - this.scrollpanel.clientWidth) + 'px';
			}
			else
				this.hscrollpanel.style.display = 'none';
		}
		
		this.updateScrollbar();
	}
	
	Scroll.prototype.scrollUp = function(size) {
		if((this.scrollarea.offsetTop + size) <= this.scroll.offsetTop)
		{
			this.scrollarea.style.top = (this.scrollarea.offsetTop + size) + 'px';
			this.scrollbar.style.top = (((0 - this.scrollarea.offsetTop) * this.scrollpanel.clientHeight) / this.scrollarea.clientHeight) + 'px';
		}
		else
		{
			this.scrollToTop();
		}
	}
	
	Scroll.prototype.scrollLeft = function(size) {
		if((this.scrollarea.offsetLeft + size) <= this.scroll.offsetLeft)
		{
			this.scrollarea.style.left = (this.scrollarea.offsetLeft + size) + 'px';
			this.hscrollbar.style.left = (((0 - this.scrollarea.offsetLeft) *  this.hscrollpanel.clientWidth) / this.scrollarea.clientWidth) + 'px';
		}
		else
		{
			this.scrollToLeft();
		}
	}
	
	Scroll.prototype.scrollDown = function(size) {
		if((this.scrollarea.offsetTop + this.scrollarea.clientHeight - size) >= (this.scroll.offsetTop + this.scroll.clientHeight))
		{
			this.scrollarea.style.top = (this.scrollarea.offsetTop - size) + 'px';
			this.scrollbar.style.top = (((0 - this.scrollarea.offsetTop) * this.scrollpanel.clientHeight) / this.scrollarea.clientHeight) + 'px';
		}
		else
		{
			this.scrollToBottom();
		}
	}
	
	Scroll.prototype.scrollRight = function(size) {
		if((this.scrollarea.offsetLeft + this.scrollarea.clientWidth - size) >= (this.scroll.offsetLeft + this.scroll.clientWidth))
		{
			this.scrollarea.style.left = (this.scrollarea.offsetLeft - size) + 'px';
			this.hscrollbar.style.left = (((0 - this.scrollarea.offsetLeft) *  this.hscrollpanel.clientWidth) / this.scrollarea.clientWidth) + 'px';
		}
		else
		{
			this.scrollToRight();
		}
	}
	
	Scroll.prototype.scrollToTop = function() {
		this.scrollbar.style.top = '0px';
		this.scrollarea.style.top = '0px';
	}
	
	Scroll.prototype.scrollToLeft = function() {
		this.hscrollbar.style.left = '0px';
		this.scrollarea.style.left = '0px';
	}
	
	Scroll.prototype.scrollToBottom = function() {
		this.scrollbar.style.top = (this.scrollpanel.clientHeight - this.scrollbar.clientHeight) + 'px';
		this.scrollarea.style.top = (this.scroll.clientHeight - this.scrollarea.clientHeight) + 'px';
		//this.scrollbar.style.top = (this.scrollbar.offsetTop + $('topbar').clientHeight) + 'px';
	}
	
	Scroll.prototype.scrollToRight = function() {
		this.hscrollbar.style.left = (this.hscrollpanel.clientWidth - this.hscrollbar.clientWidth) + 'px';
		this.scrollarea.style.left = (this.scroll.clientWidth - this.scrollarea.clientWidth) + 'px';
	}
	
	Scroll.prototype.scrollFromTop = function(size) {
		this.scrollarea.style.top = (0 - size) + 'px';
		this.scrollbar.style.top = ((size * this.scrollbar.clientHeight)/this.scrollpanel.clientHeight) + 'px';
		//this.scrollbar.style.top = (this.scrollbar.offsetTop + $('topbar').clientHeight) + 'px';
	}
	
	Scroll.prototype.scrollFromLeft = function(size) {
		this.scrollarea.style.left = (0 - size) + 'px';
		this.hscrollbar.style.left = ((size * this.hscrollbar.clientWidth)/this.hscrollpanel.clientWidth) + 'px';
	}
	
	Scroll.prototype.updateScrollbar = function() {
		if(this.scrollarea.clientHeight > this.scroll.clientHeight)
		{
			this.scrollpanel.style.display = 'block';
			this.scrollbar.style.height = ((this.scroll.clientHeight * this.scroll.clientHeight)/this.scrollarea.clientHeight) + 'px';
			this.scrollbar.style.top = Math.floor(((0 - this.scrollarea.offsetTop) * this.scrollbar.clientHeight)/this.scrollpanel.clientHeight) + 'px';
			//this.scrollbar.style.top = (this.scrollbar.offsetTop + $('topbar').clientHeight) + 'px';
		}
		else
		{
			this.scrollpanel.style.display = 'none';
		}
		
		if(this.hpanel)
		{
			if(this.scrollarea.clientWidth > this.scroll.clientWidth)
			{
				this.hscrollpanel.style.display = 'block';
				this.hscrollbar.style.width = ((this.scroll.clientWidth * this.scroll.clientWidth)/this.scrollarea.clientWidth) + 'px';
				this.hscrollbar.style.left = Math.floor(((0 - this.scrollarea.offsetLeft) * this.hscrollbar.clientWidth)/this.hscrollpanel.clientWidth) + 'px';
			}
			else
			{
				this.hscrollpanel.style.display = 'none';
			}
		}
	}
	
	Scroll.prototype.handleScrollpanelClick = function (event) {
		/* this refers to scrollpanel in this handler as the event was fired on it */
		/* Find the place it was clicked,
		   subtract it from the current placement of scrollbar
		   scroll as per needed */
		 
		var posY = event.pageY - $('topbar').clientHeight;	
		var scroll = this.parentNode.scroller;
		var scrollbar = scroll.scrollbar;
		var scrollarea = scroll.scrollarea;
		var scrollpanel = this;
		
		var sbtop = scrollbar.offsetTop;
		var sbheight = scrollbar.offsetHeight;
		var sbbottom = sbtop + sbheight;
		
		var sptop = scrollpanel.offsetTop;
		var spheight = scrollpanel.offsetHeight;
		var spbottom = sptop + spheight;
		
		if(((posY > sbtop) && (posY > sbbottom)) || (posY < sbtop))
		{
			if(((posY + (sbheight/2)) <= spbottom) &&
			   ((posY - (sbheight/2)) >= sptop))
			{
				var displacement = (posY - sptop - (sbheight/2));
				var ratio = ((displacement * spheight) / sbheight);
				scroll.scrollFromTop(ratio);				
			}
			else if((posY - (sbheight/2)) >= sptop)
			{			
				scroll.scrollToBottom();
			}
			else
			{
				scroll.scrollToTop();
			}
		}
	}