	function Search() {
		/* Object for the Search Screen */
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Search.prototype.initialize = function() {
		browsr.screen = SCREEN_SEARCH;
		
		this.elements = tabs_search;
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Search.prototype.destroy = function() {
		flickr.purge_all();
		
		this.lindex = 0;
		this.elements = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
		
		browsr.onion = false;
	}
	
	Search.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Search.prototype.handleKeypress = function(key) {
		if(!browsr.onion)
		{
			/* Normal Screen*/
			switch(key)
			{
				case KEY_UP:
					/* UP */
					if(Helper.isListMode())
						Helper.keyUpList(this);
					else
						Helper.keyUpScroll(this);
					break;
					
				case KEY_DOWN:
					/* DOWN */
					if(Helper.isListMode())
						Helper.keyDownList(this);
					else
						Helper.keyDownScroll(this);
					break;
				
				case KEY_ENTER:
					/* ENTER */
					this.keyEnter();
					break;
					
				case KEY_LEFT:
					/* LEFT */
					if(!(Helper.isListMode()))
						Helper.keyLeftTab(this);
					break;
					
				case KEY_RIGHT:
					/* RIGHT */
					if(!(Helper.isListMode()))
						Helper.keyRightTab(this);
					break;
			}
		}
		else
		{
			/* Onion Input screen */
			switch(key)
			{
				case KEY_CANCEL:
					this.cancelHandler();
					break;
			}
		}
	}
	
	Search.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
		
		switch(sindex)
		{
			case SEARCH_IDX_NEAR_ME:
				/* near me *//*
				var params = [];
				
				this.destroy();
				
				browsr.addEvent("Search Today", photostream.showBySearchToday, params, sindex);
				photostream.showBySearchToday(params);
				params = null;*/
				GPS.getLocation();
				break;
			
			case SEARCH_IDX_TEXT:
				/* text */
				this.showTextInput();
				break;
				
			case SEARCH_IDX_TAGS:
				/* tags */
				this.showTagsInput();
				break;
				
			case SEARCH_IDX_PERSON_EMAIL:
				/* email */
				this.showPersonEmailInput();
				break;
				
			case SEARCH_IDX_PERSON_USERNAME:
				/* username */
				this.showPersonUsernameInput();
				break;
				
			case SEARCH_IDX_PLACES:
				/* places */
				this.showPlacesInput();
				break;
		}
	}
	
	Search.prototype.showInBrowser = function() {
		var url = 'http://www.flickr.com/search/';
		openURL(url);
	}
	
	Search.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Search.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Search.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Search.prototype.show = function(params) {
		
		search.initialize();
		
		Helper.setTitle('Search');
		Helper.setNavigator('Search');
		
		if((params["sindex"] != undefined) || (params["sindex"] != null))
			search.lindex = params["sindex"];
			
		if(Helper.isListMode())
			search.displayList();
		else
			search.displayTab();
			
		search.updateMenus();
	}
	
	Search.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Search.prototype.displayTab = function() {
		Helper.displayTab(this, 'Search');
			
		this.auto_disp_tid = setTimeout( function() { search.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Search.prototype.autoFetch = function() {
		var sindex = 0;
			
		if(Helper.isListMode())
		{
			if(this.selector)
				sindex = this.selector.selected_index;
			else
				return;
		}
		else
		{
			sindex = this.lindex;
			this.tabs.autoFetch();
		}
		
		switch(sindex)
		{
			case SEARCH_IDX_NEAR_ME:
				/* near me */
				/* query is made for niagara falls */
				var params = [];
				
				params["method"] = "flickr.photos.search";
				params["place_id"] = SEARCH_AF_PLACE_ID;
				params["auth_token"] = user.token;
				params["per_page"] = (Constants.AUTO_FETCH_PHOTOCOUNT-2);
				
				flickr.photos_search(params, this.hrNearMe, PRI_HIGH);
				break;
			
			case SEARCH_IDX_TEXT:
				/* text */				
				var params = [];
				
				params["method"] = "flickr.photos.search";
				params["text"] = "sriram ramani";
				params["auth_token"] = user.token;
				params["per_page"] = (Constants.AUTO_FETCH_PHOTOCOUNT-2);
				
				flickr.photos_search(params, this.hrText, PRI_HIGH);
				break;
				
			case SEARCH_IDX_TAGS:
				/* tags */
				var params = [];
				
				params["method"] = "flickr.photos.search";
				params["tags"] = "sriramramani";
				params["auth_token"] = user.token;
				params["per_page"] = (Constants.AUTO_FETCH_PHOTOCOUNT-2);
				
				flickr.photos_search(params, this.hrTags, PRI_HIGH);
				break;
				
			case SEARCH_IDX_PERSON_EMAIL:
				/* email */
				//flickr.people_findByEmail('sriram_marirs@yahoo.co.in', this.hrPersonEmail, PRI_HIGH);
				flickr.people_getInfo(user.token, SEARCH_AF_PERSON, this.hrPersonEmail, PRI_HIGH);
				break;
				
			case SEARCH_IDX_PERSON_USERNAME:
				/* username */
				//flickr.people.findByUsername('sriram ramani', this.hrPersonUsername, PRI_HIGH);
				flickr.people_getInfo(user.token, SEARCH_AF_PERSON, this.hrPersonUsername, PRI_HIGH);
				break;
				
			case SEARCH_IDX_PLACES:
				flickr.places_find('Alabama', this.hrPlaces, PRI_HIGH);
				break;
		}
	}
	
	Search.prototype.hrNearMe = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == SEARCH_IDX_NEAR_ME)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var text = 'E.g. Niagara Falls';
							
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFTextPhotoList(sindex, photo_url, text, 'large', 'right');
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == SEARCH_IDX_NEAR_ME)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Search.prototype.hrText = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == SEARCH_IDX_TEXT)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var text = 'E.g. Sriram Ramani';
							
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFTextPhotoList(sindex, photo_url, text, 'large', 'right');
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == SEARCH_IDX_TEXT)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Search.prototype.hrTags = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(parseInt(rsp.photos.total))
					{
						var tphotostream = rsp.photos.photo;
						rsp = null;
						
						if(sindex == SEARCH_IDX_TAGS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var text = 'E.g. sriramramani';
							
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFTextPhotoList(sindex, photo_url, text, 'large', 'right');
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == SEARCH_IDX_TAGS)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Search.prototype.hrPersonEmail = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(rsp.person)
					{
						var tperson = rsp.person;
						rsp = null;
						
						if(sindex == SEARCH_IDX_PERSON_EMAIL)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var photo_url = flickr.build_buddy_icon_url(tperson.iconserver, tperson.iconfarm, tperson.nsid);
							
							var text = [];
							
							text[text.length] = 'Search for \'ayashok@gmail.com\':';
							
							if(tperson.realname && tperson.realname._content)
								text[text.length] = tperson.realname._content;
							
							if(tperson.location && tperson.location._content)
								text[text.length] = tperson.location._content;
								
							Helper.setAFPhotoTextList(sindex, photo_url, text, 'small', 'right');
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No matching email found!');
						search.resize();
						search.scroll.updateScrollbar();
					}
					
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}

	Search.prototype.hrPersonUsername = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(rsp.person)
					{
						var tperson = rsp.person;
						rsp = null;
						
						if(sindex == SEARCH_IDX_PERSON_USERNAME)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var photo_url = flickr.build_buddy_icon_url(tperson.iconserver, tperson.iconfarm, tperson.nsid);
							
							var text = [];
							
							text[text.length] = 'Search for \'ayashok photography\':';
							
							if(tperson.realname && tperson.realname._content)
								text[text.length] = tperson.realname._content;
							
							if(tperson.location && tperson.location._content)
								text[text.length] = tperson.location._content;
								
							Helper.setAFPhotoTextList(sindex, photo_url, text, 'small', 'right');
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No such username found!');
						search.resize();
						search.scroll.updateScrollbar();
					}
					
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}

	Search.prototype.hrPlaces = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					
					if(rsp.places && rsp.places.place && rsp.places.place.length)
					{
						var tplace = rsp.places.place;
						rsp = null;
						
						if(sindex == SEARCH_IDX_PLACES)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							
							var thead = 'Place search for \'Alabama\'';
							var tlist = [];
							for(var i=0; (i < tplace.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								tlist[i] = tplace[i]._content;
							}
							
							Helper.setAFTextListHeader(sindex, thead, tlist);
							search.resize();
							search.scroll.updateScrollbar();
						}
					}
					else
					{
						Helper.setAFNoResult(sindex, 'No places found!');
						search.resize();
						search.scroll.updateScrollbar();
					}
					
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}

	Search.prototype.showTextInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			var that = this;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; that.cancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer(0);
			var cnt = Helper.getOnionContent(dcont);
			
			var sc_inp = Helper.getSearchBox('Search by text:', 'sc_text', 'sc_text_ok');
			cnt.appendChild(sc_inp);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			var that = this;
			
			$('sc_text_ok').addEventListener('click', function() { that.textOkHandler(); }, false);
			$('sc_text').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('sc_text').addEventListener('blur',  function() { browsr.onion_cancel_ok = true;  }, false);
			$('sc_text').focus();
		}
	}
	
	Search.prototype.hideTextInput = function() {
		if($('onion_skin'))
		{
			$('sc_text').blur();
			$('sc_text_ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Search.prototype.textOkHandler = function() {
		if($('sc_text_ok'))
		{
			var ttext = '' + $('sc_text').value;
			
			search.hideTextInput();
			
			if(ttext != '')
			{
				var sindex = Helper.getSindex(search);
				var params = [];
				params["text"] = ttext;
				
				search.destroy();
				
				browsr.addEvent('Search by Text', photostream.showBySearchText, params, sindex, searchTextImage, 'icon');
				photostream.showBySearchText(params);
				params = null;
			}
		}
	}
	
	Search.prototype.showTagsInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			var that  = this;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; that.cancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer(0);
			var cnt = Helper.getOnionContent(dcont);
			
			var sc_inp = Helper.getSearchBox('Search by tags:', 'sc_tags', 'sc_tags_ok');
			cnt.appendChild(sc_inp);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			$('sc_tags_ok').addEventListener('click', function() { that.tagsOkHandler(); }, false);
			$('sc_tags').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('sc_tags').addEventListener('blur', function() { browsr.onion_cancel_ok = true; }, false);
			$('sc_tags').focus();
		}
	}
	
	Search.prototype.hideTagsInput = function() {
		if($('onion_skin'))
		{
			$('sc_tags').blur();
			$('sc_tags_ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Search.prototype.tagsOkHandler = function() {
		if($('sc_tags_ok'))
		{
			var ttags = '' + $('sc_tags').value;
			
			search.hideTagsInput();
			
			if(ttags != '')
			{
				var sindex = Helper.getSindex(search);
				var params = [];
				params["tags"] = ttags;
				
				search.destroy();
				
				browsr.addEvent('Search by Tags', photostream.showBySearchTags, params, sindex, searchTagsImage, 'icon');
				photostream.showBySearchTags(params);
				params = null;
			}
		}
	}
	
	Search.prototype.showPersonEmailInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			var that = this;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; that.cancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer();
			var cnt = Helper.getOnionContent(dcont);
			
			var sc_inp = Helper.getSearchBox('Search by email:', 'sc_email', 'sc_email_ok');
			cnt.appendChild(sc_inp);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			$('sc_email_ok').addEventListener('click', function() { that.personEmailOkHandler(); }, false);
			$('sc_email').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('sc_email').addEventListener('blur',  function() { browsr.onion_cancel_ok = true; }, false);
			$('sc_email').focus();
		}
	}
	
	Search.prototype.hidePersonEmailInput = function() {
		if($('onion_skin'))
		{
			$('sc_email').blur();
			$('sc_email_ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Search.prototype.personEmailOkHandler = function() {
		if($('sc_email_ok'))
		{
			var temail = '' + $('sc_email').value;
			
			search.hidePersonEmailInput();
			
			if(temail != '')
			{
				flickr.people_findByEmail(temail, search.hrFlickrPersonEmail, PRI_HIGH);
			}
		}
	}
	
	Search.prototype.hrFlickrPersonEmail = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
					var sindex = Helper.getSindex(search);
					if(rsp.user)
					{
						var tuser = new User();
						var ruser = rsp.user;
						rsp = null;
						
						tuser.user_nsid = ruser.nsid;
						tuser.username = ruser.username._content;
						
						var params = [];
						params["user"] = tuser;
						
						search.destroy();
						
						browsr.addEvent(tuser.username, contact.show, params, sindex, searchPersonEmailImage, 'icon');
						contact.show(params);
						params = null;
						
						
					}
					else
					{
						alert('No users available!');
						search.resize();
						search.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
				alert('No users available!');
				search.resize();
				search.scroll.updateScrollbar();
					
			}
		}
	}
	
	Search.prototype.showPersonUsernameInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			var that = this;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; that.cancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer();
			var cnt = Helper.getOnionContent(dcont);
			
			var sc_inp = Helper.getSearchBox('Search by username:', 'sc_uname', 'sc_uname_ok');
			cnt.appendChild(sc_inp);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			$('sc_uname_ok').addEventListener('click', function() { that.personUsernameOkHandler(); }, false);
			$('sc_uname').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('sc_uname').addEventListener('blur',  function() { browsr.onion_cancel_ok = true; }, false);
			$('sc_uname').focus();
		}
	}
	
	Search.prototype.hidePersonUsernameInput = function() {
		if($('onion_skin'))
		{
			$('sc_uname').blur();
			$('sc_uname_ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Search.prototype.personUsernameOkHandler = function() {
		if($('sc_uname_ok'))
		{
			var tuname = '' + $('sc_uname').value;
			
			search.hidePersonUsernameInput();
			
			if(tuname != '')
			{
				flickr.people_findByUsername(tuname, search.hrFlickrPersonUsername, PRI_HIGH);
			}
		}
	}
	
	Search.prototype.hrFlickrPersonUsername = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(search)
				{
				
					var sindex = Helper.getSindex(search);
					if(rsp.user)
					{
						var tuser = new User();
						var ruser = rsp.user;
						rsp = null;
						
						tuser.user_nsid = ruser.nsid;
						tuser.username = ruser.username._content;
						
						var params = [];
						params["user"] = tuser;
						
						search.destroy();
						
						browsr.addEvent(tuser.username, contact.show, params, sindex, searchPersonUsernameImage, 'icon');
						contact.show(params);
						params = null;
						
						
					}
					else
					{
						alert('No users available!');
						search.resize();
						search.scroll.updateScrollbar();
					}
				}
			}
			else
			{
				/* error */
				alert('No users available!');
				search.resize();
				search.scroll.updateScrollbar();
					
			}
		}
	}
	
	Search.prototype.showPlacesInput = function() {
		if(!browsr.onion)
		{
			/* Get a transparent container */
			browsr.onion = true;
			var that = this;
			
			var donion = Helper.getOnionSkin('onion_skin');
			donion.addEventListener('click', function() { browsr.onion_cancel_ok = true; that.cancelHandler(); }, false);
			
			var dcont = Helper.getOnionContainer();
			var cnt = Helper.getOnionContent(dcont);
			
			var sc_inp = Helper.getSearchBox('Search by places:', 'sc_places', 'sc_places_ok');
			cnt.appendChild(sc_inp);
			donion.appendChild(dcont);
			this.div.appendChild(donion);
			
			Helper.placeInCenter(dcont, donion);
			
			$('sc_places_ok').addEventListener('click', function() { that.placesOkHandler() }, false);
			$('sc_places').addEventListener('focus', function() { browsr.onion_cancel_ok = false; }, false);
			$('sc_places').addEventListener('blur',  function() { browsr.onion_cancel_ok = true; }, false);
			$('sc_places').focus();
		}
	}
	
	Search.prototype.hidePlacesInput = function() {
		if($('onion_skin'))
		{
			$('sc_places').blur();
			$('sc_places_ok').blur();
				
			Helper.destroyDescendants($('onion_skin'));
			$('onion_skin').parentNode.removeChild($('onion_skin'));
			
			browsr.onion = false;
		}
	}
	
	Search.prototype.placesOkHandler = function() {
		if($('sc_places_ok'))
		{
			var tplace = '' + $('sc_places').value;
			
			search.hidePlacesInput();
			
			if(tplace != '')
			{
				var sindex = Helper.getSindex(search);
				var params = [];
				params["query"] = tplace;
				
				search.destroy();
				
				browsr.addEvent('Search by Places', places.showBySearch, params, sindex, searchPlacesImage, 'icon');
				places.showBySearch(params);
				params = null;
			}
		}
	}
	
	Search.prototype.cancelHandler = function() {
		if(browsr.onion_cancel_ok)
		{
			if($('sc_text_ok'))
				search.hideTextInput();
			else if($('sc_tags_ok'))
				search.hideTagsInput();
			else if($('sc_email_ok'))
				search.hidePersonEmailInput();
			else if($('sc_uname_ok'))
				search.hidePersonUsernameInput();
			else if($('sc_places_ok'))
				search.hidePlacesInput();
		}
	}