
	function Selector() {
		/* Define the properties */
		this.selected_index = 0;
		this.auto_disp_tid = 0;
		this.scroll = null;
		this.div_array = [];
		
		/* this is jus for optimization. this jus holds this.div_array.length */
		this.count = 0;
		
		/* Does this provide any optimisation ???? */
		this.scrollareatop = 0;
		this.scrollareaheight = 0;
		this.scrollareabottom = 0;
		this.divtop = 0;
		this.divheight = 0;
		this.divbottom = 0;
		this.scrolltop = 0;
		this.scrollheight = 0;
		this.scrollbottom = 0;
		
		this.div = Helper.getDiv('list_area', 'list_area');
	}
	
	Selector.prototype.addTo = function(div) {
		if($(div))
		{
			$(div).appendChild(this.div);
		}
	}
	
	Selector.prototype.add = function(div) {
		if(div)
		{
			this.div_array.push(div);
			this.div.appendChild(div);
			div.sindex = this.count;
			this.count++;
		}
	}	

	Selector.prototype.removeAll = function() {
		clearTimeout(this.auto_disp_tid);
		Helper.destroyDescendants(this.div);
		this.div_array = [];
		this.count = 0;
	}

	Selector.prototype.select = function(index) {
		if(index < this.count)
		{
			this.deselect(this.selected_index);
			this.selected_index = index;
			$('list_elh_' + index).className = 'list_elm_header selected';
			
			/* Post processing */
			var pText = $('list_el_text_' + index);
			var divText = $('list_el_text_' + index);
			Helper.checkEllipsis(pText, divText.clientWidth, MAX_TEXT_HEIGHT_IN_LIST);
			
			this.autoFetch();
			this.updateSelector();
		}
	}
	
	Selector.prototype.deselect = function(index) {
		if(index < this.count)
		{
			clearTimeout(this.auto_disp_tid);
			$('list_elh_' + index).className = 'list_elm_header unselected';
			$('af_content_' + index).style.display = 'none';
			
			/* Post processing */
			var pText = $('list_el_text_' + index);
			var divText = $('list_el_text_' + index);
			Helper.checkEllipsis(pText, divText.clientWidth, MAX_TEXT_HEIGHT_IN_LIST);
			
			Helper.showRingsInAutoFetch(index, this.count);
		}
	}
	
	Selector.prototype.resize = function() {
	/*
		var width = this.scroll.scrollarea.clientWidth;
		this.div.style.width = width + 'px';
		
		for(var i=0; i < this.count; i++)
		{
			this.div_array[i].style.width = width + 'px';
			$('highlight_' + i).style.width = width + 'px';
			$('autof_elt_' + i).style.width = width + 'px';
		}
		
		
		// this.updateSizes();
	*/
		
		this.updateSelector();
	}
	
	Selector.prototype.updateSelector = function() {
		var scroll = this.scroll;
		
		var is_updated = false;
		
		this.updateSizes();
		
		scroll.updateScrollbar();
		
		if(this.divbottom > this.scrollbottom)
		{
			/* element below visible area */
			scroll.scrollDown(this.divbottom - this.scrollbottom);
			is_updated = true;
		}
		else if(this.divtop < this.scrolltop)
		{
			/* element above visible area */
			scroll.scrollUp(this.scrolltop - this.divtop);
			is_updated = true;
		}
		else if((this.scrollareaheight > this.scrollheight) && (this.scrollareabottom < this.scrollbottom))
		{
			/* scroll area bottom above screen bottom */
			scroll.scrollToBottom();
			is_updated = true;
		}
		else if((this.scrollareaheight <= this.scrollheight) && (this.scrollareatop < this.scrolltop))
		{
			/* scroll area top above visible area */
			scroll.scrollToTop();
			is_updated = true;
		}
		
		/*
		if(is_updated)
		{
			this.updateSizes();
		}
		*/
	}
	
	Selector.prototype.updateSizes = function() {
		var div = this.div_array[this.selected_index];
		this.scrollareatop = this.scroll.scrollarea.offsetTop;
		this.scrollareaheight = this.scroll.scrollarea.offsetHeight;
		this.scrollareabottom = this.scrollareatop + this.scrollareaheight;
		this.divtop = div.offsetTop + this.scrollareatop;
		this.divheight = div.offsetHeight;
		this.divbottom = this.divtop + this.divheight;
		this.scrolltop = this.scroll.scroll.offsetTop;
		this.scrollheight = this.scroll.scroll.offsetHeight;
		this.scrollbottom = this.scrolltop + this.scrollheight;
	}
	
	Selector.prototype.addElement = function(name, image, img_type) {
		var id = this.count;
		
		var divLE = Helper.getDiv('list_el_' + id, 'list_element');
		var divLEH = Helper.getDiv('list_elh_' + id, 'list_elm_header unselected');
		var tableLEH = Helper.getTable(null, null);
		var trLEH = Helper.getTr(null, null);
		var tdLEdge = Helper.getTd(null, 'edge');
		var divLeft = Helper.getDiv(null, 'left');
		var divLeftUp = Helper.getDiv(null, 'up');
		var divLeftDown = Helper.getDiv(null, 'down');
		var imgRL1 = Helper.getImg('list_el_rl_u_' + id, 'ring up', './images/ring_bottom.png');
		var imgRL2 = Helper.getImg('list_el_rl_d_' + id, 'ring down', './images/ring_top.png');
		var tdIcon = Helper.getTd(null, 'icon');
		var divIcon = Helper.getDiv(null, 'icon');
		var divShadow = null;
		var imgIcon = null;
		
		if(image)
		{
			if(img_type == 'icon')
			{
				divIcon = Helper.getDiv(null, 'icon');
				imgIcon = Helper.getImg('list_el_icon_' + id, 'icon', image);
			}
			else
			{
				divIcon = Helper.getDiv(null, 'photoframe');
				divShadow = Helper.getDiv(null, 'shadow');
				imgIcon = Helper.getImg('list_el_icon_' + id, 'icon', image);
			}
		}
		else
		{
			divIcon = Helper.getDiv(null, 'photoframe');
		}
			
		var tdText = Helper.getTd(null, 'text');
		var divText = Helper.getDiv('list_el_div_' + id, 'text');
		var pText = Helper.getP('list_el_text_' +  id, 'text', name);
		pText.origText = '' + name;
		var tdREdge = Helper.getTd(null, 'edge');
		var divRight = Helper.getDiv(null, 'right');
		var divRightUp = Helper.getDiv(null, 'up');
		var divRightDown = Helper.getDiv(null, 'down');
		var imgRR1 = Helper.getImg('list_el_rr_u_' + id, 'ring up', './images/ring_bottom.png');
		var imgRR2 = Helper.getImg('list_el_rr_d_' + id, 'ring down', './images/ring_top.png');
		
		divLeftUp.appendChild(imgRL1);
		divLeftDown.appendChild(imgRL2);
		divLeft.appendChild(divLeftUp);
		divLeft.appendChild(divLeftDown);
		tdLEdge.appendChild(divLeft);
		
		if(imgIcon)
		{
			if(divShadow)
			{
				divShadow.appendChild(imgIcon);
				divIcon.appendChild(divShadow);
			}
			else
			{
				divIcon.appendChild(imgIcon);
			}
		}
		tdIcon.appendChild(divIcon);
		
		divText.appendChild(pText);
		tdText.appendChild(divText);
		
		divRightUp.appendChild(imgRR1);
		divRightDown.appendChild(imgRR2);
		divRight.appendChild(divRightUp);
		divRight.appendChild(divRightDown);
		tdREdge.appendChild(divRight);
		
		trLEH.appendChild(tdLEdge);
		trLEH.appendChild(tdIcon);
		trLEH.appendChild(tdText);
		trLEH.appendChild(tdREdge);
		tableLEH.appendChild(trLEH);
		divLEH.appendChild(tableLEH);
		
		/* AF content */
		var divAF = Helper.getAFContainer(id);
		
		divLE.appendChild(divLEH);
		divLE.appendChild(divAF);
			
		divLE.selector = this;
		
		divLE.addEventListener('click', function() {
			divLE.selector.select(id);
			browsr.screens[browsr.screen].keyEnter();
		}, false);
		
		this.add(divLE);
		
		/* Post processing */
		Helper.checkEllipsis(pText, divText.clientWidth, MAX_TEXT_HEIGHT_IN_LIST);
	}
	
	/* TODO: Need to be modified / relooked at */
	Selector.prototype.replaceElement = function(id, name, image) {
		if(id < this.count)
		{
			/* Fill this approrpiately */
		}
	}

	Selector.prototype.autoFetch = function() {
		this.auto_disp_tid = setTimeout( function() { 
														if(browsr && browsr.screens[browsr.screen])
															browsr.screens[browsr.screen].autoFetch();
													}, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	function selectClicker(div) {
		div.selector.select(div.sindex);
	}
	
	
	
	