	function Set() {
		/* Object for the Set Screen */
		this.set = null;
		this.lindex = 0;
		this.elements = null;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.tabber = null;
		this.auto_disp_tid = 0;
	}
		
	Set.prototype.initialize = function() {
		browsr.screen = SCREEN_SET;
		
		this.elements = tabs_set;		
		Helper.initialize(this);
		
		Helper.initTabber(this);
		
		Helper.hideNavbar();
		Helper.showTabbar();
	}
	
	Set.prototype.destroy = function() {
		flickr.purge_all();
		
		this.set = null;
		this.lindex = 0;
		this.elements = null;
		
		this.tabber.removeAll();
		Helper.destroy(this);
	}
	
	Set.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode())
			this.selector.resize();
	}
	
	Set.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpList(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownList(this);
				else
					Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(!(Helper.isListMode()))
					Helper.keyLeftTab(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(!(Helper.isListMode()))
					Helper.keyRightTab(this);
				break;
		}
	}
	
	Set.prototype.keyEnter = function() {
		var sindex = Helper.getSindex(this);
		
		var ttitle = '';
		if(this.set.title._content)
			ttitle = this.set.title._content;
		else
			ttitle = this.set.title;
			
		switch(sindex)
		{
			case SET_IDX_PHOTOS:
				/* photostream */
				var params = [];
				params["set"] = this.set;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Photos', photostream.showBySet, params, sindex, photosImage, 'icon');
				photostream.showBySet(params);
				params = null;
				break;
			
			case SET_IDX_DESCRIPTION:
				/* sets */
				var params = [];
				params["set"] = this.set;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Description', description.showBySet, params, sindex, descriptionImage, 'icon');
				description.showBySet(params);
				params = null;
				break;
				
			case SET_IDX_COMMENTS:
				/* contacts */
				var params = [];
				params["set"] = this.set;
				
				this.destroy();
				
				browsr.addEvent(ttitle + '\'s Comments', comments.showBySet, params, sindex, commentsImage, 'icon');
				comments.showBySet(params);
				params = null;
				break;
		}
	}
	
	Set.prototype.showInBrowser = function() {
		//need owner info
	}
	
	Set.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
			
			if(this.set)
			{
				if(bmarks.findSetInBmarks(this.set.id))
				{
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
				}
				else
				{	
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
				}
			}
			else
			{
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Set.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
	}
	
	Set.prototype.switchToList = function() {
		Helper.switchToList(this);
	}
	
	Set.prototype.show = function(params) {
	
		if(params == null)
		{
			params["set"] = null;
		}
		else if((params["set"] == undefined) || (params["set"] == null))
		{
			params["set"] = null;
		}
		
		set.initialize();
		
		set.set = params["set"];
		
		if(set.set != null)
		{
			if((params["sindex"] != undefined) || (params["sindex"] != null))
				set.lindex = params["sindex"];
				
			/* Shoud set - set's title here */
			if(set.set.title._content)
			{
				Helper.setTitle('Set: ' + set.set.title._content);
			}
			else
			{
				Helper.setTitle('Set: ' + set.set.title);
			}
			
			if(Helper.isListMode())
				set.displayList();
			else
				set.displayTab();
				
			set.updateMenus();
		}
	}
	
	Set.prototype.showByBookmark = function(params) {
		if(params == null)
		{
			params["set_id"] = null;
			params["set_title"] = null;
		}
		
		if((params["set_id"] == undefined) || (params["set_id"] == null))
			params["set_id"] = null;
		
		if((params["set_title"] == undefined) || (params["set_title"] == null))
			params["set_title"] = null;
			
		if(params["set_id"])
		{
			var tparams = [];
			tparams["set"] = { id : params["set_id"],
							   title : params["set_title"] };
			set.show(tparams);
		}
	}
	
	Set.prototype.displayList = function() {
		Helper.displayList(this);
	}
	
	Set.prototype.displayTab = function() {
		
		var ttitle = 'Set: ';
		
		if(this.set.title._content)
			ttitle = this.set.title._content;
		else
			ttitle = this.set.title;
			
		Helper.displayTab(this, ttitle);
			
		this.auto_disp_tid = setTimeout( function() { set.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
	}
	
	Set.prototype.autoFetch = function() {
		if(this.set)
		{
			var sindex = 0;
			
			if(Helper.isListMode())
			{
				if(this.selector)
					sindex = this.selector.selected_index;
				else
					return;
			}
			else
			{
				sindex = this.lindex;
				this.tabs.autoFetch();
			}
			
			switch(sindex)
			{
				case SET_IDX_PHOTOS:
					/* photostream */
					flickr.photosets_getPhotos(user.token, this.set.id, null, null, null, null, Constants.AUTO_FETCH_PHOTOCOUNT, this.hrPhotos, PRI_HIGH);
					break;
					
				case SET_IDX_DESCRIPTION:
					/* sets */
					flickr.photosets_getInfo(user.token, this.set.id, this.hrDescription, PRI_HIGH);
					break;
					
				case SET_IDX_COMMENTS:
					/* contacts */
					flickr.photosets_comments_getList(user.token, this.set.id, this.hrComments, PRI_HIGH);
					break;
			}
		}
	}
	
	Set.prototype.hrPhotos = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(set)
				{
					var sindex = Helper.getSindex(set);
					
					if(parseInt(rsp.photoset.total))
					{
						var tphotostream = rsp.photoset.photo;
						rsp = null;
						
						if(sindex == SET_IDX_PHOTOS)
						{
							Helper.destroyDescendants($('autof_elt_' + sindex));
							var photo_url = [];
							for(var i=0; i < tphotostream.length; i++)
							{
								var tphoto = tphotostream[i];
								photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
							}
							
							Helper.setAFPhotoList(sindex, photo_url, 'large');
							set.resize();
							set.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == SET_IDX_PHOTOS)
						{
							Helper.setAFNoResult(sindex, 'No photos available!');					
							set.resize();
							set.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Set.prototype.hrDescription = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(set)
				{
					var sindex = Helper.getSindex(set);
					
					if(rsp.photoset)
					{
						tinfo = rsp.photoset;
						rsp = null;
							
						if(sindex == SET_IDX_DESCRIPTION)
						{
							var text = '';
							
							if(tinfo.description)
								text = tinfo.description._content;
								
							if(text.length > MAX_AF_TEXT_LENGTH)
							{
								text = text.substr(0, MAX_AF_TEXT_LENGTH);
								text = text + '...';
							}
							
							if(text != '')
								Helper.setAFText(sindex, text);
							else
								Helper.setAFNoResult(sindex, 'No description available!');
								
							set.resize();
							set.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Set.prototype.hrComments = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				if(set)
				{
					var sindex = Helper.getSindex(set);
					
					if(rsp.comments && rsp.comments.comment && rsp.comments.comment.length)
					{
						tcomments = rsp.comments.comment;
						rsp = null;
							
						if(sindex == SET_IDX_COMMENTS)
						{
							var thead = "Comments by";
							var tlist = [];
							
							for(var i=0; (i < tcomments.length) && (i < Constants.AUTO_FETCH_PHOTOCOUNT); i++)
							{
								tlist[i] = tcomments[i].authorname;
							}
							
							Helper.setAFTextListHeader(sindex, thead, tlist);
							set.resize();
							set.scroll.updateScrollbar();
						}
					}
					else
					{
						if(sindex == SET_IDX_COMMENTS)
						{
							Helper.setAFNoResult(sindex, 'Hasn\'t been commented so far!');
							set.resize();
							set.scroll.updateScrollbar();
						}
					}
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Set.prototype.addToBookmarks = function() {
		if(bmarks && this && this.set)
		{
			var ttitle = '';
			
			if(this.set.title._content)
				ttitle = this.set.title._content;
			else
				ttitle = this.set.title;
			
			bmarks.addSetToBmarks( {id:this.set.id, title:ttitle} );
		}
	}
	
	Set.prototype.removeFromBookmarks = function() {
		if(bmarks && this && this.set)
		{
			bmarks.removeSetFromBmarks(this.set.id);
		}
	}
	
	
	
	
	