	function loadSettings()
	{
		if(wkey('SETTINGS_AFTIMEOUT'))
			Constants.AUTO_FETCH_TIMEOUT = wkey('SETTINGS_AFTIMEOUT');
		else
			wsetKey(Constants.AUTO_FETCH_TIMEOUT, 'SETTINGS_AFTIMEOUT');
		
		if(wkey('SETTINGS_AFNO'))
			Constants.AUTO_FETCH_PHOTOCOUNT = wkey('SETTINGS_AFNO');
		else
			wsetKey(Constants.AUTO_FETCH_PHOTOCOUNT, 'SETTINGS_AFNO');
		
		if(wkey('MAX_LIST_SIZE'))
			MAX_LIST_SIZE = wkey('MAX_LIST_SIZE');
		else
			wsetKey(MAX_LIST_SIZE, 'MAX_LIST_SIZE');
		
		if(wkey('DEFAULT_MODE'))
		{
			DEFAULT_MODE = parseInt(wkey('DEFAULT_MODE'));
			if(browsr)
				browsr.mode = DEFAULT_MODE;
		}
		else
			wsetKey(DEFAULT_MODE, 'DEFAULT_MODE');
	}
	
	function Settings()
	{
		this.mode_val = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}

	Settings.prototype.initialize = function() {
		browsr.screen = SCREEN_SETTINGS;
		
		this.scroll = new Scroll();		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		/*
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		*/
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	Settings.prototype.destroy = function() {
		flickr.purge_all();
		
		if($('aftimeout'))
			$('aftimeout').blur();
			
		if($('afno'))
			$('afno').blur();
			
		if($('max_ls'))
			$('max_ls').blur();
			
		if($('mode'))
			$('mode').blur();
		
		if($('save'))
			$('save').blur();
		
		if($('cancel'))
			$('cancel').blur();
			
		/* TODO: Verify */
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	Settings.prototype.resize = function() {
		this.scroll.resize();
	}
	
	Settings.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(this.scroll)
				{
					if(this.scroll.scrollarea.clientHeight > this.scroll.scroll.clientHeight)
						this.scroll.scrollUp(20);
				}
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(this.scroll)
				{
					if(this.scroll.scrollarea.clientHeight > this.scroll.scroll.clientHeight)
						this.scroll.scrollDown(20);
				}
				break;
		}
	}
	
	Settings.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(true);
			wid(MENU_REFRESH.id).setDimmed(true);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.hide(MENU_CLEAR_HISTORY.id);
			toolbar.hide(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.hide(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
	}
	
	Settings.prototype.show = function(params) {
	
		settings.initialize();
		
		Helper.setTitle('Settings');
	
		var rcont = Helper.getRoundedContainer();
		var cnt = Helper.getRcContent(rcont);
		
		var aftimeout = '2';
		if(isNokia)
		{
			if(wkey('SETTINGS_AFTIMEOUT'))
				aftimeout = parseInt(wkey('SETTINGS_AFTIMEOUT')) / 1000;
		}
			
		var afno = '5';
		if(isNokia)
		{
			if(wkey('SETTINGS_AFNO'))
				afno = wkey('SETTINGS_AFNO');
		}
			
		var max_ls = '20';
		if(isNokia)
		{
			if(wkey('MAX_LIST_SIZE'))
				max_ls = wkey('MAX_LIST_SIZE');
		}
		
		if(isNokia)		
		{
			if(wkey('DEFAULT_MODE'))
			{
				if(wkey('DEFAULT_MODE') == '0')
				{
					settings.mode_val = 0;
				}
				else
				{
					settings.mode_val = 1;
				}
			}
		}
		
		/* af timeout */
		var taftimeout = Helper.getP(null, 'settings', 'Auto Fetch Timeout :');
		var iaftimeout = Helper.getTextBox('aftimeout', 'settings', '2', '2', aftimeout);
		var tsecs = Helper.getP(null, 'settings', ' secs');
		
		var uaftimeout = Helper.getUl(null, 'settings');
		var laftimeout = Helper.getLi(null, 'settings');
		
		laftimeout.appendChild(taftimeout);
		laftimeout.appendChild(iaftimeout);
		laftimeout.appendChild(tsecs);
		uaftimeout.appendChild(laftimeout);
		cnt.appendChild(uaftimeout);
		
		var tafno = Helper.getP(null, 'settings', 'No. of Auto Fetch photos to display :');
		var iafno = Helper.getTextBox('afno', 'settings', '2', '2', afno);
		
		var uafno = Helper.getUl(null, 'settings');
		var lafno = Helper.getLi(null, 'settings');
		
		lafno.appendChild(tafno);
		lafno.appendChild(iafno);
		uafno.appendChild(lafno);
		cnt.appendChild(uafno);
		
		var tmax_ls = Helper.getP(null, 'settings', 'Max List Size per page :');
		var imax_ls = Helper.getTextBox('max_ls', 'settings', '2', '2', max_ls);
		
		var umax_ls = Helper.getUl(null, 'settings');
		var lmax_ls = Helper.getLi(null, 'settings');
		
		lmax_ls.appendChild(tmax_ls);
		lmax_ls.appendChild(imax_ls);
		umax_ls.appendChild(lmax_ls);
		cnt.appendChild(umax_ls);
		
		
		var tmode = Helper.getP(null, 'settings', 'Startup Mode : ');
		var imode = Helper.getButton('mode', 'mode' + settings.mode_val, '');
		imode.setAttribute('onclick', 'settings.modeHandler()');
		
		var umode = Helper.getUl(null, 'settings');
		var lmode = Helper.getLi(null, 'settings');
		
		lmode.appendChild(tmode);
		lmode.appendChild(imode);
		umode.appendChild(lmode);
		cnt.appendChild(umode);
		
		
		/* save & cancel buttons */
		var isave = Helper.getButton('save', 'save', '');
		var icancel = Helper.getButton('cancel', 'cancel', '');
		isave.setAttribute('onclick', 'settings.saveHandler()');
		icancel.setAttribute('onclick', 'settings.cancelHandler()');
		
		var ucontrols = Helper.getUl(null, 'settings');
		var lcontrols = Helper.getLi(null, 'settingsbuttons');
		
		lcontrols.appendChild(isave);
		lcontrols.appendChild(icancel);
		ucontrols.appendChild(lcontrols);
		cnt.appendChild(ucontrols);
		
		settings.scroll.add(rcont);
		settings.resize();
		settings.scroll.updateScrollbar();
		settings.updateMenus();
	}
	
	Settings.prototype.modeHandler = function() {
		if($('mode'))
		{
			if(settings.mode_val == 0)
			{
				settings.mode_val = 1;
				$('mode').setAttribute('class', 'mode' + settings.mode_val);
			}
			else
			{
				settings.mode_val = 0;
				$('mode').setAttribute('class', 'mode' + settings.mode_val);
			}
		}
	}
	
	Settings.prototype.saveHandler = function() {
		if($('save'))
		{
			/* validations */
			var aftimeout = $('aftimeout').value * 1000;
			var afno = $('afno').value;
			var max_ls = $('max_ls').value;
			var mode = settings.mode_val + '';
			
			wsetKey(aftimeout, 'SETTINGS_AFTIMEOUT');
			Constants.AUTO_FETCH_TIMEOUT = aftimeout;
			
			wsetKey(afno, 'SETTINGS_AFNO');
			Constants.AUTO_FETCH_PHOTOCOUNT = afno;
			
			wsetKey(max_ls, 'MAX_LIST_SIZE');
			MAX_LIST_SIZE = max_ls;
			
			wsetKey(mode, 'DEFAULT_MODE');
			DEFAULT_MODE = parseInt(mode);
			if(browsr)
				browsr.mode = mode;
			
			goBack();
		}
	}
	
	Settings.prototype.cancelHandler = function() {
		if($('cancel'))
		{
			goBack();
		}
	}
	
	
	
	
	
	
	
	
	