	function Sizes() {
		/* Object for the Sizes Screen */
		this.page = [];
		this.photo = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Sizes.prototype.initialize = function() {
		browsr.screen = SCREEN_SIZES;

		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();

	}
	
	Sizes.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.photo = null;
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	Sizes.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	Sizes.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpListNav(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownListNav(this);
				else
					Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	Sizes.prototype.keyEnter = function() {
		if(this.total)
		{	
			var tsize = this.getSelectedSize();
			var lindex = this.lindex;
			var tphoto = this.photo;
			
			var params = [];
			
			params["photo"] = tphoto;
			params["size"] = tsize;
			
			var ttitle = '';
			if(this.photo.title)
				ttitle = this.photo.title;
			else
				ttitle = '(untitled)';
				
			var photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
				
			this.destroy();
			
			browsr.addEvent( ttitle+ '\'s Sizes', sphoto.showBySize, params, lindex, photo_url, 'photoframe');
			sphoto.showBySize(params);
			params = null;
		}
	}
	
	Sizes.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	Sizes.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	Sizes.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	Sizes.prototype.keyRightTab = function() {
		Helper.keyRightTabPage(this);
	}
	
	Sizes.prototype.refresh = function() {
		this.displaySizes();
	}
	
	Sizes.prototype.showInBrowser = function() {
		if(this.total)
		{
			var tsize = this.getSelectedSize();
			var url = tsize.url;
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	Sizes.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Sizes.prototype.switchToTabs = function() {
		Helper.switchToTabs(this);
		this.displaySizes();
	}
	
	Sizes.prototype.switchToList = function() {
		Helper.switchToList(this);
		this.displaySizes();
	}
	
	Sizes.prototype.showByPhoto = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
		}
		else if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
			
		sizes.photo = params["photo"];
		sizes.initialize();
		
		if(sizes.photo != null)
		{
		
			if(sizes.photo.title != '')
				Helper.setTitle('Sizes for: ' + sizes.photo.title);
			else
				Helper.setTitle('Sizes for: ' + '(untitled)');
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				sizes.lindex = params["sindex"];
				sizes.cur_page = parseInt(sizes.lindex / MAX_LIST_SIZE) + 1;
			}
			
			flickr.photos_getSizes(user.token, sizes.photo.id, sizes.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Sizes.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				sizes.total = 0;
				var cur_page = sizes.cur_page;
				
				if(rsp.sizes && rsp.sizes.size)
				{
					var tsizes = rsp.sizes;
					sizes.total = rsp.sizes.size.length;
					rsp = null;
					sizes.cur_page = 1;
					
					while(tsizes.size.length)
					{
						if(tsizes.size.length > MAX_LIST_SIZE)
						{
							sizes.page[sizes.cur_page] = tsizes.size.slice(0, MAX_LIST_SIZE);
							tsizes.size.splice(0, MAX_LIST_SIZE);
							sizes.cur_page++;
						}
						else
						{
							sizes.page[sizes.cur_page] = tsizes.size.slice(0, tsizes.size.length);
							tsizes.size.splice(0, tsizes.size.length);
							sizes.cur_page++;
						}
					}
					
					tsizes = null;
				}
				
				if(sizes.total)
				{
					sizes.pages = sizes.cur_page-1;
					sizes.cur_page = cur_page;
				}
				
				if(sizes.total)
				{
					sizes.displaySizes();
				}
				else
				{
					sizes.displayNoSize();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Sizes.prototype.displaySizes = function () {
		if(Helper.isListMode())
			this.displaySizesList();
		else
			this.displaySizesTabs();
	}
	
	Sizes.prototype.displaySizesList = function () {
		if(this.selector)
			this.selector.removeAll();
		
		var tsizes = this.page[this.cur_page];
		
		/* add to selector */
		for(var i=0; i < tsizes.length; i++)
		{
			this.selector.addElement(tsizes[i].label, sizesImage, 'icon');
			Helper.hideIconGloss(i);
		}
		
		Helper.postDisplayList(this);
	}
	
	Sizes.prototype.displaySizesTabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var tsize = this.page[this.cur_page][sindex];

		var subtitle = '';
		if(this.photo.title != '')
			subtitle = 'Sizes for: ' + this.photo.title;
		else
			subtitle = 'Sizes for: ' + '(untitled)';
		
		Helper.displayTabPage(this, this.lindex, tsize.label, subtitle, sizesImage, 'icon');
		this.auto_disp_tid = setTimeout( function() { sizes.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
			
		Helper.postDisplayTabs(this);
	}
	
	Sizes.prototype.displayNoSize = function () {
		this.selector = null;
		var div = Helper.displayNoType('No sizes found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Sizes.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	Sizes.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	Sizes.prototype.autoFetch = function() {
		if(this.cur_page && this.page[this.cur_page])
		{	
			var tsize = this.getSelectedSize();
				
			if(!(Helper.isListMode()))
				this.tabs.autoFetch();
			
			var sindex = Helper.getSindex(this);
				
			var text = '' + tsize.width + ' X ' + tsize.height;
			
			Helper.setAFText(sindex, text);
			this.resize();
			this.scroll.updateScrollbar();
		}
	}
		
	Sizes.prototype.getSelectedSize = function() {
		if(Helper.isListMode())
		{
			sindex = this.selector.selected_index;
			this.lindex = this.selectedListItem();
		}
		else
		{
			this.cur_page = parseInt(this.lindex / MAX_LIST_SIZE) + 1;
			sindex = this.lindex % MAX_LIST_SIZE;
		}
		
		if(this.total)
			return this.page[this.cur_page][sindex];
		else
			return null;
	}	
		
		
		