	function SPhoto() {
		/* Object for the SPhoto Screen - Displays the Photo :) */
		this.photo = null;
		this.size = null;
		this.note = null;
			
		this.by_default = false;
		this.by_size = false;
		this.by_note = false;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	SPhoto.prototype.initialize = function() {
		browsr.screen = SCREEN_SPHOTO;
		
		this.scroll = new Scroll(true);		
		/* adding to the parent div */
		this.scroll.addTo('content_area');
		$('scrollpanel').style.right = (window.innerWidth >= 240) ? (window.innerWidth - 240) + 'px' : '10px';
		$('scrollpanel').style.height	= (200 - 5) + 'px';
			
		$('hscrollpanel').style.bottom = (window.innerHeight >= 320) ? ((window.innerHeight - 320) + 40) + 'px' : '5px';
		$('hscrollpanel').style.width	= (240 - 5) + 'px';
		
		this.div = $('content_area');
		this.div.style.display = 'block';
		
		/* Post processing */
		Helper.hideNavbar();
		Helper.hideTabbar();
		
		/* TODO: Move somewhere else!! */
		$('content_area').style.height = ($('content_area').clientHeight + 40) + 'px';
		$('scrollpanel').style.height = ($('content_area').clientHeight - 5) + 'px';
		$('scrollpanel').style.top = ($('scrollpanel').offsetTop - 40) + 'px';
	}
	
	SPhoto.prototype.destroy = function() {
		flickr.purge_all();
		
		this.photo = null;
		this.size = null;
		this.note = null;
		
		this.by_default = false;
		this.by_size = false;
		this.by_note = false;
		
		Helper.destroy(this);
		$('content_area').style.height = ($('content_area').clientHeight - 40) + 'px';
	}
	
	SPhoto.prototype.resize = function() {
		/* TODO: Verify */
		this.scroll.scrollToTop();
		this.scroll.resize();
	}
	
	SPhoto.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				Helper.keyDownScroll(this);
				break;
			
			case KEY_ENTER:
				/* ENTER */
				break;
				
			case KEY_LEFT:
				/* LEFT */
				Helper.keyLeftScroll(this);
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				Helper.keyRightScroll(this);
				break;
		}
	}
	
	SPhoto.prototype.showInBrowser = function() {
		if((this.by_default || this.by_note) && this.photo)
		{
			var url = 'http://www.flickr.com/photos/' + this.photo.owner + '/' + this.photo.id + '/';
			openURL(url);
		}
		else if(this.by_size && this.photo && this.size)
		{
			var url = this.size.url;
			openURL(url);
		}
		else
		{
			alert('Unable to open in browser!');
		}
	}
	
	SPhoto.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(false);
			wid(MENU_SETTINGS.id).setDimmed(false);
			wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
			wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			
			if(this.photo)
			{
				if(bmarks.findPhotoInBmarks(this.photo.id))
				{
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(false);
				}
				else
				{	
					wid(MENU_ADD_TO_BMARKS.id).setDimmed(false);
					wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
				}
			}
			else
			{
				wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
				wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.show(MENU_SHOW_IN_BROWSER.id);
			toolbar.show(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			toolbar.hide(MENU_SWITCH_TO_TABS.id);
			toolbar.hide(MENU_SWITCH_TO_LIST.id);
		}
		
		/*
		else
		{
			toolbar.show(MENU_FRAME.id);
			switch(browsr && browsr.frame)
			{
				case FRAME_NONE:
					MENU_FRAME_NO.select_bydefaut = true;
				break;
				
				case FRAME_WHITE:
					MENU_FRAME_WHITE.select_bydefaut = true;
				break;
				
				case FRAME_BLACK:
					MENU_FRAME_BLACK.select_bydefaut = true;
				break;
				
				case FRAME_POLAROID:
					MENU_FRAME_POLAROID.select_bydefaut = true;
				break;
			}
		}
		*/
	}
	
	SPhoto.prototype.show = function(params) {
	
		if(params == null)
			params["photo"] = null;
		else if((params["photo"] == undefined) || (params["photo"] == null))
			params["photo"] = null;
			
		sphoto.photo = params["photo"];
		sphoto.initialize();
		
		if(sphoto.photo != null)
		{
			sphoto.by_default = true;
			tphoto = sphoto.photo;
			
			var photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_M);
			
			var div = Helper.getPhotoframe(photo_url, 200);
			
			sphoto.scroll.add(div);
			sphoto.resize();
			sphoto.scroll.updateScrollbar();
			sphoto.updateMenus();
			
			/* Need to change the place of autofetch */
			sphoto.auto_disp_tid = setTimeout( function() { sphoto.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT * 2);
		}
	}
	
	SPhoto.prototype.showBySize = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["size"] = null;
		}
		
		if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
		
		if((params["size"] == undefined) || (params["size"] == null))
		{
			params["size"] = null;
		}
			
		sphoto.photo = params["photo"];
		sphoto.size = params["size"];
		sphoto.initialize();
		
		if(sphoto.photo && sphoto.size)
		{
			sphoto.by_size = true;
			
			var photo_url = sphoto.size.source;
			
			var div = Helper.getPhotoframe(photo_url, 0);
			
			sphoto.scroll.add(div);
			sphoto.resize();
			sphoto.scroll.updateScrollbar();
			sphoto.updateMenus();
			
			/* Need to change the place of autofetch */
			sphoto.auto_disp_tid = setTimeout( function() { sphoto.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT * 2);
		}
	}
	
	SPhoto.prototype.showByNote = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["note"] = null;
		}
		
		if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
		
		if((params["note"] == undefined) || (params["note"] == null))
		{
			params["note"] = null;
		}
			
		sphoto.photo = params["photo"];
		sphoto.note = params["note"];
		sphoto.initialize();
		
		if(sphoto.photo && sphoto.note)
		{
			sphoto.by_note = true;
			tphoto = sphoto.photo;
			
			var photo_url = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_NONE);
			
			var div = Helper.getPhotoframe(photo_url, 200, [sphoto.note.y, sphoto.note.x, sphoto.note.h, sphoto.note.w]);
			
			sphoto.scroll.add(div);
			sphoto.resize();
			sphoto.scroll.updateScrollbar();
			sphoto.updateMenus();
			
			/* Need to change the place of autofetch */
			sphoto.auto_disp_tid = setTimeout( function() { sphoto.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT * 2);
		}
	}
	
	SPhoto.prototype.autoFetch = function() {
		if(this.photo)
		{
			if(this.by_default || this.by_size)
			{
				var div = Helper.getDiv(null, 'notification');
				var p1 = '';
				
				if(this.photo.title)
					p1 = Helper.getP(null, 'picture-title', this.photo.title);
				else
					p1 = Helper.getP(null, 'picture-title', '(untitled)');
					
				var p2 = Helper.getP(null, 'picture-owner', 'by ' + this.photo.ownername);
				
				var br = Helper.getBr();
				
				div.appendChild(p1);
				div.appendChild(br);
				div.appendChild(p2);
				$('content_area').appendChild(div);
			}
			else if(this.by_note && this.note)
			{
				var div = Helper.getDiv(null, 'notification');
				var p1 = Helper.getP(null, 'picture-title', this.note._content);
				var p2 = Helper.getP(null, 'picture-owner', 'by ' + this.note.authorname);
				var br = Helper.getBr();
				
				div.appendChild(p1);
				div.appendChild(br);
				div.appendChild(p2);
				$('content_area').appendChild(div);
			}
		}
	}
	
	SPhoto.prototype.addToBookmarks = function() {
		if(bmarks && this && this.photo)
		{
			var ttitle = '';
			
			if(this.photo.title != '')
				ttitle = this.photo.title;
			else
				ttitle = '(untitled)';
			
			bmarks.addPhotoToBmarks( {id:this.photo.id, title:ttitle} );
		}
	}
	
	SPhoto.prototype.removeFromBookmarks = function() {
		if(bmarks && this && this.photo)
		{
			bmarks.removePhotoFromBmarks(this.photo.id);
		}
	}
	
	SPhoto.prototype.setFrame = function(frame) {
		/* Set the border as per the frame number */
		switch(frame)
		{
			case FRAME_NONE:
				$('photoframe').className = 'noborder';
				break;
				
			case FRAME_WHITE:
				$('photoframe').className = 'frame white';
				break;
				
			case FRAME_BLACK:
				$('photoframe').className = 'frame black';
				break;
				
			case FRAME_POLAROID:
				$('photoframe').className = 'frame polaroid';
				break;
		}
		
//		Helper.placeInCenter($('photo_div'), $('photo_cont'));
		Helper.placeInCenter($('photo_cont'), $('content_area'));
	}
	
	
	
	
	
	
	