
	function cbMoveTabRight() {
		var that = cbMoveTabRight.that;
		that.moveRight();
	}
	
	function cbMoveTabLeft() {
		var that = cbMoveTabLeft.that;
		that.moveLeft();
	}

	function TabberItem(name, unselected, selected) {
		this.name       = name;
		this.unselected = unselected;
		this.selected   = selected;
	}

	function Tabber() {
		/* Define the properties */
		this.selected_index = 0;
		this.scroll = null;
		this.div_array = [];
		
		/* this is jus for optimization */
		this.count = 0;
		this.max_icons = 0;
		this.arrows = false;
		
		this.div = $('tab_pane');		
		this.parent = $('tab_bar');
		
		cbMoveTabLeft.that = this;
		cbMoveTabRight.that = this;
		
		$('tab_left').addEventListener('click', cbMoveTabRight, false);

		$('tab_right').addEventListener('click', cbMoveTabLeft, false);
	}
	
	Tabber.prototype.addTo = function(div) {
		if($(div))
		{
			$(div).appendChild(this.div);
		}
	}
	
	Tabber.prototype.add = function(div) {
		if(div)
		{
			this.div_array.push(div);
			div.sindex = this.count;
			this.count++;
		}
	}
	
	Tabber.prototype.removeAll = function() {
		Helper.destroyDescendants(this.div);
		this.div_array = [];
		this.count = 0;
		
		$('tab_left').removeEventListener('click', cbMoveTabRight, false);
		$('tab_right').removeEventListener('click', cbMoveTabLeft, false);
	}

	Tabber.prototype.select = function(index) {
		if(index < this.count)
		{
			this.deselect(this.selected_index);
			this.selected_index = index;
			$('tab_slider_' + index).style.display = 'block';
			this.updateTabber();
		}
	}
	
	Tabber.prototype.deselect = function(index) {
		if(index < this.count)
		{
			$('tab_slider_' + index).style.display = 'none';
		}
	}
	
	Tabber.prototype.resize = function() {
	}
	
	Tabber.prototype.updateTabber = function() {
		
		/* Bring the icon to visible area */
		if(this.count > this.max_icons)
		{
			var index = this.selected_index;
			var div = this.div_array[index];
			
			if(div.offsetLeft < (0 - this.div.offsetLeft))
			{
				/* Element to the left of the window */
				while(div.offsetLeft < (0 - this.div.offsetLeft))
					this.moveRight();
			}
			
			if((div.offsetLeft + this.div.offsetLeft + div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
			{
				/* Element to the right of the window */
				while((div.offsetLeft + this.div.offsetLeft + div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
					this.moveLeft();
			}
			
			/* Check the arrows */
			if((0 - this.div.offsetLeft) > 0)
				$('tab_left').style.display = 'block';
			else
				$('tab_left').style.display = 'none';
			
			if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
				$('tab_right').style.display = 'block';
			else
				$('tab_right').style.display = 'none';
		}
	}
	
	Tabber.prototype.moveRight = function() {
		this.div.style.left = this.div.offsetLeft + TAB_ICON_WIDTH;
		
		if((0 - this.div.offsetLeft) > 0)
			$('tab_left').style.display = 'block';
		else
			$('tab_left').style.display = 'none';
		
		if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
			$('tab_right').style.display = 'block';
		else
			$('tab_right').style.display = 'none';
	}
	
	Tabber.prototype.moveLeft = function() {
		this.div.style.left = this.div.offsetLeft - TAB_ICON_WIDTH;
		
		if((0 - this.div.offsetLeft) > 0)
			$('tab_left').style.display = 'block';
		else
			$('tab_left').style.display = 'none';
		
		if((this.div.offsetLeft + this.div.clientWidth) > (this.parent.clientWidth - ARROW_WIDTH))
			$('tab_right').style.display = 'block';
		else
			$('tab_right').style.display = 'none';
	}
	
	Tabber.prototype.addArray = function(tab_array) {
		if(tab_array)
		{
			var tableTab = Helper.getTable(null, null);
			var trTab = Helper.getTr(null, null);
			
			for(var i=0; i < tab_array.length; i++)
			{	
				var tdTab = Helper.getTd(null, null);
				var divTab = this.addElement(tab_array[i].name, tab_array[i].unselected, tab_array[i].selected);
				
				tdTab.appendChild(divTab);
				trTab.appendChild(tdTab);
			}
			
			tableTab.appendChild(trTab);
			this.div.appendChild(tableTab);
		
			var index = this.selected_index;
			this.max_icons = this.parent.clientWidth / TAB_ICON_WIDTH;
			
			
			this.div.style.left          = '0px';
			$('tab_left').style.display  = 'none';
			$('tab_right').style.display = 'none';
			
			this.div.style.width = (this.count * TAB_ICON_WIDTH) + 'px';
			
			if(this.count > this.max_icons)
			{
				/* Accounting for the arrows */
				this.arrows = true;
				this.div.style.left = ARROW_WIDTH + 'px';
			}
			else
			{
				this.arrows = false;
				this.div.style.left = ((this.parent.clientWidth - (this.count * TAB_ICON_WIDTH)) / 2) + 'px';
			}
		}
	}
	
	Tabber.prototype.addElement = function(name, img_unselected, img_selected) {
		var id = this.count;
		
		var divEl = Helper.getDiv('tabber_' + id, 'menu_bar_top_icon');
		var imgEl = Helper.getImg('tabber_img_' + id, null, img_unselected);
		
		var divSlider = Helper.getDiv('tab_slider_' + id, 'menu_bar_top_slider');
		var imgSlider = Helper.getImg('tab_slider_img_' + id, null, img_selected);
		
		divSlider.appendChild(imgSlider);
		divSlider.style.display = 'none';
		
		divEl.appendChild(imgEl);
		divEl.appendChild(divSlider);
		
		var that = this;
		
		imgEl.addEventListener('click', function() {
														that.select(id);
														
														if(Helper.isListMode())
															Helper.keySelectList(browsr.screens[browsr.screen], id);
														else
															Helper.keySelectTab(browsr.screens[browsr.screen], id);
													}, false);
		
		divEl.addEventListener('click', function() {
														that.select(id);
														
														if(Helper.isListMode())
															Helper.keySelectList(browsr.screens[browsr.screen], id);
														else
															Helper.keySelectTab(browsr.screens[browsr.screen], id);
													}, false);
		
		this.add(divEl);
		
		return divEl;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	