	function Tabs() {
		/* Define the properties */
		this.selected_index = 0;
		this.auto_disp_tid = 0;
		this.scroll = null;
		
		this.id = 0;
		this.title = '';
		this.subtitle = '';
		this.photo_url = '';
		this.img_type = '';
		
		this.count = 0;
		
		this.div = Helper.getDiv('tab_area', 'tab_area');
		this.div.addEventListener('click', function() {
			browsr.screens[browsr.screen].keyEnter();
		}, false);
	}
	
	Tabs.prototype.addTo = function(div) {
		if($(div))
		{
			$(div).appendChild(this.div);
		}
	}
	
	Tabs.prototype.add = function(div) {
		if(div)
		{
			this.div.appendChild(div);
			div.sindex = this.count;
			this.count++;
		}
	}	

	Tabs.prototype.removeAll = function() {
		if(browsr && browsr.screens[browsr.screen])
			clearTimeout(browsr.screens[browsr.screen].auto_disp_tid);
		
		Helper.destroyDescendants(this.div);
		this.scroll.scrollToTop();
		this.count = 0;
	}
	
	Tabs.prototype.addElement = function(id, title, subtitle, photo_url, img_type) {
	
		/* copy all the values for later use */
		this.id = id;
		this.title = title;
		this.subtitle = subtitle;
		this.photo_url = photo_url;
		this.img_type = img_type;
		
		/* Tab Icon */
		var divTIcon = Helper.getDiv('tab_icon_' + id, 'tab_icon');
		var tableTIcon = Helper.getTable(null, null);
		var trTIcon = Helper.getTr(null, null);
		var tdTIcon = Helper.getTd(null, 'icon');
		var centerIcon = Helper.getCenter();
		var divIcon = null;
		var imgIcon = null;
		
		if(img_type == 'icon')
		{
			divIcon = Helper.getDiv(null, 'icon');
			imgIcon = Helper.getImg(null, null, photo_url);
			divIcon.appendChild(imgIcon);
		}
		else if(img_type == 'photoframe')
		{
			divIcon = Helper.getDiv(null, 'photoframe');
			imgIcon = Helper.getImg(null, 'photo', photo_url);
			imgIcon.addEventListener('load', function() { 
															imgIcon.style.display = '';
															Helper.resizePhotoframe(divIcon, imgIcon, 140);
														}, false);
			imgIcon.style.display = 'none';
			divIcon.appendChild(imgIcon);
			
			/*
			divIcon = Helper.getDiv(null, 'photoframe');
			var divPframe = this.getPhotoframe(photo_url, 120, divIcon);
			divIcon.appendChild(divPframe);
			*/
		}
		else
		{
			divIcon = Helper.getDiv(null, 'contactframe');
			imgIcon = Helper.getImg(null, 'photo', photo_url);
			divIcon.appendChild(imgIcon);
		}
		
		centerIcon.appendChild(divIcon);
		tdTIcon.appendChild(centerIcon);
		trTIcon.appendChild(tdTIcon);
		tableTIcon.appendChild(trTIcon);
		divTIcon.appendChild(tableTIcon);
		
		this.add(divTIcon);
		
		/* Tab Text */
		var centerText = Helper.getCenter();
		var divTText = Helper.getDiv('tab_text_' + id, 'tab_text');
		var tableTText = Helper.getTable(null, null);
		var trTText = Helper.getTr(null, null);
		var tdTText = Helper.getTd(null, 'title');
		var divTitle = Helper.getDiv(null, 'title');
		var tableTitle = Helper.getTable(null, null);
		var trTitle = Helper.getTr(null, null);
		var tdLEdge = Helper.getTd(null, 'edge');
		var divLeft = Helper.getDiv(null, 'left');
		var tdMiddle = Helper.getTd(null, 'middle');
		var divText = Helper.getDiv(null, 'text');
		var pTitle = Helper.getP(null, null, title);
		pTitle.origText = '' + title;
		var tdREdge = Helper.getTd(null, 'edge');
		var divRight = Helper.getDiv(null, 'right');
		
		tdLEdge.appendChild(divLeft);
		divText.appendChild(pTitle);
		tdMiddle.appendChild(divText);
		tdREdge.appendChild(divRight);
		trTitle.appendChild(tdLEdge);
		trTitle.appendChild(tdMiddle);
		trTitle.appendChild(tdREdge);
		tableTitle.appendChild(trTitle);
		divTitle.appendChild(tableTitle);
		tdTText.appendChild(divTitle);
		trTText.appendChild(tdTText);
		tableTText.appendChild(trTText);
		divTText.appendChild(tableTText);
		centerText.appendChild(divTText);
		
		this.add(centerText);
		
		/* Post processing */
		Helper.checkEllipsis(pTitle, divText.clientWidth, divText.clientHeight);
	}
	
	Tabs.prototype.addAFElement = function(id, title, subtitle, photo_url, img_type) {
	
		var divTabAF = Helper.getDiv('tab_af_' + id, 'tab_af');
		var divTAFHeader = Helper.getDiv('tab_af_header_' + id, 'tab_af_header');
		var tableTAFHeader = Helper.getTable(null, null);
		
		/* First row in Helper */
		var trHUp = Helper.getTr(null, null);
		var tdHUpLEdge = Helper.getTd(null, 'edge');
		var divHUpLEdge = Helper.getDiv(null, 'up left');
		
		var tdHUpIcon = Helper.getTd(null, 'icon');
		tdHUpIcon.setAttribute('rowspan', '2');
		var divHUpIcon = Helper.getDiv(null, null);
		var divIcon = null;
		var imgIcon = null;
		
		if(img_type == 'icon')
		{
			divIcon = Helper.getDiv(null, 'icon');
			imgIcon = Helper.getImg(null, null, photo_url);
		}
		else if(img_type == 'photoframe')
		{
			divIcon = Helper.getDiv(null, 'photoframe');
			imgIcon = Helper.getImg(null, 'photo', photo_url);
		}
		else
		{
			divIcon = Helper.getDiv(null, 'contactframe');
			imgIcon = Helper.getImg(null, 'photo', photo_url);
		}
		
		var tdHUpText = Helper.getTd(null, 'text');
		var divHUpText = Helper.getDiv(null, 'up');
		var pTitle = Helper.getP(null, null, title);
		pTitle.origText = '' + title;
		
		var tdHUpREdge = Helper.getTd(null, 'edge');
		var divHUpREdge = Helper.getDiv(null, 'up right');
		
		tdHUpLEdge.appendChild(divHUpLEdge);
		
		divIcon.appendChild(imgIcon);
		divHUpIcon.appendChild(divIcon);
		tdHUpIcon.appendChild(divHUpIcon);
		
		divHUpText.appendChild(pTitle);
		tdHUpText.appendChild(divHUpText);
		
		tdHUpREdge.appendChild(divHUpREdge);
		
		trHUp.appendChild(tdHUpLEdge);
		trHUp.appendChild(tdHUpIcon);
		trHUp.appendChild(tdHUpText);
		trHUp.appendChild(tdHUpREdge);
		
		
		/* Second row in Helper */
		var trHDown = Helper.getTr(null, null);
		var tdHDownLEdge = Helper.getTd(null, 'edge');
		var divHDownLEdge = Helper.getDiv(null, 'down left');
		
		var tdHDownText = Helper.getTd(null, 'text');
		var divHDownText = Helper.getDiv(null, 'down');
		var pSubtitle = Helper.getP(null, null, subtitle);
		pSubtitle.origText = '' + subtitle;
		
		var tdHDownREdge = Helper.getTd(null, 'edge');
		var divHDownREdge = Helper.getDiv(null, 'down right');
		
		tdHDownLEdge.appendChild(divHDownLEdge);
		
		divHDownText.appendChild(pSubtitle);
		tdHDownText.appendChild(divHDownText);
		
		tdHDownREdge.appendChild(divHDownREdge);
		
		trHDown.appendChild(tdHDownLEdge);
		trHDown.appendChild(tdHDownText);
		trHDown.appendChild(tdHDownREdge);
		
		
		tableTAFHeader.appendChild(trHUp);
		tableTAFHeader.appendChild(trHDown);
		
		divTAFHeader.appendChild(tableTAFHeader);
		divTabAF.appendChild(divTAFHeader);
		
		/* AF Content */
		var divAF = Helper.getAFContainer(id);
		divAF.style.display = 'block';
		
		divTabAF.appendChild(divAF);
		
		this.add(divTabAF);
		
		/* Post processing */
		Helper.checkEllipsis(pTitle, divHUpText.clientWidth, 20);
		Helper.checkEllipsis(pSubtitle, divHDownText.clientWidth, 20);
	}
	
	Tabs.prototype.autoFetch = function() {
		this.removeAll();
		this.addAFElement(this.id, this.title, this.subtitle, this.photo_url, this.img_type);
	}
	
	Tabs.prototype.getPhotoframe = function(photo_url, size, div_cont) {
			var div = Helper.getDiv('photo_cont', null);
			var center = Helper.getCenter();
			
			var divPframe;
			switch(browsr.frame)
			{
				case FRAME_NONE:
					divPframe = Helper.getDiv('photoframe', 'noborder');
					break;
					
				case FRAME_WHITE:
					divPframe = Helper.getDiv('photoframe', 'frame white');
					break;
					
				case FRAME_BLACK:
					divPframe = Helper.getDiv('photoframe', 'frame black');
					break;
					
				case FRAME_POLAROID:
					divPframe = Helper.getDiv('photoframe', 'frame polaroid');
					break;
			}
			
			divPframe.style.maxHeight = '140px';
			
			var tablePframe = Helper.getTable(null, null);
			
			var trUp  = Helper.getTr(null, null);
			var tdUL  = Helper.getTd(null, 'edge');
			var divUL = Helper.getDiv(null, 'up left');
			var tdUM  = Helper.getTd(null, 'middle');
			var divUM = Helper.getDiv(null, 'up');
			var tdUR  = Helper.getTd(null, 'edge');
			var divUR = Helper.getDiv(null, 'up right');
			
			var trMiddle = Helper.getTr (null, null);
			var tdML     = Helper.getTd (null, 'middle left');
			var divML    = Helper.getDiv(null, null);
			var tdMM     = Helper.getTd (null, 'middle');
			var divMM    = Helper.getDiv('photo_div', 'center');
			var img      = Helper.getImg('photo', null, photo_url);
			var tdMR     = Helper.getTd (null, 'middle right');
			var divMR    = Helper.getDiv(null, null);
			
			var trDown = Helper.getTr (null, null);
			var tdDL   = Helper.getTd (null, 'edge');
			var divDL  = Helper.getDiv(null, 'down left');
			var tdDM   = Helper.getTd (null, 'middle');
			var divDM  = Helper.getDiv(null, 'down');
			var tdDR   = Helper.getTd (null, 'edge');
			var divDR  = Helper.getDiv(null, 'down right');
			
			img.addEventListener('load', function() {
														//	return false;
														divPframe.style.display = 'block';
														var h = img.clientHeight;
														var w = img.clientWidth;
														
														air.trace(img.clientHeight + ' ' + img.clientWidth + ' ');
														air.trace(divMM.clientHeight + ' ' + divMM.clientWidth + ' ');
														air.trace(divPframe.clientHeight + ' ' + divPframe.clientWidth + ' ');
														air.trace(div.clientHeight + ' ' + div.clientWidth + ' ');
														air.trace(div_cont.clientHeight + ' ' + div_cont.clientWidth + ' ');
														
														if(size)
														{
															var h = img.height;
															var w = img.width;
															var origSize = (h > w) ? h : w;
																
															img.style.height = (h * size / origSize) + 'px';
															img.style.width = (w * size / origSize) + 'px';
															img.style.display = '';
																
															divMM.style.width = img.width + 'px';
															divMM.style.height = img.height + 'px';
														}
														
														air.trace('after resize');
														air.trace(img.clientHeight + ' ' + img.clientWidth + ' ');
														air.trace(divMM.clientHeight + ' ' + divMM.clientWidth + ' ');
														air.trace(divPframe.clientHeight + ' ' + divPframe.clientWidth + ' ');
														air.trace(div.clientHeight + ' ' + div.clientWidth + ' ');
														air.trace(div_cont.clientHeight + ' ' + div_cont.clientWidth + ' ');
														
														if(size || (h < 200))
														{
															//Helper.placeInCenter(divPframe, div);
															//Helper.placeInCenter(div, div_cont);
														}
														
														air.trace('after centering');
														air.trace(img.clientHeight + ' ' + img.clientWidth + ' ');
														air.trace(divMM.clientHeight + ' ' + divMM.clientWidth + ' ');
														air.trace(divPframe.clientHeight + ' ' + divPframe.clientWidth + ' ');
														air.trace(div.clientHeight + ' ' + div.clientWidth + ' ');
														air.trace(div_cont.clientHeight + ' ' + div_cont.clientWidth + ' ');
													}, false);
			
			tdUL.appendChild(divUL);
			tdUM.appendChild(divUM);
			tdUR.appendChild(divUR);
			trUp.appendChild(tdUL);
			trUp.appendChild(tdUM);
			trUp.appendChild(tdUR);
			
			divMM.appendChild(img);
			tdML.appendChild(divML);
			tdMM.appendChild(divMM);
			tdMR.appendChild(divMR);
			trMiddle.appendChild(tdML);
			trMiddle.appendChild(tdMM);
			trMiddle.appendChild(tdMR);
			
			tdDL.appendChild(divDL);
			tdDM.appendChild(divDM);
			tdDR.appendChild(divDR);
			trDown.appendChild(tdDL);
			trDown.appendChild(tdDM);
			trDown.appendChild(tdDR);
			
			tablePframe.appendChild(trUp);
			tablePframe.appendChild(trMiddle);
			tablePframe.appendChild(trDown);
			
			divPframe.appendChild(tablePframe);
			divPframe.style.display = '';
			
			center.appendChild(divPframe);
			div.appendChild(center);
			div.photoDiv = divMM;
			div.photo = img;
			
			return div;
		}
	
	
	
	
	