	function Tags() {
		/* Object for the Tags Screen */
		this.page = [];
		this.user = null;
		this.photo = null;
		this.user_id = '';
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	Tags.prototype.initialize = function() {
		browsr.screen = SCREEN_TAGS;

		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();
	}
	
	Tags.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.user = null;
		this.photo = null;
		this.user_id = '';
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	Tags.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	Tags.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpListNav(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownListNav(this);
				else
					Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	Tags.prototype.keyEnter = function() {
		if(this.total)
		{
			var ttag = this.getSelectedTag();
			var lindex = this.lindex;
			var params = [];
			
			
			if(this.user_id)
				params["user_id"] = this.user_id;
			else if(this.user)
				params["user_id"] = this.user.user_nsid;
				
			params["tag"] = ttag;
			
			this.destroy();
			
			browsr.addEvent(ttag._content + '\'s Photostream', photostream.showByTag, params, lindex, tagImage, 'icon');
			photostream.showByTag(params);
			params = null;
		}
	}
	
	Tags.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	Tags.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	Tags.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	Tags.prototype.keyRightTab = function() {
		Helper.keyRightTabPage(this);
	}
	
	Tags.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(false);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(false);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.show(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.show(MENU_CLEAR_HISTORY.id);
			toolbar.show(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	Tags.prototype.switchToTabs = function() {
		Helper.switchToTabsPage(this);
		this.displayTags();
	}
	
	Tags.prototype.switchToList = function() {
		Helper.switchToListPage(this);
		this.displayTags();
	}
	
	Tags.prototype.refresh = function() {
		this.displayTags();
	}
	
	Tags.prototype.showByUser = function(params) {
	
		if(params == null)
		{
			params["user"] = user;
		}
		else if((params["user"] == undefined) || (params["user"] == null))
		{
			params["user"] = user;
		}
			
		tags.user = params["user"];
		tags.initialize();
		
		if(tags.user != null)
		{
			Helper.setTitle(tags.user.username + '\'s tags');
			
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				tags.lindex = params["sindex"];
				tags.cur_page = parseInt(tags.lindex / MAX_LIST_SIZE) + 1;
			}
			
			flickr.tags_getListUser(user.token, tags.user.user_nsid, tags.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Tags.prototype.showByPhoto = function(params) {
	
		if(params == null)
		{
			params["photo"] = null;
			params["user_id"] = null;
		}
		else if((params["photo"] == undefined) || (params["photo"] == null))
		{
			params["photo"] = null;
		}
		
		if((params["user_id"] == undefined) || (params["user_id"] == null))
		{
			params["user_id"] = null;
		}
			
		tags.photo = params["photo"];
		tags.user_id = params["user_id"];
		tags.initialize();
		
		if(tags.photo != null)
		{
			if(tags.photo.title != '')
				Helper.setTitle(tags.photo.title + '\'s tags');
			else
				Helper.setTitle('(untitled)' + '\'s tags');
				
			if((params["sindex"] != undefined) || (params["sindex"] != null))
			{
				tags.lindex = params["sindex"];
				tags.cur_page = parseInt(tags.lindex / MAX_LIST_SIZE) + 1;
			}
				
			flickr.tags_getListPhoto(user.token, tags.photo.id, tags.handleFlickrResponse, PRI_HIGH);
		}
	}
	
	Tags.prototype.handleFlickrResponse = function(rsp) {
		/* this refers to the window here */
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				var ttags;
				
				if(rsp.who)
					ttags = rsp.who.tags;
				else
					ttags = rsp.photo.tags;
					
				tags.total = ttags.tag.length;
				rsp = null;
				
				var cur_page = tags.cur_page;
				tags.cur_page = 1;
				
				while(ttags.tag.length)
				{
					if(ttags.tag.length > MAX_LIST_SIZE)
					{
						tags.page[tags.cur_page] = ttags.tag.slice(0, MAX_LIST_SIZE);
						ttags.tag.splice(0, MAX_LIST_SIZE);
						tags.cur_page++;
					}
					else
					{
						tags.page[tags.cur_page] = ttags.tag.slice(0, ttags.tag.length);
						ttags.tag.splice(0, ttags.tag.length);
						tags.cur_page++;
					}
				}
				
				ttags = null;
				
				if(tags.total)
				{
					tags.pages = tags.cur_page-1;
					tags.cur_page = cur_page;
				}
				
				if(tags.total)
				{
					tags.displayTags();
				}
				else
				{
					tags.displayNoTag();
				}
			}
			else
			{
				/* error */
				alert('failure : ' + rsp.message);
			}
		}
	}
	
	Tags.prototype.displayTags = function () {
		if(Helper.isListMode())
			this.displayTagsList();
		else
			this.displayTagsTabs();
	}
	
	Tags.prototype.displayTagsList = function () {
		if(this.selector)
			this.selector.removeAll();
			
		var ttags = this.page[this.cur_page];
			
		/* add to selector */
		for(var i=0; i < ttags.length; i++)
		{
			var ttag = ttags[i];
			
			this.selector.addElement(ttag._content, tagImage, 'icon');
		}
		
		Helper.postDisplayList(this);
	}
	
	Tags.prototype.displayTagsTabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var ttag = this.page[this.cur_page][sindex];
		
		var ttitle = null;
		
		if(this.user)
			ttitle = this.user.username + '\'s Tags';
		else
		{
			if(this.photo.title)
				ttitle = this.photo.title;
			else
				ttitle = '(untitled)';
		}
		
		Helper.displayTabPage(this, this.lindex, ttag._content, ttitle, tagImage, 'icon');
		this.auto_disp_tid = setTimeout( function() { tags.autoFetch() }, Constants.AUTO_FETCH_TIMEOUT);
		
		Helper.postDisplayTabs(this);
	}
	
	Tags.prototype.displayNoTag = function () {
		this.selector = null;
		var div = Helper.displayNoType('No tags found!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	Tags.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	Tags.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	Tags.prototype.autoFetch = function() {
		if(this.cur_page && this.page[this.cur_page])
		{	
			var ttag = this.getSelectedTag();
			
			if(!(Helper.isListMode()))
				this.tabs.autoFetch();
			
			/* photostream */
			var params = [];
			
			params["method"] = "flickr.photos.search";
			
			if(this.user)
				params["user_id"] = this.user.user_nsid;
			else if(this.photo)
				params["user_id"] = this.photo.owner;
			else
				params["user_id"] = user.user_nsid;
				
			params["tags"] = '' + ttag._content;
			params["auth_token"] = user.token;
			params["per_page"] = Constants.AUTO_FETCH_PHOTOCOUNT;

			flickr.photos_search(params, this.hrPhotos, PRI_HIGH);
		}
	}
	
	Tags.prototype.hrPhotos = function(rsp) {
		if(rsp != null)
		{
			if(rsp.stat == 'ok')
			{
				var tphotostream = rsp.photos.photo;
				rsp = null;
				
				if(tags)
				{
					var sindex = 0;
					if(Helper.isListMode())
						sindex = tags.selector.selected_index;
					else
						sindex = tags.lindex;
					
					Helper.destroyDescendants($('autof_elt_' + sindex));
					var photo_url = [];
					for(var i=0; i < tphotostream.length; i++)
					{
						var tphoto = tphotostream[i];
						photo_url[i] = flickr.build_photo_url(tphoto.farm, tphoto.server, tphoto.id, tphoto.secret, PHOTO_S);
					}
					
					Helper.setAFPhotoList(sindex, photo_url, 'large');
					tags.resize();
					tags.scroll.updateScrollbar();
				}
			}
			else
			{
				/* error */
			}
		}
	}
	
	Tags.prototype.getSelectedTag = function() {
		if(Helper.isListMode())
		{
			sindex = this.selector.selected_index;
			this.lindex = this.selectedListItem();
		}
		else
		{
			this.cur_page = parseInt(this.lindex / MAX_LIST_SIZE) + 1;
			sindex = this.lindex % MAX_LIST_SIZE;
		}
	
		if(this.total)
			return this.page[this.cur_page][sindex];
		else
			return null;
	}
	
	
	
	