	function WhereAmI() {
		/* Object for the WhereAmI Screen */
		this.page = [];
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		this.div = null;
		this.scroll = null;
		this.selector = null;
		this.tabs = null;
		this.auto_disp_tid = 0;
	}
		
	WhereAmI.prototype.initialize = function() {
		browsr.screen = SCREEN_WHERE_AM_I;
		
		Helper.initialize(this);
		Helper.showNavbar();
		Helper.hideTabbar();
	}
	
	WhereAmI.prototype.destroy = function() {
		flickr.purge_all();
		
		this.page = [];
		this.total = 0;
		this.pages = 0;
		this.cur_page = 1;
		this.lindex = 0;
		
		Helper.destroy(this);
	}
	
	WhereAmI.prototype.resize = function() {
		this.scroll.resize();
		
		if(Helper.isListMode() && this.selector)
			this.selector.resize();
	}
	
	WhereAmI.prototype.handleKeypress = function(key) {
		switch(key)
		{
			case KEY_UP:
				/* UP */
				if(Helper.isListMode())
					Helper.keyUpListNav(this);
				else
					Helper.keyUpScroll(this);
				break;
				
			case KEY_DOWN:
				/* DOWN */
				if(Helper.isListMode())
					Helper.keyDownListNav(this);
				else
					Helper.keyDownScroll(this);
				break;
				
			case KEY_ENTER:
				/* ENTER */
				this.keyEnter();
				break;
				
			case KEY_LEFT:
				/* LEFT */
				if(Helper.isListMode())
					this.keyLeftList();
				else
					this.keyLeftTab();
				break;
				
			case KEY_RIGHT:
				/* RIGHT */
				if(Helper.isListMode())
					this.keyRightList();
				else
					this.keyRightTab();
				break;
		}
	}
	
	WhereAmI.prototype.keyEnter = function() {
		if(this.total)
		{	
			var lindex = this.selectedListItem();
			
			if(browsr.history.length > (lindex + 2))
				browsr.history.splice((lindex + 2), (browsr.history.length - lindex - 1));
			
			this.destroy();
			goBack();
		}
	}
	
	WhereAmI.prototype.keyLeftList = function() {
		Helper.keyLeftList(this);
	}
	
	WhereAmI.prototype.keyRightList = function() {
		Helper.keyRightList(this);
	}
	
	WhereAmI.prototype.keyLeftTab = function() {
		Helper.keyLeftTabPage(this);
	}
	
	WhereAmI.prototype.keyRightTab = function() {
		Helper.keyRightTabPage(this);
	}
	
	WhereAmI.prototype.refresh = function() {
		this.displayWhereAmI();
	}
	
	WhereAmI.prototype.updateMenus = function() {
		if(isNokia)
		{
			wid(MENU_WHERE_AM_I.id).setDimmed(true);
			wid(MENU_GOT_LOST.id).setDimmed(false);
			wid(MENU_CLEAR_HISTORY.id).setDimmed(true);
			wid(MENU_REFRESH.id).setDimmed(false);
			wid(MENU_ADD_TO_BMARKS.id).setDimmed(true);
			wid(MENU_REMOVE_FROM_BMARKS.id).setDimmed(true);
			wid(MENU_SHOW_IN_BROWSER.id).setDimmed(true);
			wid(MENU_SETTINGS.id).setDimmed(false);
			
			if(Helper.isListMode())
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(false);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(true);
			}
			else
			{
				wid(MENU_SWITCH_TO_TABS.id).setDimmed(true);
				wid(MENU_SWITCH_TO_LIST.id).setDimmed(false);
			}
		}
		else
		{
			toolbar.hide(MENU_WHERE_AM_I.id);
			toolbar.show(MENU_GOT_LOST.id);
			toolbar.hide(MENU_CLEAR_HISTORY.id);
			toolbar.hide(MENU_REFRESH.id);
			toolbar.hide(MENU_SHOW_IN_BROWSER.id);
			toolbar.hide(MENU_FRAME.id);
			toolbar.show(MENU_BACKGROUND.id);
			toolbar.show(MENU_SETTINGS.id);
			
			if(Helper.isListMode())
			{
				toolbar.show(MENU_SWITCH_TO_TABS.id);
				toolbar.hide(MENU_SWITCH_TO_LIST.id);
			}
			else
			{
				toolbar.hide(MENU_SWITCH_TO_TABS.id);
				toolbar.show(MENU_SWITCH_TO_LIST.id);
			}
		}
	}
	
	WhereAmI.prototype.switchToTabs = function() {
		Helper.switchToTabsPage(this);
		this.displayWhereAmI();
	}
	
	WhereAmI.prototype.switchToList = function() {
		Helper.switchToListPage(this);
		this.displayWhereAmI();
	}
	
	WhereAmI.prototype.show = function(params) {
		whereami.initialize();
		Helper.setTitle('Where Am I?');
		
		if(browsr)
		{
			whereami.total = 0;
				
			var thistory = browsr.history.slice(0, browsr.history.length);
			
			if(thistory && thistory.length)
				thistory.pop();

			if(thistory && thistory.length)
			{
				whereami.total = thistory.length;
				whereami.cur_page = 1;
				
				while(thistory.length)
				{
					if(thistory.length > MAX_LIST_SIZE)
					{
						whereami.page[whereami.cur_page] = thistory.slice(0, MAX_LIST_SIZE);
						thistory.splice(0, MAX_LIST_SIZE);
						whereami.cur_page++;
					}
					else
					{
						whereami.page[whereami.cur_page] = thistory.slice(0, thistory.length);
						thistory.splice(0, thistory.length);
						whereami.cur_page++;
					}
				}
				
				thistory = null;
			}
			
			if(whereami.total)
			{
				whereami.pages = whereami.cur_page-1;
				whereami.cur_page = whereami.pages;
			}
			
			if(whereami.total)
			{
				whereami.lindex = whereami.total - 1;
				whereami.displayWhereAmI();
			}
			else
			{
				whereami.displayNoWhereAmI();
			}
		}
	}
	
	WhereAmI.prototype.displayWhereAmI = function () {
		if(Helper.isListMode())
			this.displayWhereAmIList();
		else
			this.displayWhereAmITabs();
	}
	
	WhereAmI.prototype.displayWhereAmIList = function () {
		if(this.selector)
			this.selector.removeAll();
		
		var twhereami = this.page[this.cur_page];
		
		/* add to selector */
		for(var i=0; i < twhereami.length; i++)
		{
			this.selector.addElement(twhereami[i].name, twhereami[i].image, twhereami[i].img_type);
		}
		
		Helper.postDisplayList(this);
	}
	
	WhereAmI.prototype.displayWhereAmITabs = function () {
		if(this.tabs)
			this.tabs.removeAll();
			
		var sindex = this.lindex % MAX_LIST_SIZE;
		
		var twhereami = this.page[this.cur_page][sindex];
		
		Helper.displayTabPage(this, this.lindex, twhereami.name, 'Where Am I?', twhereami.image, twhereami.img_type);
			
		Helper.postDisplayTabs(this);
	}
	
	WhereAmI.prototype.displayNoWhereAmI = function () {
		/* Ideally shudnt happen!!! */
		this.selector = null;
		var div = Helper.displayNoType('History is empty!');
		this.scroll.add(div);
		this.updateMenus();
	}
	
	WhereAmI.prototype.selectedListItem = function() {
		return Helper.selectedListItem(this);
	}
	
	WhereAmI.prototype.updateNavigator = function() {
		Helper.updateNavigator(this);
	}
	
	WhereAmI.prototype.autoFetch = function() {
	}